<?php

include_once '../../../../include/opage.php';

// get parameters
if ( !isset( $sSystemModul ) || $sSystemModul === null )
{
    $sSystemModul = $oApp->GetParameter( 'systemmodul' );
}
if ( !isset( $sSystemPage ) || $sSystemPage === null )
{
    $sSystemPage = $oApp->GetParameter( 'systempage' );
}
if ( !isset( $sSystemPath ) || $sSystemPath === null )
{
    $sSystemPath = $oApp->GetParameter( 'systempath' );
}

// die if parameters missing (or set default parameters)
if ( $sSystemModul === null )
{
    die( 'parameter modul' );
}
if ( $sSystemPage === null )
{
    die( 'parameter page' );
}
if ( $sSystemPath === null )
{
    die( 'parameter path' );
}

// get subtitle for page
$sSubTitle = $oApp->GetParameter( 'subtitle' );
$sId = $oApp->GetParameter( 'id' );

// create page
$oWebpage = $oFactory->Webpage( $sSystemPage, 'CWebpageNormal' );
$oWebpage->SetTemplate( 'admin/custom/pages/detail/detail.tpl' );
$oWebpage->Init();
$oWebpage->AddTitle( $sSubTitle );
$oWebpage->RightCheck( substr( $sSystemPage, 2 ), 'read', $oApp->GetRoot() . 'admin/custom/pages/home/home.php' );

// create modul
$oModul = $oFactory->Modul( $sSystemModul );
$oModul->ClearFilters();
$oModul->SetView( '' );
$oModul->SetFilter( 'id', $sId );

// create admin
$oAdmin = $oFactory->Control( 'CAdmin' );

// Hook for plugins
$oPlugins->AdminDetail( $oWebpage, $oModul, $oAdmin );

// Begin page
$oWebpage->Begin();

$oWebpage->Assign( 'subtitle', $sSubTitle );
$oWebpage->Assign( 'id', $sId );

// configure admin control
$oAdmin->SetTemplateParameter( $oWebpage->GetTemplateParameter() );
$oAdmin->SetModul( $oModul );

// set counter
if ( isset( $oCounter ) )
{
    $oCounter->SetType( $oModul->GetName() );
    $oAdmin->SetCounter( $oCounter );
}

// insert fields into admin
$oModul->Admin( $oAdmin );

// run admin
$oAdmin->Action();

// output admin
$oWebpage->Assign( 'content', $oAdmin->Output( $sRoot . $sSystemPath . 'detail.tpl' ) );

// finish page
$oWebpage->End();
