<?php

include_once '../../../../include/opage.php';

/** parameters
m           modul
i           id
f           fieldname (default: filename)
r           row
t           filemode, download or open, default download
*/

$oWebpage = $oFactory->Webpage( 'a_download', 'CWebpageBasis' );
$oWebpage->Init();
$oWebpage->UserCheck( $oApp->PathLink( 'admin/index.php' ) . '?filename=' . urlencode( $oApp->GetBackUrl() ) );
$oWebpage->Begin();

$sModul = $oApp->GetParameter( 'm' );
$sId = $oApp->GetParameter( 'i' );
$sFieldname = $oApp->GetParameter( 'f', 'filename' );
$sRow = $oApp->GetParameter( 'r' );
$sFilemode = $oApp->GetParameter( 't' );

// fieldname may be 'fieldname{row}_file'
if ( substr( $sFieldname, -5 ) == '_file' )
    $sFieldname = substr( $sFieldname, 0, -5 );
if ( is_numeric( substr( $sFieldname, -1 ) ) )
    $sRow = '';
while( is_numeric( substr( $sFieldname, -1 ) ) )
{
    $sRow .= substr( $sFieldname, -1 );
    $sFieldname = substr( $sFieldname, 0, -1 );
}

$oModul = $oFactory->Modul( $sModul );
$oModul->SetFilter( 'id', $sId );
$oModul->QueryData();

$sFilename = '';
if ( $oModul->IsData() )
{
    if ( $oModul->IsField( $sFieldname . $sRow . '_file' ) )
    {
        $sFilename = $oModul->Get( $sFieldname . $sRow . '_file' );
        $sPath = $oModul->GetFieldPath( $sFieldname . $sRow . '_file' );
    }
    else
    {
        $sFilename = $oModul->Get( $sFieldname . $sRow );
        $sPath = $oModul->GetFieldPath( $sFieldname . $sRow );
    }

    // 2010.03.31 DOH    Create path to file: file is either below static -> prepend with $sRoot, or is already an absolute path
    if ( substr( $sPath, 0, strlen( 'static/' ) ) == 'static/' )
    {
        $sPath = $sRoot . $sPath;
    }

    // Filename for user
    if ( $oModul->IsField( $sFieldname . $sRow . '_file' ) )
    {
        $sName = $oModul->Get( $sFieldname . $sRow . '_name' );
    }
    else
    {
        $sName = $oModul->Get( $sFieldname . $sRow );
    }
}

// Check, if we got a filename
if ( $sFilename === null || $sFilename === '' )
{
    exit( "<h1>Es wurde kein Dateiname angegeben.</h1>" );
}

// Download or open the file
if ( !FileDownload( $sPath . $sFilename, $sName, $sFilemode ) )
{
    exit( "<h1>Die Datei ist nicht vorhanden.</h1>" );
}
