<?php

include_once '../../../../include/opage.php';
include_once $sRoot . 'include/control/form.php';
include_once $sRoot . 'include/dir.php';

$oWebpage = $oFactory->Webpage( 'a_editor', 'CWebpageX' );
$oWebpage->Init();
$oWebpage->RightCheck( 'editor', 'read', $oApp->PathLink( 'admin/custom/pages/home/home.php' ) );
$oWebpage->Begin();
$aParameter = $oWebpage->GetTemplateParameter();

$oForm = $oFactory->Control( 'CForm', 'htmleditor' );
$oForm->AddField( 'filelist', 'SELECT' );
$oForm->AddField( 'filename', 'TEXT' );
$oForm->AddField( 'editor_header', 'TEXT' );
$oForm->AddField( 'editor_footer', 'TEXT' );
$oForm->AddField( 'editor', 'TEXTBOX' );
$oForm->SetTemplateParameter( $aParameter );

// Eigenes Template laden
$oTemplate = $oFactory->Template( 'editor.tpl' );
$oTemplate->SetVars( $aParameter );

if ( $oForm->IsSubmitted( 'action_save' ) )
{
    // Dateiname holen
    $sFilename = $oForm->GetValue( 'filename' );

    // Check filename
    if ( !IsNull( $sFilename ) )
    {
        // Content holen
        $sContent = $oForm->GetValue( 'editor_header' );
        $sContent .= $oForm->GetValue( 'editor' );
        $sContent .= $oForm->GetValue( 'editor_footer' );

        // Replace absolute path to relative path
        $sContent = HtmlUrlRelative( $sContent, '', $oApp->GetRoot() . dirname( $sFilename ) . '/' );

        // Dateiname ins Template eintragen fr Fehlermeldungen
        $oTemplate->assign( 'filename', $sFilename );

        // Inhalt speichern
		if ( !FileWrite( $oApp->PathLink( $sFilename ), $sContent ) )
		    $oTemplate->parse( 'main.htmleditor.editor_write_error' );
   	    else
   	    {
		    $oTemplate->parse( 'main.htmleditor.editor_write_ok' );

   	        // set rights
   	        @chmod( $oApp->PathLink( $sFilename ), 0666 );
		}
        $oTemplate->parse( 'main.htmleditor.save' );
    }
}
else
{
    // Dateinamen ermitteln und als Hidden Value speichern
    $sFilename = $oForm->GetValue( 'filelist' );
    $oForm->SetValue( 'filename', $sFilename );

    // Datei ffnen
    if ( IsNull( $sFilename ) )
        $oForm->SetValue( 'editor', '' );
    else
    {
        // Dateiname fr Fehlermeldungen ins Template eintragen
        $oTemplate->assign( 'filename', $sFilename );

	    $oForm->SetValue( 'editor_header', '' );
	    $oForm->SetValue( 'editor_footer', '' );
	    $oForm->SetValue( 'editor', '' );

        if ( !FileRead( $oApp->PathLink( $sFilename ), $sContent ) )
		    $oTemplate->parse( 'main.htmleditor.editor_read_error' );
   	    else
   	    {
		    $oTemplate->parse( 'main.htmleditor.editor_read_ok' );

            // Replace relative path to absolute path
            $sContent = HtmlUrlAbsolute( $sContent, '', $oApp->GetRoot() . dirname( $sFilename ) . '/' );

            // Html Content in den Editor speichern
            // if ( eregi( '(<body[^>]*>).*$', $sContent ) )
            if ( preg_match( '((<body[^>]*>).*$)i', $sContent ) )
            {
		        // $oForm->SetValue( 'editor_header', eregi_replace( '(<body[^>]*>).*$', '\\1', $sContent ) );
		        $oForm->SetValue( 'editor_header', preg_replace( '((<body[^>]*>).*$)i', '$1', $sContent ) );
            }
            // if ( eregi( '^.*(</body>)', $sContent ) )
            if ( preg_match( '(^.*(</body>))i', $sContent ) )
            {
    		    // $oForm->SetValue( 'editor_footer', eregi_replace( '^.*(</body>)', '\\1', $sContent ) );
    		    $oForm->SetValue( 'editor_footer', preg_replace( '(^.*(</body>))i', '$1', $sContent ) );
            }
		    // $oForm->SetValue( 'editor', eregi_replace( '</body>.*$', '', eregi_replace( '^.*<body[^>]*>', '', $sContent ) ) );
		    $oForm->SetValue( 'editor', preg_replace( '(</body>.*$)i', '', preg_replace( '(^.*<body[^>]*>)i', '', $sContent ) ) );

            // create base url
            $sUrl = $oApp->GetProtocol() . $oApp->GetServerName() . $oApp->GetRoot() . $sFilename;
            $oForm->SetFieldParameter( 'editor', 'url', $sUrl );
//            $sStylesheet = $oApp->GetProtocol() . $oApp->GetServerName() . $oApp->GetRoot() . 'custom/default.css';
//            $oForm->SetFieldParameter( 'editor', 'stylesheet', $sStylesheet );

            $oTemplate->parse( 'main.htmleditor.save' );
		}
    }
}
$oTemplate->parse( 'main.htmleditor.open' );

// Alle HTML Dateinamen ermitteln
$sInclude = '(htm|html)$';
$sExclude = $oParameter->Get( 'admin_editor_exclude' );
if ( $sExclude != '' )
    $sExclude .= '|';
$sExclude .= '(_vti_)|(^admin)|(^include)|(^privat)|(^_privat)|(^webmail)|(^postinfo.html)|(^images)|(^cache)|(^custom)|(^ebay)|(^htdig)';

$oDir = new CDir();
$oDir->Read( $oApp->PathLink( '' ), $sInclude, true, true, false, '', $sExclude );
$aFiles = $oDir->FullNames();

// Option Array erstellen: Key = Value, Value = Text
if ( is_array( $aFiles ) && count( $aFiles ) > 0 )
{
    reset( $aFiles );
    sort( $aFiles );
    foreach( $aFiles as $sKey => $sOption )
        $aOptions[ $sOption ] = $sOption;

    // Options setzen
    $oForm->SetOptions( 'filelist', $aOptions );
}

// Formular ausgeben
$oForm->OutputTpl( $oTemplate );
$oWebpage->Assign( 'onload', $oForm->GetOnLoad() );

$oTemplate->Parse();
$oWebpage->Assign( 'content', $oTemplate->Text() );

$oWebpage->End();
