<?php

include_once '../../../../include/opage.php';
include_once $sRoot . 'include/control/form.php';
include_once $sRoot . 'include/dir.php';

$oWebpage = $oFactory->Webpage( 'a_editor', 'CWebpageX' );
$oWebpage->Init();
$oWebpage->RightCheck( 'editor', 'read', $oApp->PathLink( 'admin/custom/pages/home/home.php' ) );
$oWebpage->Begin();
$aParameter = $oWebpage->GetTemplateParameter();

$oForm = new CForm( 'templateeditor' );
$oForm->AddField( 'filelist', 'SELECT' );
$oForm->AddField( 'filename', 'TEXT' );
$oForm->AddField( 'editor_header', 'TEXT' );
$oForm->AddField( 'editor_footer', 'TEXT' );
$oForm->AddField( 'editor', 'TEXTBOX' );
$oForm->SetTemplateParameter( $aParameter );

// Eigenes Template laden
$oTemplate = new CTemplate( 'template.tpl' );
$oTemplate->SetVars( $aParameter );

if ( $oForm->IsSubmitted( 'action_save' ) )
{
    // Dateiname holen
    $sFilename = $oForm->GetValue( 'filename' );

    // Check filename
    if ( !IsNull( $sFilename ) )
    {
        // Content holen
        $sContent = $oForm->GetValue( 'editor_header' );
        $sContent .= $oForm->GetValue( 'editor' );
        $sContent .= $oForm->GetValue( 'editor_footer' );

        // Dateiname ins Template eintragen fr Fehlermeldungen
        $oTemplate->assign( 'filename', $sFilename );

        // Inhalt speichern
		if ( !FileWrite( $oApp->PathLink( $sFilename ), $sContent ) )
		    $oTemplate->parse( 'main.templateeditor.editor_write_error' );
   	    else
   	    {
		    $oTemplate->parse( 'main.templateeditor.editor_write_ok' );

   	        // set rights
   	        @chmod( $oApp->PathLink( $sFilename ), 0666 );
		}
        $oTemplate->parse( 'main.templateeditor.save' );
    }
}
else
{
    // Dateinamen ermitteln und als Hidden Value speichern
    $sFilename = $oForm->GetValue( 'filelist' );
    $oForm->SetValue( 'filename', $sFilename );

    // Datei ffnen
    if ( IsNull( $sFilename ) )
        $oForm->SetValue( 'editor', '' );
    else
    {
        // Dateiname fr Fehlermeldungen ins Template eintragen
        $oTemplate->assign( 'filename', $sFilename );

	    $oForm->SetValue( 'editor', '' );

        if ( !FileRead( $oApp->PathLink( $sFilename ), $sContent ) )
		    $oTemplate->parse( 'main.templateeditor.editor_read_error' );
   	    else
   	    {
		    $oTemplate->parse( 'main.templateeditor.editor_read_ok' );
            $oTemplate->parse( 'main.templateeditor.save' );
		    $oForm->SetValue( 'editor', $sContent );
		}
    }
}
$oTemplate->parse( 'main.templateeditor.open' );

// Alle HTML Dateinamen ermitteln
$sInclude = '(tpl)$';
$sExclude = $oParameter->Get( 'admin_editor_exclude' );
if ( $sExclude != '' )
    $sExclude .= '|';
$sExclude .= '(^_privat)|(_vti_)|(^admin)|(^cache)|(^ebay)|(^htdig)|(^images)|(^include)|(^popup)|(^postinfo.html)|(^plugin\/piwik\/piwik)|(^privat)|(^redirect)|(^webmail)';

$oDir = new CDir();
$oDir->Read( $oApp->PathLink( '' ), $sInclude, true, true, false, '', $sExclude );
$aFiles = $oDir->FullNames();

// Option Array erstellen: Key = Value, Value = Text
if ( is_array( $aFiles ) && count( $aFiles ) > 0 )
{
    reset( $aFiles );
    sort( $aFiles );
    foreach( $aFiles as $sKey => $sOption )
        $aOptions[ $sOption ] = $sOption;

    // Options setzen
    $oForm->SetOptions( 'filelist', $aOptions );
}

// Formular ausgeben
$oForm->OutputTpl( $oTemplate );
$oWebpage->Assign( 'onload', $oForm->GetOnLoad() );

$oTemplate->Parse();
$oWebpage->Assign( 'content', $oTemplate->Text() );

$oWebpage->End();
