<?php

include_once '../../../../include/opage.php';

// get parameters
if ( !isset( $sSystemModul ) || $sSystemModul === null )
    $sSystemModul = $oApp->GetParameter( 'systemmodul' );
if ( !isset( $sSystemPage ) || $sSystemPage === null )
    $sSystemPage = $oApp->GetParameter( 'systempage' );
if ( !isset( $sSystemPath ) || $sSystemPath === null )
    $sSystemPath = $oApp->GetParameter( 'systempath' );

// die if parameters missing (or set default parameters)
if ( $sSystemModul === null )
    die( 'parameter modul' );
if ( $sSystemPage === null )
    die( 'parameter page' );
if ( $sSystemPath === null )
    die( 'parameter path' );

// create page
$oWebpage = $oFactory->Webpage( $sSystemPage, 'CWebpageX' );
$oWebpage->Init();
$oWebpage->RightCheck( substr( $sSystemPage, 2 ), 'read', $oApp->GetRoot() . 'admin/custom/pages/home/home.php' );

// create modul
$oModul = $oFactory->Modul( $sSystemModul );
$oModul->ClearFilters();
$oModul->SetView( '' );

// create admin
$oAdmin = $oFactory->Control( 'CAdmin' );

// Hook for plugins
$oPlugins->AdminList( $oWebpage, $oModul, $oAdmin );

// Begin page
$oWebpage->Begin();

// Configure admin control
$oAdmin->SetTemplateParameter( $oWebpage->GetTemplateParameter() );
$oAdmin->SetModul( $oModul );
$oAdmin->SetFilter();
$oAdmin->SetSort();
$oAdmin->SetPager();

// insert fields into admin
$oModul->AdminList( $oAdmin );

// run admin
$oAdmin->Action();

// output admin
$oWebpage->Assign( 'content', $oAdmin->Output( $sRoot . $sSystemPath . 'index.tpl' ) );

$oWebpage->End();
