<?php

include_once '../../../../include/opage.php';

// Berechtigungssystem aktivieren?
$iFeatureRights = $oApp->GetFeature( 'user', 'rights' );

$oWebpage = $oFactory->Webpage( 'a_navigation', 'CWebpageBasis' );
$oWebpage->Init();
//$oWebpage->UserCheck( $oApp->GetRoot() . 'admin/index.php' . '?filename=' . urlencode( $oApp->GetBackUrl() ) );
$oWebpage->Begin();

$oTemplate = $oFactory->Template( 'navigation.tpl' );

// create menu for moduls
$oModule = $oFactory->Control( 'CMenu', 'module' );

// create menu for tools
$oTools = $oFactory->Control( 'CMenu', 'tools' );

// todo: wtf is this? Demmer? Get current section
$sSection = $oApp->GetParameter( 'shop_section' );

// Use global navigation: default: yes
$fGlobalNavigation = true;

// Hook for plugins
$oPlugins->AdminNavigation( $oWebpage, $oModule, $iFeatureRights, $fGlobalNavigation );

// insert modul entries
$oWebpageModule = $oFactory->Modul( 'CPageModul' );
if ( $fGlobalNavigation && is_object( $oWebpageModule ) && $oWebpageModule->Test() )
{
    $sQuery = '';
    if ( !IsNull( $sSection ) )
        $sQuery .= 'section=' . $sSection;

    $oWebpageModule->QueryData();
    foreach( $oWebpageModule->GetResult() as $aRow )
    {
        if ( $iFeatureRights >= 0 )
        {
            $sName = substr( $aRow[ 'name' ], strpos( $aRow[ 'name' ], '_' ) + 1 );

            // If there is a parent_name, user must have the right for the parent as well
            if ( $aRow[ 'parent_name' ] !== '' && $aRow[ 'parent_name' ] !== null )
            {
                $sParent = substr( $aRow[ 'parent_name' ], strpos( $aRow[ 'parent_name' ], '_' ) + 1 );
                if ( !$oUser->Right( $sParent, 'read' ) )
                    continue;
            }

            if ( !$oUser->Right( $sName, 'read' ) )
                continue;
        }

        $oWebpage->AddNavigation( $oModule, $aRow[ 'name' ], $aRow[ 'parent_name' ], $sQuery, null, null, null, true );
    }
}

// insert tool entries
$oWebpage->AddNavigation( $oTools, 'a_home' );

$oWebpageTools = $oFactory->Modul( 'CPageTools' );
if ( is_object( $oWebpageTools ) && $oWebpageTools->Test() )
{
    $sQuery = '';
    if ( !IsNull( $sSection ) )
        $sQuery .= 'section=' . $sSection;

    $oWebpageTools->QueryData();
    if ( $oWebpageTools->CountRows() == 0 )
    {
        $oWebpage->AddNavigation( $oTools, 'a_home', $sQuery );
        $oWebpage->AddNavigation( $oTools, 'a_logoff', $sQuery );
    }

    foreach( $oWebpageTools->GetResult() as $aRow )
    {
        if ( $iFeatureRights >= 0 )
        {
            $sName = substr( $aRow[ 'name' ], strpos( $aRow[ 'name' ], '_' ) + 1 );
            $sParent = substr( $aRow[ 'parent_name' ], strpos( $aRow[ 'parent_name' ], '_' ) + 1 );

            if ( !$oUser->Right( $sParent, 'read' ) )
                continue;

            if ( !$oUser->Right( $sName, 'read' ) )
                continue;
        }
        elseif ( $oUser->GetUser() != 'admin' )
        {
            // if current user is not admin, skip some entries
            switch( $aRow[ 'name' ] )
            {
                case 'a_module':
                case 'a_page':
                case 'a_page_modul':
                case 'a_page_tools':
                case 'a_parameter':
                case 'a_user':
                    continue 2;
                break;
            }
        }

        $oWebpage->AddNavigation( $oTools, $aRow[ 'name' ], $aRow[ 'parent_name' ], $sQuery, null, null, null, true );
    }
}

$oWebpage->AddNavigation( $oTools, 'a_logoff' );

// output menu modul
$oModule->SetView( $oApp->GetParameter( 'menu' ) );
$oModule->OutputTpl( $oTemplate );

// output menu tools
$oTools->SetView( $oApp->GetParameter( 'tools' ) );
$oTools->OutputTpl( $oTemplate );

// Parse reload button
if ( $oUser->GetUser() == 'admin' )
    $oTemplate->Parse( 'main.reload' );

$oTemplate->Parse();
$oWebpage->Assign( 'content', $oTemplate->Text() );
$oWebpage->End();
