<?php

defined( 'oPage' ) or die();

/** Basic class for pages
*/
class CWebpageBasis extends CWebpage
{
    function CWebpageBasis()
    {
        global $oPlugins;

        $this->CWebpage();
        $this->SetTemplate( 'admin/custom/basis.tpl' );

        // Hook for plugins
        $oPlugins->AdminWebpageBasis( $this, 'constructor' );
    }

    function Init()
    {
        global $oPlugins;

        $fResult = parent::Init();

        // Hook for plugins
        $oPlugins->AdminWebpageBasis( $this, 'init' );

        return( $fResult );
    }

    function Begin()
    {
        global $oApp;
        global $oPlugins;

        parent::Begin();

        // Hook for plugins
        $oPlugins->AdminWebpageBasis( $this, 'begin' );
    }

    function End()
    {
        global $oPlugins;

        // Hook for plugins
        $oPlugins->AdminWebpageBasis( $this, 'end' );

        return( parent::End() );
    }
}

// Standard Admin Page
class CWebpageNormal extends CWebpageBasis
{
    function CWebpageNormal()
    {
        global $oPlugins;

        $this->CWebpageBasis();
        $this->SetTemplate( 'admin/custom/normal.tpl' );

        // Hook for plugins
        $oPlugins->AdminWebpageNormal( $this, 'constructor' );
    }

    function Init()
    {
        global $oApp;
        global $oPlugins;

        $fResult = parent::Init();

        if ( !( $oApp->IsDevelopment() && $oApp->GetCookie( 'ZendDebuggerCookie' ) != '' ) )
        {
            $this->UserCheck( $oApp->GetRoot() . 'admin/custom/pages/logon/logon.php?filename=' . urlencode( $oApp->GetBackUrl() ) );
        }

        // Hook for plugins
        $oPlugins->AdminWebpageNormal( $this, 'init' );

        return( $fResult );
    }

    function Begin()
    {
        global $oPlugins;
        global $oUser;

        parent::Begin();

        $sUsername = $oUser->GetUser();
        $sFullname = $oUser->GetFullname();
        if ( $sFullname != '' )
        {
            $sDisplay = $sFullname . ' (' . $sUsername . ')';
        }
        else
        {
            $sDisplay = $sUsername;
        }

        $this->Assign( 'user_name', $sUsername );
        $this->Assign( 'user_fullname', $sFullname );
        $this->Assign( 'user_display', $sDisplay );

        // Hook for plugins
        $oPlugins->AdminWebpageNormal( $this, 'begin' );
    }

    function End()
    {
        global $oPlugins;
        global $oMessage;
        global $oError;

        $oMessage->OutputTpl( $this->oTpl );
        $oError->OutputTpl( $this->oTpl );

        // Hook for plugins
        $oPlugins->AdminWebpageNormal( $this, 'end' );

        return( parent::End() );
    }
}

// Advanced Admin Page
class CWebpageContent extends CWebpageNormal
{
    function CWebpageContent()
    {
        global $oPlugins;

        $this->CWebpageNormal();
        $this->SetTemplate( 'admin/custom/content.tpl' );

        // Hook for plugins
        $oPlugins->AdminWebpageContent( $this, 'constructor' );
    }

    function Init()
    {
        global $oPlugins;

        $fResult = parent::Init();

        // Hook for plugins
        $oPlugins->AdminWebpageContent( $this, 'init' );

        return( $fResult );
    }

    function Begin()
    {
        global $oApp;
        global $oFactory;
        global $oPlugins;

        global $oBack;

        parent::Begin();

        // Back Button
        $oBack = $oFactory->Control( 'CBack' );

        // If we have some languages, we use the language switch form.
        if ( $oApp->GetLanguageCount() > 1 )
        {
            $oLanguage = new CForm( 'language' );
            $oLanguage->AddField( 'language', 'SELECT' );
            $aLanguage = array();
            for( $i = 0; $i < $oApp->GetLanguageCount(); $i++ )
            {
                $iId = $oApp->GetLanguageIdByIndex( $i );
                $aLanguage[ $oApp->GetLanguageText( $iId ) ] = $oApp->GetLanguageText( $iId );
            }
            $oLanguage->SetOptions( 'language', $aLanguage );
            $oLanguage->SetValue( 'language', $oApp->GetLanguageText( $oApp->GetLanguage() ) );
        }

        foreach( $oApp->GetParameters() as $sKey => $sValue )
        {
            if ( $sKey != 'language' )
            {
                $aParameter = array( 'name' => $sKey, 'value' => $sValue );
                $this->oTpl->Assign( 'DATA', $aParameter );
                $this->oTpl->Parse( 'main.language.parameter' );
            }
        }

        // If we have some languages, we use the language switch form.
        if ( $oApp->GetLanguageCount() > 1 )
        {
            $oLanguage->OutputTpl( $this->oTpl );
        }

        // Hook for plugins
        $oPlugins->AdminWebpageContent( $this, 'begin' );
    }

    function End()
    {
        global $oPlugins;
        global $oBack;

        $oBack->OutputTpl( $this->oTpl );

        // Hook for plugins
        $oPlugins->AdminWebpageContent( $this, 'end' );

        return( parent::End() );
    }
}

if ( file_exists( $sRoot . 'custom/admin/webpage.php' ) )
{
    include_once $sRoot . 'custom/admin/webpage.php';
}
else
{
    class CWebpageX extends CWebpageContent
    {
    }
}
