<?php

defined( 'oPage' ) or die();

/** Basisklasse fr Controls
    Die verwendeten Templates mssen folgende Struktur aufweisen, wobei
    Control durch den jeweiligen Controlnamen zu ersetzen ist.

    <!-- BEGIN: main -->
        <!-- BEGIN: control -->
        <!-- End: control -->
    <!-- END: main -->

    Damit ist es mglich, mehrere Controls innerhalb eines Templates abzubilden.
    Hierfr ist die Funktion OutputTpl() vorgesehen.

    Soll das Control die Daten in ein eigenes Template ausgeben, so wird dazu
    Output() verwendet.
*/

include_once $sRoot . 'include/tools.php';

class CControl
{
    /** Name of the control
    */
    var $sName;

    /** Name of class
    */
    var $sClass;

    /** name for named resources
    */
    var $sResource;

    var $sPrefix;
    var $sPostfix;
    var $aTemplateParameter;
    var $sParameterExclude = '';
    var $sParameterInclude = '';

    /** scriptname, default $oApp->GetScriptname()
     */
    var $sScriptname;

    function CControl( $sName )
    {
        global $oApp;

        $this->SetScriptname( $oApp->GetScriptname() );
        $this->SetName( $sName );
        $this->GetParameter();
    }

    function Copy( $oCopy = Null )
    {
        if ( !is_object( $oCopy ) )
        {
            $sClass = get_class( $this );
            $oCopy = new $sClass( '' );
        }

        $oCopy->sName = $this->sName;
        $oCopy->sResource = $this->sResource;
        $oCopy->sPrefix = $this->sPrefix;
        $oCopy->sPostfix = $this->sPostfix;
        $oCopy->aTemplateParameter = $this->aTemplateParameter;
        $oCopy->sParameterExclude = $this->sParameterExclude;
        $oCopy->sParameterInclude = $this->sParameterInclude;

        return( $oCopy );
    }

    function GetParameter()
    {
    }

    function PrepareRowEdit( &$aValues, $sAction = 'changed', $fClear = false )
    {
        global $oUser;

        // Wenn zb. changed aufgerufen wird, dann darf created nicht mehr berschrieben werden.
        // Daher wird beim update created mit clear = true aufgerufen.
        if ( $fClear )
        {
            unset( $aValues[ "user_$sAction" ] );
            unset( $aValues[ "server_date_$sAction" ] );
            unset( $aValues[ "date_$sAction" ] );
            unset( $aValues[ "ip_$sAction" ] );

            return( true );
        }

          $iDateTime = Time();
        if ( IsNull( $aValues[ 'timezone' ] ) )
            $iDateTimeClient = $iDateTime;
        else
        {
            $aTimeOfDay = GetTimeOfDay();
            if ( PHP_VERSION >= '4.1.2' && PHP_OS == 'WINNT' )
                $iDateTimeClient = $aValues[ 'timezone' ] * 60 - $aTimeOfDay[ 'minuteswest' ] + $iDateTime;
            else
                $iDateTimeClient = ( $aValues[ 'timezone' ] - $aTimeOfDay[ 'minuteswest' ] ) * 60 + $iDateTime;
        }

        // Usernamen eintragen
        if ( is_object( $oUser ) )
            $aValues[ "user_$sAction" ] = $oUser->GetUser();

        $oDate = new CDate();
        $aValues[ "server_date_$sAction" ] = $oDate->Format( 4, $iDateTime );
        $aValues[ "date_$sAction" ] = $oDate->Format( 4, $iDateTimeClient );
        $aValues[ "ip_$sAction" ] = ClientIP();

        return( true );
    }

    function Output( $sTemplate, $sBlock = null )
    {
        global $oFactory;

        if ( $sBlock === null )
            $sBlock = 'main';

        $oTemplate = $oFactory->Template( $sTemplate, $sBlock, null, null, $this->sResource );

        $aParameter = $this->GetTemplateParameter();
        if ( is_array( $aParameter ) )
            $oTemplate->SetVars( $aParameter );

        $this->OutputTpl( $oTemplate, $sBlock );
        $oTemplate->parse( $sBlock );

        return( $oTemplate->text( $sBlock ) );
    }

    function OutputTpl( &$oTemplate, $sBlock = null, $sSub = null )
    {
        if ( $sBlock === null )
        {
            $sBlock = 'main';
        }

        $oTemplate->assign( 'control.scriptname', $this->sScriptname );

        $sBlockName = $sBlock . '.' . $this->GetName() . $sSub;

        if ( !$oTemplate->IsBlock( $sBlockName ) )
        {
            return( false );
        }

        return( true );
    }

    function OutputValue( &$oTemplate, $sKey, &$aRow, $sBlock = 'main' )
    {
        if ( !IsNull( $aRow[ $sKey ] ) )
        {
            // BEGIN:var#header parsen
            $oTemplate->parse( $sBlock . '.' . $sKey . '#header' );

            // BEGIN:var#begin parsen
            $oTemplate->parse( $sBlock . '.' . $sKey . '#begin' );

            // BEGIN var=value parsen
            $oTemplate->Parse( $sBlock . '.' . $sKey . '=' . $aRow[ $sKey ] );

            // BEGIN var<>0 parsen
            if ( $aRow[ $sKey ] <> 0 )
            {
                $oTemplate->Parse( $sBlock . '.' . $sKey . '<>0#begin' );
                $oTemplate->Parse( $sBlock . '.' . $sKey . '<>0' );
                $oTemplate->Parse( $sBlock . '.' . $sKey . '<>0#end' );
            }

            // BEGIN:var parsen
            $oTemplate->parse( $sBlock . '.' . $sKey );

            // BEGIN:var#end parsen
            $oTemplate->parse( $sBlock . '.' . $sKey . '#end' );

            // BEGIN:var#footer parsen
            $oTemplate->parse( $sBlock . '.' . $sKey . '#footer' );

            // BEGIN:var#empty parsen
            $oTemplate->parse( $sBlock . '.' . $sKey . '#notempty' );
        }
        else
        {
            // BEGIN:var#empty parsen
            $oTemplate->parse( $sBlock . '.' . $sKey . '#empty' );
        }
    }

    function SetName( $sValue )
    {
        $this->sName = $sValue;
        $this->SetResource( $sValue );
    }

    function GetName()
    {
        return( $this->sName );
    }

    function SetClass( $sValue )
    {
        $this->sclass = $sValue;
    }
    function GetClass()
    {
        return( $this->sclass );
    }

    /** set name of resources
        @param $sValue name for resource file
        @return void
    */
    function SetResource( $sValue )
    {
        $this->sResource = $sValue;
    }

    /** get name of resources
        @param void
        @return string
    */
    function GetResource()
    {
        return( $this->sResource );
    }

    /** Liefert den Feldnamen inkl. Postfix und Prefix
    */
    function GetField( $sName )
    {
        $sPrefix = $this->GetPrefix();
        $sPostfix = $this->GetPostfix();
        if ( !IsNull( $sPrefix ) )
            $sName = $sPrefix . '_' . $sName;
        if ( !IsNull( $sPostfix ) )
            $sName .= '_' . $sPostfix;

        return( $sName );
    }

    /** Setzt den Prefix eines Feldes
    */
    function SetPrefix( $sValue )
    {
        $this->sPrefix = $sValue;
    }

    /** Liefert den Prefix
    */
    function GetPrefix()
    {
        return( $this->sPrefix );
    }

    /** Setzt den Feldnamen Postfix
    */
    function SetPostfix( $sValue )
    {
        $this->sPostfix = $sValue;
    }

    /** Liefert den Postfix eines Feldes
    */
    function GetPostfix()
    {
        return( $this->sPostfix );
    }

    function SetTemplateParameter( $aValue )
    {
        $this->aTemplateParameter = $aValue;
        return( true );
    }

    function GetTemplateParameter()
    {
        return( $this->aTemplateParameter );
    }

    /** Legt einen Regulren Ausdruck fest, mit dem Parameter ausgeschlossen werden knnen.
        Die ausgeschlossenen Parameter werden nicht an den Get-String angehngt.
        zb. Submit-Buttons.
        @param $sValue String mit einem Regulren Ausdruck fr preg_match(), jedoch ohne '(' und ')i'
        @return void
    */
    function SetParameterExclude( $sValue )
    {
        $this->sParameterExclude = $sValue;
    }

    function AddParameterExclude( $sValue )
    {
        if ( IsNull( $sValue ) )
            return( true );

        if ( !IsNull( $this->sParameterExclude ) )
            $this->sParameterExclude .= '|';
        $this->sParameterExclude .= strtolower( $sValue );
    }

    function RemoveParameterExclude( $sValue )
    {
        if ( IsNull( $sValue ) )
            return( false );

        if ( !$this->IsParameterExcluded( $sValue ) )
            return( false );

        $this->sParameterExclude = substr
        (
        str_replace( '|' . strtolower( $sValue ) . '|', '|', '|' . $this->sParameterExclude . '|' ), 1, -1 );

        return( true );
    }

    function GetParameterExclude()
    {
        return( $this->sParameterExclude );
    }

    function IsParameterExcluded( $sValue )
    {
        if ( !preg_match( '/' . $this->sParameterExclude . '/i', $sValue ) )
        {
            return( false );
        }

        return( true );
    }

    /** Legt einen Regulren Ausdruck fest, mit dem Parameter eingeschlossen werden knnen.
        Es werden nur die eingeschlossenen Parameter an den Get-String angehngt.
        zb. Submit-Buttons.
        @param $sValue String mit einem Regulren Ausdruck fr preg_match(), jedoch ohne '(' und ')i'
        @return void
    */
    function SetParameterInclude( $sValue )
    {
        $this->sParameterInclude = $sValue;
    }

    function AddParameterInclude( $sValue )
    {
        if ( IsNull( $sValue ) )
            return( true );

        if ( !IsNull( $this->sParameterInclude ) )
            $this->sParameterInclude .= '|';
        $this->sParameterInclude .= strtolower( $sValue );
    }

    function RemoveParameterInclude( $sValue )
    {
        if ( IsNull( $sValue ) )
            return( false );

        if ( !$this->IsParameterInclude( $sValue ) )
            return( false );

        $this->sParameterInclude = substr( str_replace( '|' . strtolower( $sValue ) . '|', '|', '|' . $this->sParameterInclude . '|' ), 1, -1 );

        return( true );
    }

    function GetParameterInclude()
    {
        return( $this->sParameterInclude );
    }

    function IsParameterIncluded( $sValue )
    {
        if ( preg_match( '/' . $this->sParameterInclude . '/i', $sValue ) )
        {
            return( false );
        }

        return( true );
    }

    /** sets the scriptname
     * @param $sValue string path to the script
     */
    function SetScriptname( $sValue )
    {
        $this->sScriptname = $sValue;
    }

    /** returns the current scriptname
     * @param void
     */
    function GetScriptname()
    {
        return( $this->sScriptname );
    }
}
