<?php

defined( 'oPage' ) or die();

class CAdmin extends CControl
{
    /** Admin Mode
        1: List Admin, default
        2: Detail Admin, automatically set in CModul->Admin()
    */
    var $iMode = 1;

    /** Form
        Hier wird ein Objekt gespeichert
    */
    var $oForm;

    /** Felder */
	var $aFields = array();

    /** Modul, dessen Daten bearbeitet werden sollen
        Hier wird nur eine Referenz gespeichert.
    */
    var $rModul;

    /** Filter Control
        Hier wird ein Objekt gespeichert
    */
    var $oFilter;

    /** Sort Control
        Hier wird ein Objekt gespeichert
    */
    var $oSort;

    /** Pager Control
        Hier wird ein Objekt gespeichert
    */
    var $oPager;

    /** Exclude filter
        Used for excluding form fields from pager urls and back urls
    */
    var $sExclude;

    /** Counter Modul
        Hier wird ein Objekt gespeichert
    */
    var $oCounter;

    /** Total record count in modul */
    var $iRecords;

    /** Anzahl von Zeilen pro Seite */
    var $iRows;

    /** Wurden die Daten gelesen */
    var $fRead = false;

    /** Postfix fr Feldnamen
        Wird zur eindeutigen Identifizierung von Feldnamen gesetzt.
        Feldnamen haben dann die Form
        {Prefix_}field_{name}{_Postfix}{_row}
    */
    var $sPostfix = '';

    /** Preview Url
        Dieser Url wird aufgerufen, wenn Preview gedrckt wurde.
        Root-Absoluter Pfad mit {field} fr die Felder
        zb. article.php?article={id}&article_preview={id}
    */
    var $sPreviewUrl;

    /** Array with Cache Update urls
        Each of this url is called, when the Cache Update button is pressed
        The path has to be root relative and can contain placeholders for field names
    */
    var $aCacheUpdateUrl;

    /** Filter */
    var $aFilters;

    /** Button ListAdd */
    var $fButtonListAdd = true;

    /** Button ListSave */
    var $fButtonListSave = true;

    /** Button ListDelete */
    var $fButtonListDelete = true;

    /** Button ListDeleteAll */
    var $fButtonListDeleteAll = false;

    /** Button ListExport */
    var $fButtonListExport = false;

    /** Button ListImport */
    var $fButtonListImport = false;

    /** Button ListReset */
    var $fButtonListReset = false;

    /** Button ListCustom1 */
    var $fButtonListCustom1 = false;

    /** Module methode called when buttom Custom1 is clicked */
    var $sButtonListCustom1Method;

    /** Button ListCustom2 */
    var $fButtonListCustom2 = false;

    /** Module methode called when buttom Custom2 is clicked */
    var $sButtonListCustom2Method;

    /** Button Add */
    var $fButtonAdd = true;

    /** Button Preview */
    var $fButtonPreview = false;

    /** Button Cache Update */
    var $fButtonCacheUpdate = false;
    var $aButtonCacheUpdate = array();

    /** Button Save */
    var $fButtonSave = true;

    /** Button SaveAndClose */
    var $fButtonSaveAndClose = true;

    /** Button SaveAndNew */
    var $fButtonSaveAndNew = true;

    /** Button Copy */
    var $fButtonCopy = true;
    var $aButtonCopy = array();

    /** Button Delete */
    var $fButtonDelete = true;
    var $aButtonDelete = array();

    /** Button Reset */
    var $fButtonReset = true;

    /** Button Edit */
    var $fButtonEdit = true;
    var $aButtonEdit = array();

    /** Button Sub */
    var $fButtonSub = false;

    /** Button Send */
    var $fButtonSend = false;
    var $aButtonSend = array();

    /** Button SendAdmin */
    var $fButtonSendAdmin = false;
    var $aButtonSendAdmin = array();

    /** SubAdmins */
    var $aAdmins = array();

    /** Name des eigenen ID Feldes */
    var $sFieldId;

    /** Name des bergeordneten ID Feldes */
    var $sFieldMainId;

    /** Resultset
        Enthlt das Ergebnis der DB Abfrage, ev. zustzlichen Felder wie
        counter
        category
        admin
    */
    var $aResult = array();

    /** Wenn ein neuer Hauptrecord im bergeordneten Admin angelegt, so werden automatisch die angegeben Anzahl Datenstze im Unteradmin angelegt.
        Der Wert wird im SubAdmin festgelegt!
    */
    var $iAddRows = 0;

    /** Legt einen Prefix fr die Parameter fest.
        zb.: admin_gallery_picture -> verwendet statt admin_rows admin_gallery_picture_rows
        @default = 'admin'
    */
    var $sParameterPrefix = 'admin';

    var $iLanguageContent = -1;

    function CAdmin( $sName = 'admin' )
    {
        global $oApp;
        global $oSession;
        global $oBack;
        global $oFactory;

        $this->CControl( $sName );
		$this->oForm = $oFactory->Control( 'CForm', $sName );
        $this->oForm->SetPrefix( $sName );

    	// Content Language
      	$this->oForm->AddField( 'language_content', 'INTEGER' );
      	$iLanguageId = $this->GetLanguageContent();
      	if ( $iLanguageId == -1 )
      	{
            $iLanguageId = $this->oForm->GetValue( 'language_content' );
        	if ( IsNull( $iLanguageId ) )
          	    $iLanguageId = $oApp->GetLanguageShortID( $oSession->GetValue( 'language_content' ), true );
            if ( IsNull( $iLanguageId ) )
          	    $iLanguageId = $oApp->GetLanguageDefault( true );
          	$this->SetLanguageContent( $iLanguageId );
        }
  	    $this->oForm->SetValue( 'language_content', $iLanguageId );

        $this->sExclude = "^{$sName}_action|^{$sName}_select|^{$sName}_field|^{$sName}_filter_action";

        if ( is_object( $oBack ) )
            $oBack->AddParameterExclude( $this->sExclude );
    }

    function Copy( $oCopy = Null )
    {
        if ( !is_object( $oCopy ) )
        {
            $sClass = get_class( $this );
            $oCopy = new $sClass( '' );
        }
        $oCopy = CControl::Copy( $oCopy );

        $oCopy->iMode = $this->iMode;
        $oCopy->oForm = $this->oForm->Copy();
        $oCopy->aFields = $this->aFields;
        $oCopy->rModul = $this->rModul;

        if ( is_object( $this->oFilter ) )
            $oCopy->oFilter = $this->oFilter->Copy();
        else
            $oCopy->oFilter = $this->oFilter;

        if ( is_object( $this->oSort ) )
            $oCopy->oSort = $this->oSort->Copy();
        else
            $oCopy->oSort = $this->oSort;

        if ( is_object( $this->oPager ) )
            $oCopy->oPager = $this->oPager->Copy();
        else
            $oCopy->oPager = $this->oPager;

        if ( is_object( $this->oCounter ) )
            $oCopy->oCounter = $this->oCounter->Copy();
        else
            $oCopy->oCounter = $this->oCounter;

        $oCopy->iRows = $this->iRows;
        $oCopy->fRead = $this->fRead;
        $oCopy->sPostfix = $this->sPostfix;
        $oCopy->sPreviewUrl = $this->sPreviewUrl;
        $oCopy->aCacheUpdateUrl = $this->aCacheUpdateUrl;
        $oCopy->aFilters = $this->aFilters;
        $oCopy->fButtonListAdd = $this->fButtonListAdd;
        $oCopy->fButtonListSave = $this->fButtonListSave;
        $oCopy->fButtonListDelete = $this->fButtonListDelete;
        $oCopy->fButtonListDeleteAll = $this->fButtonListDeleteAll;
        $oCopy->fButtonListImport = $this->fButtonListImport;
        $oCopy->fButtonListExport = $this->fButtonListExport;
        $oCopy->fButtonListReset = $this->fButtonListReset;
        $oCopy->fButtonListCustom1 = $this->fButtonListCustom1;
        $oCopy->fButtonListCustom2 = $this->fButtonListCustom2;
        $oCopy->fButtonAdd = $this->fButtonAdd;
        $oCopy->fButtonPreview = $this->fButtonPreview;
        $oCopy->fButtonCacheUpdate = $this->fButtonCacheUpdate;
        $oCopy->aButtonCacheUpdate = $this->aButtonCacheUpdate;
        $oCopy->fButtonSave = $this->fButtonSave;
        $oCopy->fButtonCopy = $this->fButtonCopy;
        $oCopy->aButtonCopy = $this->aButtonCopy;
        $oCopy->fButtonDelete = $this->fButtonDelete;
        $oCopy->aButtonDelete = $this->aButtonDelete;
        $oCopy->fButtonReset = $this->fButtonReset;
        $oCopy->fButtonEdit = $this->fButtonEdit;
        $oCopy->aButtonEdit = $this->aButtonEdit;
        $oCopy->fButtonSub = $this->fButtonSub;
        $oCopy->fButtonSend = $this->fButtonSend;
        $oCopy->aButtonSend = $this->aButtonSend;
        $oCopy->fButtonSendAdmin = $this->fButtonSendAdmin;
        $oCopy->aButtonSendAdmin = $this->aButtonSendAdmin;
        $oCopy->aAdmins = $this->aAdmins;
        $oCopy->sFieldId = $this->sFieldId;
        $oCopy->sFieldMainId = $this->sFieldMainId;
        $oCopy->aResult = $this->aResult;
        $oCopy->iAddRows = $this->iAddRows;
        $oCopy->sParameterPrefix = $this->sParameterPrefix;

        return( $oCopy );
    }

    /** Initialisiert das Objekt
        Beim Hauptadmin wirds von Action() aufgerufen.
        Bei Subadmins mu es nach dem Setzen des Postfix der SubAdmin-Kopie aufgerufen werden,
        da bei Subadmins keine Action aufgerufen wird.
    */
    function Init()
    {
        global $oParameter;
        global $oApp;
        global $oSession;

        // Init form
        $this->InitForm();

        // Remember original url for form reset
        $this->oForm->AddField( 'url' );
        if ( $oApp->GetRequestMethod() == 'GET' )
        {
            $this->oForm->SetValue( 'url', $oApp->GetRequestUri() );
        }

        // Wurden bereits Daten gelesen? (heit deshalb action, damits beim Pager ausgeschlossen wird)
		$this->oForm->AddField( 'action_read', 'TEXT' );
        $sRead = $this->oForm->GetValue( 'action_read' );
        if ( !IsNull( $sRead  ) )
            $this->SetRead( true );

        // Zeilen pro Seite ermitteln
		$this->oForm->AddField( 'page_rows', 'INTEGER' );
		$iRows = $this->oForm->GetValue( 'page_rows' );
		if ( IsNull( $iRows ) )
		    $iRows = $oParameter->Get( $this->GetParameterPrefix() . '_rows', $oParameter->Get( 'rows' ) );
		if ( IsNull( $iRows ) )
		    $iRows = 20;
		$this->SetRows( $iRows );

		$this->oForm->AddField( 'select_all', 'CHECKBOX' );
		$this->oForm->AddField( 'selected', 'CHECKBOX', false, false, true );
    	$this->oForm->AddField( 'add_rows', 'TEXT' );
		$this->oForm->AddField( 'back', Null, Null, Null, Null, false );

      	$iLanguageId = $this->GetLanguageContent();
  	    $this->oForm->SetValue( 'language_content', $iLanguageId );

        // add encoding field for export
        if ( $this->GetButtonListExport() )
            $this->oForm->AddField( 'export_encoding', 'SELECT' );

        // only needed for (very old) modules, which do not use Admin() and AdminList()
        $this->rModul->SetLanguagePostfix( $oApp->GetLanguagePostfix( $iLanguageId, true ) );

        return( $iLanguageId );
    }

    /** Initialises the previously created admin form object:
        init row count
        init with values or defaults
    */
    function InitForm()
    {
        // Initialize row count
        $this->oForm->SetRows();

        // Query all data, initialize with default, if no values
        $this->oForm->QueryData();
    }

    function Mode( $iMode = null )
    {
        if ( $iMode === null )
            return( $this->iMode );

        $this->iMode = $iMode;
    }

    function SetModul( &$oValue )
    {
        $this->rModul = &$oValue;
    }

    function SetFilter( $oValue = '' )
    {
        global $oFactory;

        if ( !IsNull( $oValue ) )
		    $this->oFilter = $oValue;
        else
        {
    		$this->oFilter = $oFactory->Control( 'CFilter', $this->GetName() . '_filter' );
            $this->oFilter->SetPrefix( $this->GetName() . '_filter' );
        }
    }

    function SetSort( $oValue = '' )
    {
        global $oFactory;

        if ( !IsNull( $oValue ) )
    		$this->oSort = $oValue;
        else
        {
    		$this->oSort = $oFactory->Control( 'CSortSimple', $this->GetName() . '_sort' );
            $this->oSort->SetPrefix( $this->GetName() . '_sort' );
        }
    }

    function SetPager( $oValue = null, $sExclude = null )
    {
        global $oFactory;

        if ( !IsNull( $oValue ) )
    		$this->oPager = $oValue;
        else
        {
    		$this->oPager = $oFactory->Control( 'CPager', $this->GetName() . '_pager' );
            $this->oPager->SetPrefix( $this->GetName() . '_pager' );
            $this->oPager->AddParameterExclude( $this->sExclude );
            $this->oPager->AddParameterExclude( $sExclude );
        }
    }

    function SetCounter( $oValue )
    {
		$this->oCounter = $oValue;
        $this->oForm->AddField( 'counter', 'INTEGER', false, false, true );
    }

    /** Fgt einen neuen untergeordneten Admin hinzu
        @param $oObject Admin Objekt
        @return void
    */
    function AddAdmin( $oObject )
    {
        $this->aAdmins[] = $oObject;
    }

    /** Setzt die Abhngigkeit zu einem bergeordneten Admin
        @param $sId Name des eigenen ID Feldes (Fremdschlssel)
        @param $sMainId Name des zugehrigen ID Feldes im bergeordneten Admin
        @return void
    */
    function SetDependency( $sFieldId, $sFieldMainId )
    {
        $this->sFieldId = $sFieldId;
        $this->sFieldMainId = $sFieldMainId;
    }

    /** Postfix fr Feldnamen
        @param $sValue String
        Wird zur eindeutigen Identifizierung von Feldnamen gesetzt.
        Feldnamen haben dann im Formular
        {Prefix_}field_{name}{_Postfix}{_row}
        Angesprochen werden sie aber weiterhin mit field_feldname
    */
    function SetPostfix( $sValue )
    {
        $this->oForm->SetPostfix( $sValue );
    }

    /** Liefert einen Feldnamen inkl. field_
        @param $sName Name des Feldes
        @return String Name inkl. field_
    */
    function GetField( $sName )
    {
        $sName = 'field_' . $sName;

        return( $sName );
    }

    function AddField( $sName, $sType = Null, $fNotEmpty = Null, $fValidate = Null, $fMultiple = Null, $fHidden = Null, $fMultilanguage = Null )
    {
        if ( $fHidden === null )
            $fHidden = false;

        // 2004.10.13 DOH: auskommentiert wg. Admin: In CModul wird AddField aufgerufen, in CDiscount nochmals wg. Select_Switch
        // if ( $this->aFields[ $sName ] !== null )
        //    return;

        // 2008.11.08 DOH: check, if field has not been set, the field
        if ( !isset( $this->aFields[ $sName ] ) )
            $this->aFields[ $sName ] = array();

        if ( is_object( $this->oFilter ) )
            $this->oFilter->AddField( $sName, $sType );

        if ( is_object( $this->oSort ) )
            $this->oSort->AddField( $sName );

        $this->oForm->AddField( $this->GetField( $sName ), $sType, $fNotEmpty, $fValidate, $fMultiple, true, $fMultilanguage );
		$this->SetHidden( $sName, $fHidden );
    }

    function SetFieldType( $sName, $sValue )
    {
        if ( is_object( $this->oFilter ) )
            $this->oFilter->SetFieldType( $sName, $sValue );

        $this->oForm->SetFieldType( $this->GetField( $sName ), $sValue );
    }

    function SetFieldParameter( $sName, $sParameter, $sValue )
    {
        $this->oForm->SetFieldParameter( $this->GetField( $sName ), $sParameter, $sValue );
    }

    function GetFieldParameter( $sName, $sParameter )
    {
        return( $this->oForm->GetFieldParameter( $this->GetField( $sName ), $sParameter ) );
    }

    function SetWidth( $sName, $sValue )
    {
        if ( is_object( $this->oFilter ) )
            $this->oFilter->SetWidth( $sName, $sValue );

        if ( is_object( $this->oSort ) )
            $this->oSort->SetWidth( $sName, $sValue );

        $this->oForm->SetWidth( $this->GetField( $sName ), $sValue );
    }

    function SetHeight( $sName, $sValue )
    {
        if ( is_object( $this->oFilter ) )
            $this->oFilter->SetHeight( $sName, $sValue );

        if ( is_object( $this->oSort ) )
            $this->oSort->SetHeight( $sName, $sValue );

        $this->oForm->SetHeight( $this->GetField( $sName ), $sValue );
    }

    function SetMaxlength( $sName, $sValue )
    {
        if ( is_object( $this->oFilter ) )
            $this->oFilter->SetMaxlength( $sName, $sValue );

        if ( is_object( $this->oSort ) )
            $this->oSort->SetMaxlength( $sName, $sValue );

        $this->oForm->SetMaxlength( $this->GetField( $sName ), $sValue );
    }

    function SetValueMin( $sName, $iValue )
    {
        $this->oForm->SetValueMin( $this->GetField( $sName ), $iValue );
    }

    function SetValueMax( $sName, $iValue )
    {
        $this->oForm->SetValueMax( $this->GetField( $sName ), $iValue );
    }

    function SetNotEmpty( $sName, $fValue = null )
    {
        $this->oForm->SetNotEmpty( $this->GetField( $sName ), $fValue );
    }

    function SetValidate( $sName, $fValue = null )
    {
        $this->oForm->SetValidate( $this->GetField( $sName ), $fValue );
    }

    function SetHidden( $sName, $fValue = null )
    {
        $this->oForm->SetHidden( $this->GetField( $sName ), $fValue );
    }
    function GetHidden( $sName )
    {
        return( $this->oForm->GetHidden( $this->GetField( $sName ) ) );
    }

    function GetOptions( $sName )
    {
        return( $this->oForm->GetOptions( $this->GetField( $sName ) ) );
    }
    function SetOptions( $sName, $aValues, $aStyles = null )
    {
        if ( is_object( $this->oFilter ) )
            $this->oFilter->SetOptions( $sName, $aValues );

        if ( is_object( $this->oSort ) )
            $this->oSort->SetOptions( $sName, $aValues );

        $this->oForm->SetOptions( $this->GetField( $sName ), $aValues, $aStyles );
    }

    function SetRelation( $sName, $oObject )
    {
        if ( is_object( $this->oFilter ) )
            $this->oFilter->SetRelation( $sName, $oObject );

        $this->aFields[ $sName ][ 'relation' ] = $oObject;
    }

    /** Limitiert die Ausgabe von Texten
        @param sName Name des Feldes
        @param sValue Lnge des Limits
        Die Inhalt wird im Formular als <name>_limited zur Verfgung gestellt.
        Der normale Inhalt mu in einem Hidden Feld mitgezogen werden.
    */
    function SetLimit( $sName, $sValue )
    {
        $this->oForm->SetLimit( $this->GetField( $sName ), $sValue );
    }

    /** Setzt ein Feld auf ReadOnly
        @param sName Name des Feldes
        @param fValue True/False
        Felder mit ReadOnly = true werden nicht an Insert und Update Statements weitergereicht.
    */
    function SetReadonly( $sName, $fValue = Null )
    {
        if ( $fValue === null )
            $fValue = true;

        $this->aFields[ $sName ][ 'readonly' ] = $fValue;
    }

    /** Setzt den SyncMaster fr das angegebene Feld
        Beim Speichern eines Datensatzes wird der Inhalt des Masterfeldes bernommen,
        falls das Feld keinen eigenen Wert hat und das Master-Feld vorhanden ist.
        @param sName Name des Feldes
        @param sValue Name des Master-Feldes
        @param bool $fStrict Sync the master field with the slave and ignore slave value, default null (false)
        @return void
    */
    function SetSyncMaster( $sName, $sValue, $sParameter = null, $fStrict = null )
    {
        $this->oForm->SetSyncMaster( $this->GetField( $sName ), $this->GetField( $sValue ), $sParameter, $fStrict );
    }

    /** Get the fields value
        @param sName Fieldname
        @param iRow row, default 0
        @return value
    */
    function GetValue( $sName, $iRow = null )
    {
        return( $this->oForm->GetValue( $this->GetField( $sName ), $iRow ) );
    }

    /** Setzt den Defaultwert fr neue Eintrge
        @param sName Feldname
        @param sValue Defaultwert
        @return void
    */
    function SetDefault( $sName, $sValue )
    {
        $this->aFields[ $sName ][ 'default' ] = $sValue;
    }

    /** Liefert den Defaultwert
        @param sName Feldname
        @return String
    */
    function GetDefault( $sName )
    {
        return( $this->aFields[ $sName ][ 'default' ] );
    }

    /** Setzt einen Pfad, zb. fr einen Bildupload
        @param sName Feldname
        @param sValue Pfad (absolut zum Webroot)
        @return void
    */
    function SetUploadPath( $sName, $sValue )
    {
        $this->oForm->SetUploadPath( $this->GetField( $sName ), $sValue );
    }

    /** Setzt einen Prefix fr den Dateinamen des Uploads
        @param sName Feldname
        @param sValue String
        @return void
    */
    function SetUploadPrefix( $sName, $sValue )
    {
        $this->oForm->SetUploadPrefix( $this->GetField( $sName ), $sValue );
    }

    /** Setzt einen Postfix fr den Dateinamen des Uploads
        @param sName Feldname
        @param sValue String
        @return void
    */
    function SetUploadPostfix( $sName, $sValue )
    {
        $this->oForm->SetUploadPostfix( $this->GetField( $sName ), $sValue );
    }

    /** Setzt die erlaubten Dateitypen
        @param sName Feldname
        @param sValue Dateitypen, mehrere durch '|' getrennt, zb. 'gif|jpg|jpeg'
        @return void
    */
    function SetUploadType( $sName, $sValue )
    {
        $this->oForm->SetUploadType( $this->GetField( $sName ), $sValue );
    }

    /** Setzt die erlaubte Dateigre
        @param sName Feldname
        @param sValue Dateigre in Byte
        @return void
    */
    function SetUploadMaxsize( $sName, $sValue )
    {
        $this->oForm->SetUploadMaxsize( $this->GetField( $sName ), $sValue );
    }

    /** Setzt die Anzahl an Verzeichnisebenen, um zu viele Dateien in einem Verzeichnis zu vermeiden.
        @param sName Feldname
        @param iValue Levels
        @return void
    */
    function SetUploadLevel( $sName, $iValue )
    {
        $this->oForm->SetUploadLevel( $this->GetField( $sName ), $iValue );
    }

    /** Image display width (width for displaying the image in the form)
        @param sName field anme
        @param sValue width in pixel
        @return void
    */
    function SetImageDisplayWidth( $sName, $sValue )
    {
        $this->oForm->SetImageDisplayWidth( $this->GetField( $sName ), $sValue );
        if ( is_object( $this->oFilter ) )
            $this->oFilter->oForm->SetImageDisplayWidth( $this->GetField( $sName ), $sValue );
    }

    /** Legt fest, ob Bilder auch vergrert werden sollen
        @param sName Feldname
        @param fValue true/false
        @return void
    */
    function SetImageExact( $sName, $fValue )
    {
        $this->oForm->SetImageExact( $this->GetField( $sName ), $fValue );
    }

    /** Set image width/height mode
	    @param sName Feldname
    	@param iValue 0 normal, 1 min, 2 max
    	@return void
    */
    function SetImageMode( $sName, $iValue )
    {
        $this->oForm->SetImageMode( $this->GetField( $sName ), $iValue );
    }

    /** Legt die Qualitt der verlustbehafteter Komprimierung der Bilder fest.
        @param sName Feldname
        @param iValue bei JPG: 0-100
        @return void
    */
    function SetImageQuality( $sName, $iValue )
    {
        $this->oForm->SetImageQuality( $this->GetField( $sName ), $iValue );
    }

    /** Setzt die Image-Breite
        @param sName Feldname
        @param sValue Breite in Pixel
        @return void
    */
    function SetImageWidth( $sName, $sValue )
    {
        if ( is_object( $this->oFilter ) )
            $this->oFilter->SetImageWidth( $sName, $sValue );

        $this->oForm->SetImageWidth( $this->GetField( $sName ), $sValue );
    }

    /** Setzt die Image-Hhe
        @param sName Feldname
        @param sValue Hhe in Pixel
        @return void
    */
    function SetImageHeight( $sName, $sValue )
    {
        if ( is_object( $this->oFilter ) )
            $this->oFilter->SetImageHeight( $sName, $sValue );

        $this->oForm->SetImageHeight( $this->GetField( $sName ), $sValue );
    }

    /** Setzt die Anzahl der Datenstze, die bei einem neuen Hauptdatensatz angelegt werden.
        @param iValue
        @return void
    */
    function SetAddRows( $iValue )
    {
        $this->iAddRows = $iValue;
    }

    /** Liefert die Anzahl der hinzuzufgenden Datenstze, wenn ein neuer Hauptdatensatz angelegt wird.
        @return iValue
    */
    function GetAddRows()
    {
        return( $this->iAddRows );
    }

    /** Setzt den Parameterprefix fr Admin-Parameter
        @return void
    */
    function SetParameterPrefix( $sValue )
    {
        $this->sParameterPrefix = $sValue;
    }

    /** Liefert den ParameterPrefix fr Admin-Parameter
        @return string
    */
    function GetParameterPrefix()
    {
        return( $this->sParameterPrefix );
    }

    /** Setzt ein zustzliches Suchfeld fr ein Filterfeld
        @param sName Name des Hauptfeldes
        @param sValue Name des zustzlichen Suchfeldes
        @return void
    */
    function AddSearchField( $sName, $sValue )
    {
        if ( is_object( $this->oFilter ) )
            $this->oFilter->AddSearchField( $sName, $sValue );
    }

    function Action( $aMainRow = null )
    {
        global $oError;
        global $oResource;

        SystemSetTimeout( 0 );

        // Objekt initialisieren
        if ( $aMainRow === null )
            $this->Init();

        // Wenn wir was gelesen haben, dann die Daten aus dem Form holen
        if ( $this->GetRead() )
            $this->QueryDataFromForm();

        if ( is_object( $this->oFilter ) )
            if ( $this->oFilter->Action() )
                $this->SetRead( false );

        if ( is_object( $this->oSort ) )
            if ( $this->oSort->Action() )
                $this->SetRead( false );

        // Standardfilter setzen
        if ( is_array( $this->aFilters ) )
            foreach( $this->aFilters as $sName => $aFilter )
    	        $this->rModul->SetFilter( $sName, $aFilter[ 'value' ], $aFilter[ 'compare' ], $aFilter[ 'escape' ], $aFilter[ 'slashes' ], $aFilter[ 'getfield' ] );

        // Filter setzen
        if ( is_object( $this->oFilter ) )
        {
      		foreach ( array_keys( $this->aFields ) as $sName )
            {
                // Apply modul filter?
                if ( !$this->rModul->AdminListFilter( $sName, $this->oFilter->GetValue( $sName ) ) )
                    // Apply form filter
                    if ( $this->oFilter->Get( $sName, $sFilter, $sCompare ) )
                        $this->rModul->SetFilter( $sName, $sFilter, $sCompare );
            }
        }

        // Sort setzen
        if ( is_object( $this->oSort ) )
        {
            $aSort = $this->oSort->Get();
            if ( count( $aSort ) > 0 )
            {
   		        $this->rModul->ClearOrders();
          		foreach ( $aSort as $sName => $sOrder )
                    $this->rModul->SetOrder( $sName, $sOrder );
            }
        }

        // Wenn wir eine Row haben, dann den Filter fr die ID setzen
        if ( !IsNull( $aMainRow ) )
        {
            if ( IsNull( $this->sFieldId ) || IsNull( $this->sFieldMainId ) )
                die( 'CAdmin: QueryData: SetDependency() wurde fr den untergeordneten Admin nicht aufgerufen' );

            $this->rModul->SetFilter( $this->sFieldId, $aMainRow[ $this->sFieldMainId ] );
            $this->SetDefault( $this->sFieldId, $aMainRow[ $this->sFieldMainId ] );
        }

        if ( $this->oForm->Validate() )
        {
            // Daten einfgen?
            $fAdd = $this->Add( $aMainRow );

            // Daten speichern?
            $this->Save( $aMainRow, false, false, $fAdd );

            // Daten lschen?
            $this->Delete( $aMainRow );

            // Daten exportieren?
            $this->Export( $aMainRow );

            // Module specific method?
            $this->Custom( $aMainRow );
        }
        else
            $oError->Add( $oResource->Error( 'data_invalid', $this->rModul->GetName() ) );

        // Wurde Rows gedrckt
        if ( $this->oForm->IsSubmitted( 'action_list_rows' ) )
            $this->SetRead( false );

        // Pager initialisieren
        if ( !IsNull( $this->oPager ) )
        {
            // Rows setzen
            $this->rModul->SetRows( $this->GetRows() );
            $this->oPager->SetPages( $this->rModul->GetPages() );
            $this->rModul->SetPage( $this->oPager->GetPage() );
        }

        // Wenn die Daten des Hauptadmins nicht neu geladen werden mssen, dann
        // in die SubAdmins reingehen und dort gucken, obs was zu tun gibt.
        if ( $this->GetRead() )
            foreach( $this->aResult as $i => $aRow )
                foreach( $this->aAdmins as $sKey => $oAdmin )
                    $this->aResult[ $i ][ 'admin' ][ $sKey ]->Action( $aRow );

        // If saveandnew has been clicked, clear data
        if ( $this->oForm->IsSubmitted( 'action_saveandnew', 1 ) )
        {
            // if the field sort is used, set the default value of sort to old-value + 1
            if ( isset( $this->aFields[ 'sort' ] ) )
            {
                $sValue = $this->oForm->GetValue( $this->GetField( 'sort' ) );
                if ( $sValue !== null && $sValue !== '' )
                {
                    $sValue += 10;
                    $this->SetDefault( 'sort', $sValue );
                }
            }

            // Reset data in form and subadmins
            $this->Reset();

            // No need to read data -> set read = true
            $this->SetRead( true );
        }

        // Need to read data?
        if ( $this->GetRead() == false )
            $this->QueryData( $aMainRow );

        if ( $aMainRow == null )
        {
            $sUrl = $this->oForm->GetValue( 'url' );
            $aParameter = array();
            HttpSplit( $sUrl, $sUrl, $aParameter );
            // Is there an ID? (e.g. new records have no ID at the beginning)
            if ( $aParameter[ 'id' ] === null || $aParameter[ 'id' ] === '' )
            {
                // Get ID of current record
                $aParameter[ 'id' ] = $this->oForm->GetValue( $this->GetField( 'id' ) );
                // If there is an ID unset the list_add action (which clears the ID)
                if ( $aParameter[ 'id' ] !== null && $aParameter[ 'id' ] !== '' )
                {
                    unset( $aParameter[ 'admin_action_list_add' ] );
                }
                $sUrl .= HttpParam( $aParameter );
                $this->oForm->SetValue( 'url', $sUrl );
            }
        }

        SystemSetTimeout();
    }

    function QueryDataFromForm( $aRow = Null )
    {
        // Werte fr die bertragung aus dem Formular vorbereiten
        $aResult = array();

        // Anzahl der Datenstze im Form
        $iRows = $this->oForm->GetRows( true );

        // Alle Datenstze verarbeiten
        for( $i = 1; $i <= $iRows; $i++ )
        {
            $aRow = array();

            // Wenn wir einen Counter haben, dann den Counter auslesen
            $aRow[ 'counter' ] = $this->oForm->GetValue( $this->GetField( 'counter' ), $i );
            if ( $aRow[ 'counter' ] == 0 )
                $aRow[ 'counter' ] = null;

            // Datetime und Timezone bernehmen
            $aRow[ 'datetime' ] = $this->oForm->GetValue( 'datetime' );
            $aRow[ 'timezone' ] = $this->oForm->GetValue( 'timezone' );

            // Daten aus dem Formular bernehmen und als Array fr den Modul herichten
            foreach( array_keys( $this->aFields ) as $sName )
                $aRow[ $sName ] = $this->oForm->GetValue( $this->GetField( $sName ), $i );

            // Die anderen Admins verarbeiten
            foreach( $this->aAdmins as $sKey => $oAdmin )
            {
                $sPostfix = $this->oForm->GetPostfix();
                if ( !IsNull( $sPostfix ) )
                    $sPostfix .= '_';
                $sPostfix .= 'row' . $i;

                // Admin kopieren
                $aRow[ 'admin' ][ $sKey ] = $oAdmin->Copy();
                $aRow[ 'admin' ][ $sKey ]->SetPostfix( $sPostfix );
                $aRow[ 'admin' ][ $sKey ]->SetLanguageContent( $this->GetLanguageContent() );
                $aRow[ 'admin' ][ $sKey ]->Init();

                // Daten im untergeordneten Admin lesen
                $aRow[ 'admin' ][ $sKey ]->QueryDataFromForm( $aRow );
            }

            $aResult[ $i ] = $aRow;
        }

        $this->aResult = $aResult;
    }

    function Reset( $aRow = Null )
    {
        global $oApp;

        // Reset all form fields to the default values and clear all get/post parameter values
        foreach( array_keys( $this->aFields ) as $sName )
            $this->oForm->ResetField( $this->GetField( $sName ) );

        // Max 1 row per Admin
        if ( $this->oForm->GetRows() > 1 )
            $this->oForm->SetRows( 1 );

        $iRows = $this->oForm->GetRows();
        for( $i = 1; $i <= $iRows; $i++ )
        {
            // Defaultwerte setzen
            foreach( $this->aFields as $sName => $aField )
                $this->oForm->SetValue( $this->GetField( $sName ), $aField[ 'default' ], $i );

            // Disable some buttons
            $this->aButtonCopy[ $i ] = false;
            $this->aButtonEdit[ $i ] = false;
            $this->aButtonSend[ $i ] = false;
            $this->aButtonSendAdmin[ $i ] = false;
            $this->aButtonCacheUpdate[ $i ] = false;

            // Die anderen Admins verarbeiten
            foreach( $this->aAdmins as $sKey => $oAdmin )
                // Daten im untergeordneten Admin lschen
                $this->aResult[ $i ][ 'admin' ][ $sKey ]->Reset( $this->aResult[ $i ] );
        }
    }

    function Add( $aMainRow = Null, $iAdd = 0 )
    {
        if ( $this->oForm->IsSubmitted( 'action_list_add' ) || $iAdd > 0 )
        {
            $iRows = $this->oForm->GetRows();

            // Anzahl der hinzuzufgenden Zeilen ermitteln.
            if ( $iAdd != 0 )
                $iRowsAdd = $iAdd;
            else
            {
                $iRowsAdd = $this->oForm->GetValue( 'add_rows' );
                if ( $iRowsAdd < 0 || IsNull( $iRowsAdd ) )
                    $iRowsAdd = 1;
            }

            $iRows += $iRowsAdd;
            $this->oForm->SetRows( $iRows );

            // Copy, Edit, Send and CacheUpdate Button fr die neuen Rows ausschalten.
            for( $i = $iRows - $iRowsAdd + 1; $i <= $iRows; $i++ )
            {
                $this->aResult[ $i ] = array();

                // show delete button -> so new unsaved records can be deleted without saving them
                // $this->aButtonDelete[ $i ] = false;
                $this->aButtonCopy[ $i ] = false;
                $this->aButtonEdit[ $i ] = false;
                $this->aButtonSend[ $i ] = false;
                $this->aButtonSendAdmin[ $i ] = false;
                $this->aButtonCacheUpdate[ $i ] = false;

                // Defaultwerte setzen
                foreach( $this->aFields as $sName => $aField )
                    $this->oForm->SetValue( $this->GetField( $sName ), $aField[ 'default' ], $i );

                // SubAdmins anlegen
                foreach( $this->aAdmins as $sKey => $oAdmin )
                {
                    // Die anderen Admins verarbeiten
                    foreach( $this->aAdmins as $sKey => $oAdmin )
                    {
                        $sPostfix = $this->oForm->GetPostfix();
                        if ( !IsNull( $sPostfix ) )
                            $sPostfix .= '_';
                        $sPostfix .= 'row' . $i;

                        // Admin kopieren
                        $this->aResult[ $i ][ 'admin' ][ $sKey ] = $oAdmin->Copy();
                        $this->aResult[ $i ][ 'admin' ][ $sKey ]->SetPostfix( $sPostfix );
                        $this->aResult[ $i ][ 'admin' ][ $sKey ]->SetLanguageContent( $this->GetLanguageContent() );
                        $this->aResult[ $i ][ 'admin' ][ $sKey ]->Init();
                    }

                    $iAddRows = $this->aResult[ $i ][ 'admin' ][ $sKey ]->GetAddRows();
                    if ( $iAddRows > 0 )
                        $this->aResult[ $i ][ 'admin' ][ $sKey ]->Add( $this->aResult[ $i ], $iAddRows );
                }
            }

            // Wenn wir eine Row haben, dann den Filter fr die ID setzen
            if ( !IsNull( $aMainRow ) )
            {
                if ( IsNull( $this->sFieldId ) || IsNull( $this->sFieldMainId ) )
                    die( 'CAdmin: QueryData: SetDependency() wurde fr den untergeordneten Admin nicht aufgerufen' );

                $this->rModul->SetFilter( $this->sFieldId, $aMainRow[ $this->sFieldMainId ] );
            }

            $this->SetRead( true );
            return( true );
        }

        return( false );
    }

    /** Speichert bzw. kopiert die markierten Datenstze
        @param $aRow Datensatz des bergeordneten Admins
        @param $fForce Sollen alle Datenstze kopiert werden (oder nur die selektierten) (Default: false, nur die marktierten kopieren)
        @param $fAddMode Reference to a variable, which will be set to true, if SaveAndClose has been clicked -> Switches Action() into AddMode
        @return true alles erfolgreich, false Fehler
    */
    function Save( $aMainRow = Null, $fForce = false, $fCopy = false, &$fAddMode )
    {
        global $oApp;
        global $oResource;
        global $oError;
        global $oMessage;

        // Wenn wir eine Row haben
        if ( !IsNull( $aMainRow ) )
        {
            if ( IsNull( $this->sFieldId ) || IsNull( $this->sFieldMainId ) )
                die( 'CAdmin: Save: SetDependency() wurde fr den untergeordneten Admin nicht aufgerufen' );
        }

        $fReturn = true;

        // Alle Datenstze verarbeiten
        $fListSave = $this->oForm->IsSubmitted( 'action_list_save' );
        foreach( $this->aResult as $i => $aRow )
        {
            $fPreview = $this->oForm->IsSubmitted( 'action_preview', $i );
            $fSave = $this->oForm->IsSubmitted( 'action_save', $i );
            $fSaveAndClose = $this->oForm->IsSubmitted( 'action_saveandclose', $i );
            $fSaveAndNew = $this->oForm->IsSubmitted( 'action_saveandnew', $i );
            $fCopy = $this->oForm->IsSubmitted( 'action_copy', $i ) || $fCopy;

            // berprfen, ob einer der Language-Buttons geklickt wurde.
            $fLanguage = false;
            if ( $oApp->GetLanguageCount( true ) > 1 )
            {
                for( $j = 0; $j < $oApp->GetLanguageCount( true ); $j++ )
                {
                    $iId = $oApp->GetLanguageIdByIndex( $j, true );
                    if ( ( $fLanguage = $this->oForm->IsSubmitted( 'action_language_' . $iId ) ) == true )
                        break;
                }
            }

            // Ist der Datensatz ausgewhlt?
            if ( ( $fListSave && !IsNull( $this->oForm->GetValue( 'selected', $i ) ) )
                    || $fPreview
                    || $fSave
                    || $fSaveAndClose
                    || $fSaveAndNew
                    || $fCopy
                    || $fForce
                    || $fLanguage
               )
            {
                // Die Daten auf jeden Fall neu lesen
                $this->SetRead( false );

                $fOk = true;

                // Wenn die ID des Elterndatensatzes nicht mit dem Fremdschlssel bereinstimmt.
                // dann mssen von den Datenein im Datensatz kopien erstellt werden.
                if ( is_array( $aMainRow ) )
                    if ( $aRow[ $this->sFieldId ] != $aMainRow[ $this->sFieldMainId ] )
                        $fCopy = true;

                // Let the module process some data
                $this->rModul->AdminSave( $this, $i, $aRow );

                // Dateien an den richtigen Platz kopieren
                if ( $fOk )
                    if ( !$this->oForm->Upload( $i, $fCopy || $fPreview ) )
                        $fOk = false;

                // Bilder zuschneiden
                if ( $fOk )
                    if ( !$this->oForm->Resize( $i ) )
                        $fOk = false;

                // Daten speichern
                if ( $fOk )
                {
                    $sId = $aRow[ 'id' ];

                    // Die Daten des Datensatzes aus der DB lesen, damit alle Felder beim Kopieren gefllt sind.
                    if ( !IsNull( $sId ) )
                    {
                        if ( $fPreview || $fCopy )
                        {
                            $sFilter = $this->rModul->GetField( 'id' ) . "='$sId'";
                            $aResult = $this->rModul->Query( $sFilter );

                            if ( count( $aResult ) > 0 )
                            {
                                $aResult = array_shift( $aResult );

                                foreach( $aResult as $sName => $sValue )
                                {
                                    // Wenn wir ein Datei-Feld haben, da jedoch nicht in der normalen Feldliste vorhanden ist,
                                    // dann die Datei kopieren
                                    if ( ( $this->rModul->GetFieldType( $sName ) == 'IMAGE' || $this->rModul->GetFieldType( $sName ) == 'FILE' ) && !IsKey( $aRow, $sName ) && !IsNull( $sValue ) )
                                    {
                                        $sPath = $this->rModul->GetFieldPath( $sName );
                                        $sPath = $oApp->PathLink( $sPath );
                                        FileUploadCopy( $sPath, $sPath, $sValue, null, null, $this->rModul->GetUploadLevel() );
                                    }

                                    $aRow[ $sName ] = $sValue;
                                    $this->aResult[ $i ][ $sName ] = $aRow[ $sName ];
                                }
                            }
                        }
                    }

                    // Durch Upload und Resize sind mglicherweise die Daten gendert worden.
                    // Daten aus dem Formular bernehmen und als Array fr den Modul herichten
                    foreach( array_keys( $this->aFields ) as $sName )
                    {
                        $aRow[ $sName ] = $this->oForm->GetValue( $this->GetField( $sName ), $i );
                        $this->aResult[ $i ][ $sName ] = $aRow[ $sName ];
                    }

                    // Wenn Preview gedrckt wurde, dann display auf false und preview auf true
                    if ( $fPreview )
                    {
                        $aRow[ 'display' ] = 'n';
                        $aRow[ 'preview' ] = 'y';
                    }

                    $sIdOld = '';
                    if ( $fCopy || $fPreview )
                    {
                        $sIdOld = $sId;
                        $aRow[ 'preview_original_id' ] = $aRow[ 'id' ];
                        $sId = '';
                        $aRow[ 'id' ] = '';

                        // neuen Fremdschlssel eintragen
                        $aRow[ $this->sFieldId ] = $aMainRow[ $this->sFieldMainId ];
                    }

                    if ( IsNull( $sId ) )
                    {
                        if ( $this->rModul->Insert( $aRow ) )
                        {
                            // Aktuelle ID lesen
                            $sId = $aRow[ 'id' ];
                            $this->aResult[ $i ][ 'id' ] = $sId;

                            // Wenn wir einen ID Filter haben, dann die neue ID eintragen
                            if ( $this->rModul->IsFilter( 'id' ) )
                                $this->rModul->SetFilterValue( 'id', $sId );

                            $oMessage->Add( $oResource->Message( 'database_insert', $this->rModul->GetName() ) );
                        }
                        else
                        {
                            $sId = $sIdOld;
                            $aRow[ 'id' ] = $sIdOld;
                            $fOk = false;
                            $oError->Add( $oResource->Error( 'database_insert', $this->rModul->GetName() ) );
                        }
                    }
                    else
                    {
                        // Alle Readonly Felder aus aRow lschen
                        // 26.02.2006 DOH: wieder auskommentiert, da auch einige ID Felder readonly sind und damit der Datensatz nicht aktualisiert werden kann.
                        // foreach( $this->aFields as $sName => $aField )
                        //     if ( $aField[ 'readonly' ] == true )
                        //         unset( $aRow[ $sName ] );

                        // alle Felder entfernen, die nicht in der Query vorkommen.
                        // 11.02.2004 DOH: wieder auskommentiert, da sonst nicht gesetzte checkboxen nicht speichert werden
                        // 11.09.2007 DOH: aktivated again, checkboxes need to have a hidden field with the same name!
                        foreach( array_keys( $this->aFields ) as $sName )
                            if ( !$this->oForm->QueryIs( $this->GetField( $sName ), $i ) )
                                unset( $aRow[ $sName ] );

                        if ( $this->rModul->Update( $aRow, 'id' ) )
                            $oMessage->Add( $oResource->Message( 'database_update', $sId, $this->rModul->GetName() ) );
                        else
                        {
                            $fOk = false;
                            $oError->Add( $oResource->Error( 'database_update', $sId, $this->rModul->GetName() ) );
                        }
                    }
                }

                if ( $fOk )
                {
                    // Nachbearbeitung (zb. Kategorien speichern, etc.
                    foreach( array_keys( $this->aFields ) as $sName )
                    {
                        $oRelation = &$this->aFields[ $sName ][ 'relation' ];
                        if ( is_object( $oRelation ) )
                        {
                            $sValue = $aRow[ $sName ];
                            $sValue = $oRelation->RelationSave( $sId, $sName, $sValue );
                        }
                    }
                }

                // Jetzt die untergeordneten Admins speichern
                if ( $fOk )
                    foreach( $this->aAdmins as $sKey => $oAdmin )
                        // Wenn wir im Preview Mode sind, dann werden die untergeordneten Eintrge nur kopiert
                        if ( !$this->aResult[ $i ][ 'admin' ][ $sKey ]->Save( $aRow, true, $fCopy, $fAddMode ) )
                            $fOk = false;

                if ( !$fOk )
                    $fReturn = false;

                // Wenn alles geklappt hat und preview gedrckt wurde, Preview aufrufen.
                if ( $fOk && $fPreview )
                {
                    $sUrl = $this->GetPreviewUrl();

                    if ( $this->rModul->PreparePreviewUrl( $aRow, $sUrl ) == 1 )
                    {
                        // Replace {var} with current values
                        foreach( array_keys( $this->aFields ) as $sName )
                        {
                            $sUrl = str_replace( '{' . $sName . '}', $aRow[ $sName ], $sUrl );
                        }
                        $sUrl = str_replace( '{preview_original_id}', $aRow[ 'preview_original_id' ], $sUrl );
                    }

                    Header( 'Location: ' . $oApp->PathLink( $sUrl ) );

                    // Now delete all old preview records
                    $sFilter = $this->rModul->GetField( 'preview' ) . "='y' and " . $this->rModul->GetField( 'date_created' ) . '< now() - 3600';
                    $this->rModul->Delete( $sFilter );

                    exit();
                }

                // If saveandclose was clicked, parse close section in template
                if ( $fOk && $fSaveAndClose )
                    $this->oForm->AddBlock( 'action_saveandclose' );
            }
        }

        return( $fReturn );
    }

    /** Lscht die markierten Datenstze
        @param $aRow Datensatz des bergeordneten Admins
        @param $fForce Sollen alle Datenstze gelscht werden (oder nur die selektierten) (Default: false, nur die marktierten lschen)
        @return true alles erfolgreich, false Fehler
    */
    function Delete( $aMainRow = Null, $fForce = false )
    {
        global $oResource;
        global $oError;
        global $oMessage;

        // Wenn wir eine Row haben
        if ( !IsNull( $aMainRow ) )
        {
            if ( IsNull( $this->sFieldId ) || IsNull( $this->sFieldMainId ) )
                die( 'CAdmin: Delete: SetDependency() wurde fr den untergeordneten Admin nicht aufgerufen' );
        }

        $fReturn = true;

        // Alles lschen?
        if ( $this->oForm->IsSubmitted( 'action_list_deleteall' ) )
        {
            // Wenn wir SubAdmins haben, dann funktioniert DeleteAll noch nicht!
            if ( count( $this->aAdmins ) > 0 )
                die( 'CAdmin: Delete: DeleteAll fr Admins mit SubAdmin nicht untersttzt.' );

            // Wenn wir eine Relation haben, dann funktioniert DeleteAll noch nicht!
            foreach( array_keys( $this->aFields ) as $sName )
            {
                $oRelation = &$this->aFields[ $sName ][ 'relation' ];
                if ( is_object( $oRelation ) )
                    die( 'CAdmin: Delete: DeleteAll fr Admins mit Relationen nicht untersttzt.' );
            }

            $this->SetRead( false );

            // Alles lschen
            $fOk = true;

            if ( $this->rModul->Delete( $this->rModul->GetFilters() ) )
                $oMessage->Add( $oResource->Message( 'database_delete_all', $this->rModul->GetName() ) );
            else
            {
                $oError->Add( $oResource->Error( 'database_delete_all', $this->rModul->GetName() ) );
                $fOk = false;
            }

            if ( !$fOk )
                $fReturn = false;
        }
        else
        {
            // Alle Datenstze verarbeiten
            foreach( $this->aResult as $i => $aRow )
            {
                // Ist der Datensatz ausgewhlt?
                if ( ( $this->oForm->IsSubmitted( 'action_list_delete' ) && !IsNull( $this->oForm->GetValue( 'selected', $i ) ) )
                    || $this->oForm->IsSubmitted( 'action_delete', $i )
                    || $fForce )
                {
                    // Die Daten auf jeden Fall neu lesen
                    $this->SetRead( false );

                    $fOk = true;

                    // Zuerst die anderen Admins verarbeiten
                    foreach( $this->aAdmins as $sKey => $oAdmin )
                        if ( !$this->aResult[ $i ][ 'admin' ][ $sKey ]->Delete( $aRow, true ) )
                            $fOk = false;

                    // Daten lschen
                    if ( $fOk )
                    {
                        $sId = $aRow[ 'id' ];
                        if ( !IsNull( $sId ) )
                        {
                            $sQuery = $this->rModul->GetField( 'id' ) . "='$sId'";

                            if ( $this->rModul->Delete( $sQuery ) )
                                $oMessage->Add( $oResource->Message( 'database_delete', $sId, $this->rModul->GetName() ) );
                            else
                            {
                                $oError->Add( $oResource->Error( 'database_delete', $sId, $this->rModul->GetName() ) );
                                $fOk = false;
                            }
                        }
                    }

                    if ( $fOk )
                    {
                        // Nachbearbeitung (zb. Kategorien speichern, etc.
                        foreach( array_keys( $this->aFields ) as $sName )
                        {
                            $oRelation = &$this->aFields[ $sName ][ 'relation' ];
                            if ( is_object( $oRelation ) )
                                $sValue = $oRelation->RelationClear( $sId );
                        }
                    }

                    if ( !$fOk )
                        $fReturn = false;
                }
            }
        }

        return( $fReturn );
    }

    /** Exports (filtered) rows into a temporary file and sends this file to the client
        @param $aMainRow Row of parent admin (not used here)
        @return true/false
    */
    function Export( $aMainRow = Null )
    {
        global $oApp;
        global $oResource;
        global $oError;
        global $oMessage;

        // Wenn wir eine Row haben
        if ( !IsNull( $aMainRow ) )
        {
            if ( IsNull( $this->sFieldId ) || IsNull( $this->sFieldMainId ) )
                die( 'CAdmin: Delete: SetDependency() wurde fr den untergeordneten Admin nicht aufgerufen' );
        }

        // Export?
        if ( !$this->oForm->IsSubmitted( 'action_list_export' ) )
            return( true );

        // If we have a SubAdmin export currently does not work
        if ( count( $this->aAdmins ) > 0 )
            die( 'CAdmin: Export: Export does not work for admins with subadmins.' );

        // If we have a relation object export currently does not work
        foreach( array_keys( $this->aFields ) as $sName )
        {
            $oRelation = &$this->aFields[ $sName ][ 'relation' ];
            if ( is_object( $oRelation ) )
                die( 'CAdmin: Export: Export does not work for admins with relations.' );
        }

        // see also /admin_std/custom/pages/export/export.php!

        // Create temporary file
        $sFilename = FileTemp( $oApp->Pathlink( 'temp/' ), 'csv' );

        // Export Data
        if ( !$this->rModul->CsvWrite( $sFilename, $this->rModul->GetFilters() ) )
        {
            FileDelete( $sFilename );
            return( false );
        }

        // get encoding
        $sEncoding = strtolower( $this->oForm->GetValue( 'export_encoding' ) );

        // Convert the content into the target charset
        if ( $sEncoding != $oApp->GetCharset() )
            FileConvert( $sFilename, $oApp->GetCharset(), $sEncoding );

        // Send file to user
        FileDownload( $sFilename, $this->rModul->GetName() . '.csv' );

        // Delete file
        FileDelete( $sFilename );

        // just exit after successfull export -> all additional output will be written to the downloaded file!
        exit( 0 );

        return( true );
    }

    /** Custom method
        @param $aMainRow Row of parent admin
        @return true/false
    */
    function Custom( $aMainRow = Null )
    {
        if ( $this->oForm->IsSubmitted( 'action_list_custom1' ) )
        {
            // Call custom method in module
            $sMethod = $this->sButtonListCustom1Method;
            if ( !method_exists( $this->rModul, $sMethod ) )
            {
                trigger_error( 'Custom1 method does not exist: ' . $sMethod,  E_USER_NOTICE );
                return( false );
            }

            if ( !$this->rModul->$sMethod( $aMainRow ) )
            {
                return( false );
            }

            $this->SetRead( false );
        }

        if ( $this->oForm->IsSubmitted( 'action_list_custom2' ) )
        {
            // Call custom method in module
            $sMethod = $this->sButtonListCustom2Method;
            if ( !method_exists( $this->rModul, $sMethod ) )
            {
                trigger_error( 'Custom2 method does not exist: ' . $sMethod,  E_USER_NOTICE );
                return( false );
            }

            if ( !$this->rModul->$sMethod( $aMainRow ) )
            {
                return( false );
            }

            $this->SetRead( false );
        }

        return( true );
    }

    /** Liest die Daten aus der DB
        @param &$aRow aktueller Datensatz des bergeordneten Admins
        @return void
    */
    function QueryData( $aMainRow = Null )
    {
        global $oApp;

        if ( IsNull( $this->rModul ) )
            die( 'admin: rModul nicht gesetzt.' );

        // Wenn ein Languagebutten gedrckt wurde, dann mssen wir den Modul fr die neue Sprache initialisieren
        if ( $oApp->GetLanguageCount( true ) > 1 )
        {
            // Language Id holen
            $iLanguageId = $this->GetLanguageContentNew();

            if ( $iLanguageId >= 0 )
            {
          	    $this->oForm->SetValue( 'language_content', $iLanguageId );
          	    $this->SetLanguageContent( $iLanguageId );
                $this->rModul->SetLanguagePostfix( $oApp->GetLanguagePostfix( $iLanguageId, true ) );
            }
        }

        // Wenn wir eine Row haben, dann den Filter fr die ID setzen
        // 2004.04.24 DOH: Der Filter fr SubModule wird hier zustzlich gesetzt (wichtig, wenn QueryData rekursiv aufgerufen wird)
        if ( !IsNull( $aMainRow ) )
        {
            if ( IsNull( $this->sFieldId ) || IsNull( $this->sFieldMainId ) )
                die( 'CAdmin: QueryData: SetDependency() wurde fr den untergeordneten Admin nicht aufgerufen' );

            $this->rModul->SetFilter( $this->sFieldId, $aMainRow[ $this->sFieldMainId ] );

            // Pager initialisieren
            // Only necessary for subadmins, since pager of main admin already set in action()
            if ( !IsNull( $this->oPager ) )
            {
                // Rows setzen
                $this->rModul->SetRows( $this->GetRows() );
                $this->oPager->SetPages( $this->rModul->GetPages() );
                $this->rModul->SetPage( $this->oPager->GetPage() );
            }
        }

        // Get total record count
        $this->iRecords = $this->rModul->CountAll();

        // Get total values
        $this->rModul->QueryTotal( $this->Mode() );

        // Daten lesen
        $this->rModul->QueryData();

        // Adminform mit Daten befllen
        $aResult = $this->rModul->GetResult();
        $this->oForm->SetRows( count( $aResult ) );

        // Werte fr die bertragung ins Formular vorbereiten
        $aResultNew = array();
        $aResultForm = array();
        $i = 0;
        foreach( $aResult as $aRow )
        {
            $i++;
            $aRowForm = array();

            // Wenn wir einen Counter haben, dann den Counter auslesen
            // 2010-10-27 DOH   Only read counter, if there no counter field in the module
            if ( is_object( $this->oCounter ) && !isset( $aRow[ 'counter' ] ) )
            {
                $iCounter = $this->oCounter->GetCounter( $aRow[ 'id' ] );
                if ( $iCounter == 0 )
                    $iCounter = null;
                $aRowForm[ 'counter' ] = $iCounter;
                $aRow[ 'counter' ] = $iCounter;
            }

            // Inhalte aufbereiten
            foreach( array_keys( $this->aFields ) as $sName )
            {
                $oRelation = &$this->aFields[ $sName ][ 'relation' ];
                if ( is_object( $oRelation ) )
                {
                    $oRelation->SetFilter( 'id', $aRow[ 'id' ] );
                    $oRelation->QueryData();
                    $sValue = $oRelation->GetValuesString( $sName, true );
                    $aRowForm[ $this->GetField( $sName ) ] = $sValue;
                    $aRow[ $sName ] = $sValue;
                }
            }

            // Die anderen Admins verarbeiten
            foreach( $this->aAdmins as $sKey => $oAdmin )
            {
                $sPostfix = $this->oForm->GetPostfix();
                if ( !IsNull( $sPostfix ) )
                    $sPostfix .= '_';
                $sPostfix .= 'row' . $i;

                // Admin kopieren
                $aRow[ 'admin' ][ $sKey ] = $oAdmin->Copy();
                $aRow[ 'admin' ][ $sKey ]->SetPostfix( $sPostfix );
                $aRow[ 'admin' ][ $sKey ]->SetLanguageContent( $this->GetLanguageContent() );
                $aRow[ 'admin' ][ $sKey ]->Init();

                // Daten im untergeordneten Admin lesen
                $aRow[ 'admin' ][ $sKey ]->QueryData( $aRow );
            }

            // Restlichen Felder kopieren
            foreach( $aRow as $sName => $sValue )
                $aRowForm[ $this->GetField( $sName ) ] = $sValue;

            $aResultNew[ $i ] = $aRow;
            $aResultForm[ $i ] = $aRowForm;
        }
        $this->aResult = $aResultNew;

        $this->oForm->SetValues( $aResultForm );

        // Daten wurden gelesen
        $this->SetRead( true );

        // Select_All Flag lschen (selected wurde bei SetValues automatisch gelscht)
   		$this->oForm->SetValue( 'select_all', '' );
    }

    function OutputTpl( &$oTemplate, $sBlock = null, $sSub = null )
    {
        global $oApp;
        global $oFactory;

        if ( $sBlock === null )
        {
            $sBlock = 'main';
        }

        $aVars = $oTemplate->GetVars();

        if ( !parent::OutputTpl( $oTemplate, $sBlock, $sSub ) )
        {
            return( false );
        }
        $sBlockName = $sBlock . '.' . $this->GetName() . $sSub;

        $oTemplate->Assign( 'admin.modul', $this->rModul->GetClass() );
        $oTemplate->Assign( 'admin.modulgroup', $this->rModul->GetClassGroup() );
        $oTemplate->Assign( 'admin.name', $this->rModul->GetName() );

        // Create full module name inkl. parent name
        $sFullname = $oTemplate->Get( 'admin.fullname' );
        if ( $sFullname === null || $sFullname === '' )
        {
            $oTemplate->Assign( 'admin.fullname', $this->rModul->GetName() );
        }
        else
        {
            $oTemplate->Assign( 'admin.fullname', $sFullname . '-' . $this->rModul->GetName() );
        }

        $oTemplate->Assign( 'records', $this->iRecords );
        if ( $this->iRecords == 1 )
        {
            $oTemplate->Parse( $sBlockName . '.record' );
        }
        else
        {
            $oTemplate->Parse( $sBlockName . '.records' );
        }

        // Create navigation control for content language selection
        if ( $sBlock == 'main' )
        {
            if ( $oTemplate->IsBlock( 'main.admin.ROW.contentlanguage' ) )
            {
                $oContentLanguage = $oFactory->Control( 'CNavigation', 'contentlanguage' );
                if ( $this->rModul->GetMultipleLanguages() && $oApp->GetLanguageCount( true ) > 1 )
                {
                    for( $i = 0; $i < $oApp->GetLanguageCount( true ); $i++ )
                    {
                        $iId = $oApp->GetLanguageIdByIndex( $i, true );
                        $oContentLanguage->Add( $iId, '', '', $oApp->GetLanguageText( $iId, true ) );
                    }
                    $oContentLanguage->SetActive( $this->oForm->GetValue( 'language_content' ) );
                }
                $oContentLanguage->OutputTpl( $oTemplate, 'main.admin.ROW' );
            }
        }

        $iColumns = 0;
        foreach( array_keys( $this->aFields ) as $sName )
        {
            if ( !$this->GetHidden( $sName ) )
            {
                $iColumns++;
            }
        }
        $oTemplate->Assign( 'columns', $iColumns + 2 );
        $oTemplate->Assign( 'columns-1', $iColumns + 1 );

        if ( $this->GetButtonListAdd() )
        {
            $this->oForm->AddBlock( 'action_list_button_add' );
        }
        if ( $this->GetButtonListSave() )
        {
            $this->oForm->AddBlock( 'action_list_button_save' );
        }
        if ( $this->GetButtonListDelete() )
        {
            $this->oForm->AddBlock( 'action_list_button_delete' );
        }
        if ( $this->GetButtonListDeleteAll() )
        {
            $this->oForm->AddBlock( 'action_list_button_deleteall' );
        }
        if ( $this->GetButtonListImport() )
        {
            $this->oForm->AddBlock( 'action_list_button_import' );
        }
        if ( $this->GetButtonListExport() )
        {
            $this->oForm->AddBlock( 'action_list_button_export' );
        }
        if ( $this->GetButtonListReset() )
        {
            $this->oForm->AddBlock( 'action_list_button_reset' );
        }
        if ( $this->GetButtonListCustom1() )
        {
            $this->oForm->AddBlock( 'action_list_button_custom1' );
        }
        if ( $this->GetButtonListCustom2() )
        {
            $this->oForm->AddBlock( 'action_list_button_custom2' );
        }

        if ( is_object( $this->oFilter ) )
        {
            $this->oFilter->OutputTpl( $oTemplate, $sBlockName );
        }

        if ( $this->rModul->IsTotal( null, $this->Mode() ) )
        {
            foreach( array_keys( $this->aFields ) as $sName )
            {
                $oTemplate->Assign( 'total', $this->oForm->FormatValue( $this->GetField( $sName ), $this->rModul->Total( $sName, null, $this->Mode() ), false ) );
                $oTemplate->Parse( $sBlockName . '.total.field_' . $sName );
            }
            $oTemplate->Parse( $sBlockName . '.total' );
        }

        if ( is_object( $this->oSort ) )
        {
            $this->oSort->OutputTpl( $oTemplate, $sBlockName );
        }

        // Bei allen Datenstze wo ID = '' die Edit Buttons sperren
        foreach( $this->aResult as $i => $aRow )
        {
            if ( IsNull( $aRow[ 'id' ] ) )
            {
                // show delete button -> so new unsaved records can be deleted without saving them
                //$this->aButtonDelete[ $i ] = false;
                $this->aButtonCopy[ $i ] = false;
                $this->aButtonEdit[ $i ] = false;
                $this->aButtonSend[ $i ] = false;
                $this->aButtonSendAdmin[ $i ] = false;
                $this->aButtonCacheUpdate[ $i ] = false;
            }
        }

        if ( !IsNull( $this->oPager ) )
        {
            $this->oPager->OutputTpl( $oTemplate, $sBlockName );
        }

        if ( $this->GetButtonAdd() )
        {
            $this->oForm->AddBlock( 'action_button_add#begin' );
            $this->oForm->AddBlock( 'action_button_add#end' );
            $this->oForm->AddBlock( 'action_button_add' );
            $this->oForm->AddBlock( 'action_button_add#bottom' );
        }
        if ( $this->GetButtonPreview() )
        {
            $this->oForm->AddBlock( 'action_button_preview#begin' );
            $this->oForm->AddBlock( 'action_button_preview#end' );
            $this->oForm->AddBlock( 'action_button_preview' );
            $this->oForm->AddBlock( 'action_button_preview#bottom' );
        }
        if ( $this->GetButtonCacheUpdate() )
        {
            $this->oForm->AddBlock( 'action_button_cacheupdate#begin', $this->aButtonCacheUpdate );
            $this->oForm->AddBlock( 'action_button_cacheupdate#end', $this->aButtonCacheUpdate );
            $this->oForm->AddBlock( 'action_button_cacheupdate', $this->aButtonCacheUpdate );
            $this->oForm->AddBlock( 'action_button_cacheupdate#bottom', $this->aButtonCacheUpdate );

            // Output cache update urls
            foreach( $this->aResult as $i => $aRow )
            {
                // Continue if ID is not set
                if ( !isset( $aRow[ 'id' ] ) || $aRow[ 'id' ] === null || $aRow[ 'id' ] === '' )
                {
                    continue;
                }

                // For each cache update URL
                foreach( $this->aCacheUpdateUrl as $sUrl => $aFilter )
                {
                    // Default: output URL
                    $fParse = true;

                    // If a filter exists
                    if ( $aFilter !== null )
                    {
                        // Check each filter entry
                        foreach( $aFilter as $sName => $sValue )
                        {
                            // If field is equal value -> do not use cache update URL
                            if ( $aRow[ $sName ] != $sValue )
                            {
                                $fParse = false;
                                break;
                            }
                        }
                    }

                    if ( $fParse == false )
                    {
                        continue;
                    }

                    $iReturn = $this->rModul->PrepareCacheUrl( $aRow, $sUrl );
                    if ( $iReturn == 0 )
                    {
                        continue;
                    }

                    if ( $iReturn == 1 )
                    {
                        // Replace {var} with current values
                        foreach( array_keys( $this->aFields ) as $sName )
                        {
                            $sUrl = str_replace( '{' . $sName . '}', $aRow[ $sName ], $sUrl );
                        }
                    }

                    // Assign prepared URL and parse block
                    $oTemplate->Assign( 'url', $sUrl );
                    $oTemplate->Parse( $sBlockName . '.cacheupdate' );
                }
            }
        }
        if ( $this->GetButtonCopy() )
        {
            $this->oForm->AddBlock( 'action_button_copy#begin', $this->aButtonCopy );
            $this->oForm->AddBlock( 'action_button_copy#end', $this->aButtonCopy );
            $this->oForm->AddBlock( 'action_button_copy', $this->aButtonCopy );
            $this->oForm->AddBlock( 'action_button_copy#bottom', $this->aButtonCopy );
        }
        if ( $this->GetButtonSave() )
        {
            $this->oForm->AddBlock( 'action_button_save#begin' );
            $this->oForm->AddBlock( 'action_button_save#end' );
            $this->oForm->AddBlock( 'action_button_save' );
            $this->oForm->AddBlock( 'action_button_save#bottom' );
        }
        if ( $this->GetButtonSaveAndClose() )
        {
            $this->oForm->AddBlock( 'action_button_saveandclose#begin' );
            $this->oForm->AddBlock( 'action_button_saveandclose#end' );
            $this->oForm->AddBlock( 'action_button_saveandclose' );
            $this->oForm->AddBlock( 'action_button_saveandclose#bottom' );
        }
        if ( $this->GetButtonSaveAndNew() )
        {
            $this->oForm->AddBlock( 'action_button_saveandnew#begin' );
            $this->oForm->AddBlock( 'action_button_saveandnew#end' );
            $this->oForm->AddBlock( 'action_button_saveandnew' );
            $this->oForm->AddBlock( 'action_button_saveandnew#bottom' );
        }
        if ( $this->GetButtonDelete() )
        {
            $this->oForm->AddBlock( 'action_button_delete#begin', $this->aButtonDelete );
            $this->oForm->AddBlock( 'action_button_delete#end', $this->aButtonDelete );
            $this->oForm->AddBlock( 'action_button_delete', $this->aButtonDelete );
            $this->oForm->AddBlock( 'action_button_delete#bottom', $this->aButtonDelete );
        }
        if ( $this->GetButtonReset() )
        {
            $this->oForm->AddBlock( 'action_button_reset#begin' );
            $this->oForm->AddBlock( 'action_button_reset#end' );
            $this->oForm->AddBlock( 'action_button_reset' );
            $this->oForm->AddBlock( 'action_button_reset#bottom' );
        }
        if ( $this->GetButtonEdit() )
        {
            $this->oForm->AddBlock( 'action_button_edit#begin', $this->aButtonEdit );
            $this->oForm->AddBlock( 'action_button_edit#end', $this->aButtonEdit );
            $this->oForm->AddBlock( 'action_button_edit', $this->aButtonEdit );
        }
        if ( $this->GetButtonSub() )
        {
            $this->oForm->AddBlock( 'action_button_sub#begin' );
            $this->oForm->AddBlock( 'action_button_sub#end' );
            $this->oForm->AddBlock( 'action_button_sub' );
        }
        if ( $this->GetButtonSend() )
        {
            $this->oForm->AddBlock( 'action_button_send#begin', $this->aButtonSend );
            $this->oForm->AddBlock( 'action_button_send#end', $this->aButtonSend );
            $this->oForm->AddBlock( 'action_button_send', $this->aButtonSend );
            $this->oForm->AddBlock( 'action_button_send#bottom', $this->aButtonSend );
        }
        if ( $this->GetButtonSendAdmin() )
        {
            $this->oForm->AddBlock( 'action_button_sendadmin#begin', $this->aButtonSendAdmin );
            $this->oForm->AddBlock( 'action_button_sendadmin#end', $this->aButtonSendAdmin );
            $this->oForm->AddBlock( 'action_button_sendadmin', $this->aButtonSendAdmin );
            $this->oForm->AddBlock( 'action_button_sendadmin#bottom', $this->aButtonSendAdmin );
        }

        if ( $this->GetRead() )
        {
            $this->oForm->SetValue( 'action_read', '1' );
        }
        $this->oForm->SetValue( 'page_rows', $this->GetRows() );

        // Callback setzen und Daten ausgeben
        if ( count( $this->aAdmins ) > 0 )
        {
            $this->oForm->SetCallback( $this, 'FormCallback' );
        }
        $this->oForm->OutputTpl( $oTemplate, $sBlock, $sSub );

        $oTemplate->SetVars( $aVars );
    }

    function FormCallback( $aValues, &$oTemplate, $sBlock, $iRow = 0 )
    {
        if ( is_array( $this->aResult[ $iRow ][ 'admin' ] ) )
        {
            $aAdmins =& $this->aResult[ $iRow ][ 'admin' ];

            foreach( $aAdmins as $sKey => $oAdmin )
            {
                $aAdmins[ $sKey ]->OutputTpl( $oTemplate, $sBlock );
            }
        }
    }

    function SetRows( $iValue )
    {
        $this->iRows = $iValue;
        if ( $this->iRows < 1 )
            $this->iRows = 1;
    }
    function GetRows()
    {
        return( $this->iRows );
    }

    function SetRead( $fValue )
    {
        $this->fRead = $fValue;
    }
    function GetRead()
    {
        return( $this->fRead );
    }

    function SetPreviewUrl( $sValue )
    {
        $this->sPreviewUrl = $sValue;
    }
    function GetPreviewUrl()
    {
        return( $this->sPreviewUrl );
    }

    function SetCacheUpdateUrl( $aValue )
    {
        $this->aCacheUpdateUrl = $aValue;
    }
    function GetCacheUpdateUrl()
    {
        return( $this->aCacheUpdateUrl );
    }

    function SetButtonListAdd( $fValue )
    {
        $this->fButtonListAdd = $fValue;
    }
    function GetButtonListAdd()
    {
        return( $this->fButtonListAdd );
    }

    function SetButtonListSave( $fValue )
    {
        $this->fButtonListSave = $fValue;
    }
    function GetButtonListSave()
    {
        return( $this->fButtonListSave );
    }

    function SetButtonListDelete( $fValue )
    {
        $this->fButtonListDelete = $fValue;
    }
    function GetButtonListDelete()
    {
        return( $this->fButtonListDelete );
    }

    function SetButtonListDeleteAll( $fValue )
    {
        $this->fButtonListDeleteAll = $fValue;
    }
    function GetButtonListDeleteAll()
    {
        return( $this->fButtonListDeleteAll );
    }

    function SetButtonListImport( $fValue )
    {
        $this->fButtonListImport = $fValue;
    }
    function GetButtonListImport()
    {
        return( $this->fButtonListImport );
    }

    function SetButtonListExport( $fValue )
    {
        $this->fButtonListExport = $fValue;
    }
    function GetButtonListExport()
    {
        return( $this->fButtonListExport );
    }

    function SetButtonListReset( $fValue )
    {
        $this->fButtonListReset = $fValue;
    }
    function GetButtonListReset()
    {
        return( $this->fButtonListReset );
    }

    function SetButtonListCustom1( $fValue = null )
    {
        if ( $fValue === null )
        {
            $fValue = true;
        }
        $this->fButtonListCustom1 = $fValue;
    }
    function GetButtonListCustom1()
    {
        return( $this->fButtonListCustom1 );
    }
    function SetButtonListCustom1Method( $sValue )
    {
        $this->sButtonListCustom1Method = $sValue;
    }
    function GetButtonListCustom1Method()
    {
        return( $this->sButtonListCustom1Method );
    }

    function SetButtonListCustom2( $fValue = null )
    {
        if ( $fValue === null )
        {
            $fValue = true;
        }
        $this->fButtonListCustom2 = $fValue;
    }
    function GetButtonListCustom2()
    {
        return( $this->fButtonListCustom2 );
    }
    function SetButtonListCustom2Method( $sValue )
    {
        $this->sButtonListCustom2Method = $sValue;
    }
    function GetButtonListCustom2Method()
    {
        return( $this->sButtonListCustom2Method );
    }

    function SetButtonAdd( $fValue )
    {
        $this->fButtonAdd = $fValue;
    }
    function GetButtonAdd()
    {
        return( $this->fButtonAdd );
    }

    function SetButtonPreview( $fValue )
    {
        $this->fButtonPreview = $fValue;
    }
    function GetButtonPreview()
    {
        return( $this->fButtonPreview );
    }

    function SetButtonCacheUpdate( $fValue )
    {
        $this->fButtonCacheUpdate = $fValue;
    }
    function GetButtonCacheUpdate()
    {
        return( $this->fButtonCacheUpdate );
    }

    function SetButtonCopy( $fValue )
    {
        $this->fButtonCopy = $fValue;
    }
    function GetButtonCopy()
    {
        return( $this->fButtonCopy );
    }

    function SetButtonSave( $fValue )
    {
        $this->fButtonSave = $fValue;
    }
    function GetButtonSave()
    {
        return( $this->fButtonSave );
    }

    function SetButtonSaveAndClose( $fValue )
    {
        $this->fButtonSaveAndClose = $fValue;
    }
    function GetButtonSaveAndClose()
    {
        return( $this->fButtonSaveAndClose );
    }

    function SetButtonSaveAndNew( $fValue )
    {
        $this->fButtonSaveAndNew = $fValue;
    }
    function GetButtonSaveAndNew()
    {
        return( $this->fButtonSaveAndNew );
    }

    function SetButtonDelete( $fValue )
    {
        $this->fButtonDelete = $fValue;
    }
    function GetButtonDelete()
    {
        return( $this->fButtonDelete );
    }

    function SetButtonReset( $fValue )
    {
        $this->fButtonReset = $fValue;
    }
    function GetButtonReset()
    {
        return( $this->fButtonReset );
    }

    function SetButtonEdit( $fValue )
    {
        $this->fButtonEdit = $fValue;
    }
    function GetButtonEdit()
    {
        return( $this->fButtonEdit );
    }

    function SetButtonSub( $fValue )
    {
        $this->fButtonSub = $fValue;
    }
    function GetButtonSub()
    {
        return( $this->fButtonSub );
    }

    function SetButtonSend( $fValue )
    {
        $this->fButtonSend = $fValue;
    }
    function GetButtonSend()
    {
        return( $this->fButtonSend );
    }

    function SetButtonSendAdmin( $fValue )
    {
        $this->fButtonSendAdmin = $fValue;
    }
    function GetButtonSendAdmin()
    {
        return( $this->fButtonSendAdmin );
    }

    /** Fgt einen neuen zu parsenden Block ein.
        Dieser Block mu sich im ROW Bereich des Templates befinden.
        @param $sBlock Name des Blocks
        @return void
    */
    function AddBlockRow( $sBlock )
    {
        $this->oForm->AddBlock( $sBlock );
    }

    function SetLanguageContent( $iValue )
    {
        $this->iLanguageContent = $iValue;
    }

    function GetLanguageContent()
    {
        return( $this->iLanguageContent );
    }

    /** Liefert die Content Language, die verwendet wird, wenn ein Language-Karteireiter geklickt wurde.
        Wird zB. zur Sprachbestimmung von Kategorie-Listen bentigt.
        @param void
        @return int (ID)
    */
    function GetLanguageContentNew()
    {
        global $oApp;

        $iLanguageId = $this->GetLanguageContent();

        for( $i = 0; $i < $oApp->GetLanguageCount( true ); $i++ )
        {
            $iId = $oApp->GetLanguageIdByIndex( $i, true );

            if ( $this->oForm->IsSubmitted( 'action_language_' . $iId ) )
            {
                $iLanguageId = $iId;
                break;
            }
        }

        return( $iLanguageId );
    }
}
