<?php

defined( 'oPage' ) or die();

class CBack extends CControl
{
    var $sBackUrl;

    function CBack( $sName = 'back' )
    {
        $this->CControl( $sName );

        $this->AddParameterExclude( 'timezone' );
        $this->AddParameterExclude( 'datetime' );
    }

    function Copy( $oCopy = Null )
    {
        if ( !is_object( $oCopy ) )
        {
            $sClass = get_class( $this );
            $oCopy = new $sClass( '' );
        }
        $oCopy = CControl::Copy( $oCopy );

        $oCopy->sBackUrl = $this->sBackUrl;

        return( $oCopy );
    }

    function GetParameter()
    {
        global $oApp;
        $this->sBackUrl = $oApp->GetParameter( 'back' );
    }

    function GetBackUrl()
    {
        return( $this->sBackUrl );
    }

    function SetBackUrl( $sValue )
    {
        $this->sBackUrl = $sValue;
        return( true );
    }

    function OutputTpl( &$oTemplate, $sBlock = null, $sSub = null )
    {
        global $oApp;

        if ( $sBlock === null )
            $sBlock = 'main';

        $aVars = $oTemplate->GetVars();

        if ( !parent::OutputTpl( $oTemplate, $sBlock, $sSub ) )
            return( false );

        if ( $oApp->GetPrint() )
            return( true );

        $sUrl = $this->GetBackUrl();
        if ( $sUrl === null || $sUrl === '' )
            return( true );

        // If url is not absolute, make it absolute
        if ( $sUrl[ 0 ] != '/' && $sUrl[ 0 ] != '.' )
            $sUrl = $oApp->GetRoot() . $sUrl;

        $aParameter = array();
        HttpSplit2( $sUrl, $sUrl, $aParameter, $sAnchor, $oApp->GetQuerySeparator(), $oApp->GetParamSeparator() );

        // Nur bestimmte Felder einschlieen
        if ( $this->GetParameterInclude() != '' )
        {
            foreach( $aParameter as $sName => $sValue )
            {
                if ( !$this->IsParameterIncluded( $sName ) )
                {
                    unset( $aParameter[ $sName ] );
                }
            }
        }

        // Bestimmte Felder ausschlieen
        if ( $this->GetParameterExclude() != '' )
        {
            foreach( $aParameter as $sName => $sValue )
            {
                if ( $this->IsParameterExcluded( $sName ) )
                {
                    unset( $aParameter[ $sName ] );
                }
            }
        }

        // Alle leeren Felder ausschlieen
        foreach( $aParameter as $sName => $sValue )
            if ( IsNull( $aParameter[ $sName ] ) )
                unset( $aParameter[ $sName ] );

        $oTemplate->assign( 'back', $sUrl . HttpParam( $aParameter ) . $sAnchor );
        $oTemplate->assign( 'DATA.back', $sUrl . HttpParam( $aParameter, $oApp->GetQuerySeparator(), $oApp->GetParamSeparator() ) . $sAnchor );
        $oTemplate->parse( $sBlock . '.' . $this->GetName() );

        $oTemplate->SetVars( $aVars );
    }
}
