<?php

defined( 'oPage' ) or die();

/*
If field could not be validated:
    $sName . '.error'
    $sName . '.error#begin'
    $sName . '.error#end'
    $sName . '_error'

SELECT:
    $sValue = '':
        $sNameInForm . '_selected'
        $sNameInForm . '#selected'
    $sValue != '':
        $sNameInForm . '_selected_' . $sValue
        $sNameInForm . '#selected_' . $sValue

*/

class CForm extends CControl
{
    /** array of fields
    */
    var $aFields = array();

    var $aOnLoad = array();
    var $aOnSubmit = array();
    var $aBlocks = array();
    var $rCallback = Null;  // Referenz auf ein Objekt
    var $sCallback = Null;  // Funktionsname einer Methode
    var $aDefault = array(); // Default Values. Werden verwendet, wenn fr das Eingabefeld kein Wert vorhanden ist.

    /** Anzahl, wie oft das Formular wiederholt werden soll
        @default 0
    */
    var $iRows = 0;

    /** used to format date values
    */
    var $oDate;

    /** stores the last result of Validate()
        @default true
    */
    var $fValid = true;

    function CForm( $sName = 'form' )
    {
        global $oFactory;

        $this->CControl( $sName );

        $this->oDate = $oFactory->Date();

		$this->AddField( 'datetime', Null, Null, Null, Null, false );
		$this->AddField( 'timezone', Null, Null, Null, Null, false );
		$this->AddField( 'action' );
    }

    function Copy( $oCopy = Null )
    {
        if ( !is_object( $oCopy ) )
        {
            $sClass = get_class( $this );
            $oCopy = new $sClass( '' );
        }
        $oCopy = CControl::Copy( $oCopy );

        $oCopy->aFields = $this->aFields;
        $oCopy->aOnLoad = $this->aOnLoad;
        $oCopy->aOnSubmit = $this->aOnSubmit;
        $oCopy->aBlocks = $this->aBlocks;
        $oCopy->rCallback = $this->rCallback; // hier wird eine Referenz weitergegeben...
        $oCopy->sCallback = $this->sCallback;
        $oCopy->iRows = $this->iRows;
        $oCopy->fValid = $this->fValid;

        return( $oCopy );
    }

    function SetRows( $iValue = '' )
    {
        global $oApp;

        // Zeilenanzahl ermitteln und setzen
        if ( IsNull( $iValue ) )
		    $iValue = $oApp->GetParameter( $this->GetField( 'form_rows' ) );
        if ( IsNull( $iValue ) )
		    $iValue = 0;

        $this->iRows = $iValue;
    }

    function GetRows( $fDebug = false )
    {
        return( $this->iRows );
    }

    // Fgt alle Felder hinzu, die sName als Prefix haben
    function AddFields( $sName, $sType, $fNotEmpty = null, $fValidate = null, $fMultiple = null, $fPrefix = null, $fMultilanguage = null, $fReadonly = null )
    {
        global $oApp;

        $aParameter = $oApp->GetParameters();

        foreach( $aParameter as $sKey => $sValue )
        {
            if ( substr( $sKey, 0, strlen( $sName ) ) == $sName )
                $this->AddField( $sKey, $sType, $fNotEmpty, $fValidate, $fMultiple, $fPrefix, $fMultilanguage, $fReadonly );
        }
    }

    /** Fgt ein Feld in das Formular ein
    */
    function AddField( $sName, $sType = Null, $fNotEmpty = null, $fValidate = null, $fMultiple = null, $fPrefix = null, $fMultilanguage = null, $fReadonly = null )
    {
        if ( $sType === null )
            $sType = 'TEXT';
        if ( $fNotEmpty === null )
            $fNotEmpty = false;
        if ( $fValidate === null )
            $fValidate = false;
        if ( $fMultiple === null )
            $fMultiple = false;
        if ( $fPrefix === null )
            $fPrefix = true;
        if ( $fMultilanguage === null )
            $fMultilanguage = false;
        if ( $fReadonly === null )
            $fReadonly = false;

        // 2004.10.13 DOH: auskommentiert wg. Admin: In CModul wird AddField aufgerufen, in CDiscount nochmals wg. Select_Switch
        // if ( !$this->aFields[ $sName ] !== null )
        //    return;

		$aField = array();

        $aField[ 'name' ] = $sName;
        $aField[ 'notempty' ] = $fNotEmpty;
        $aField[ 'validate' ] = $fValidate;
        $aField[ 'multiple' ] = $fMultiple;
        $aField[ 'prefix' ] = $fPrefix;
        $aField[ 'multilanguage' ] = $fMultilanguage;
        $aField[ 'readonly' ] = $fReadonly;
        $aField[ 'trim' ] = true;

        // Error setzen
        if ( $fMultiple )
            $iRows = $this->GetRows();
        else
            $iRows = 1;
        $aError = array();
        for ( $i = 1; $i <= $iRows; $i++ )
            $aError[ $i ] = false;
        $aField[ 'error' ] = $aError;

		switch( $sType )
        {
            case 'CAPTCHA':
                $aField[ 'notempty' ] = true;
                $aField[ 'validate' ] = true;
            break;
        }

        $this->aFields[ $sName ] = $aField;
        $this->SetFieldType( $sName, $sType );
        $this->QueryField( $sName );

		switch( $sType )
        {
            case 'SELECT_SWITCH':
                $this->AddField( $sName . '_selected', 'SELECT', $fNotEmpty, $fValidate, $fMultiple, $fPrefix, $fMultilanguage );
                $this->AddField( $sName . '_free', 'SELECT', $fNotEmpty, $fValidate, $fMultiple, $fPrefix, $fMultilanguage );
            break;

            case 'CAPTCHA':
                $this->AddField( $sName . '_verify', null, true, true, $fMultiple, $fPrefix, $fMultilanguage );
            break;
        }
    }

    function SetFieldType( $sName, $sValue )
    {
		switch( $sValue )
        {
            case 'TEXT':
            break;

            case 'TEXTBOX':
            break;

            case 'IP':
            break;

            case 'YESNO':
            break;

            case 'TRISTATE':
            break;

            case 'CHECKBOX':
            break;

            case 'GENDER':
            case 'RADIO':
            break;

            case 'PASSWORD':
            break;

			case 'CREDITCARDNUMBER':
            break;

			case 'CREDITCARDDATE':
            break;

			case 'USERNAME':
            break;

			case 'EMAIL':
            break;

            case 'URL_TYP':
            break;

			case 'URL':
            break;

			case 'TARGET':
            break;

			case 'DATE':
            break;

			case 'TIME':
            break;

			case 'DATETIME':
            break;

		    case 'PERCENT':
            break;

            case 'ID':
            case 'NAME':
            case 'HIDDENID':
		    case 'INTEGER':
            break;

		    case 'FLOAT':
		    case 'REAL':
		    case 'DOUBLE':
		    case 'CURRENCY':
            break;

            case 'COUNTRY':
            case 'DISPLAY':
            case 'FOREIGNID':
            case 'FOREIGNNAME':
            case 'LANGUAGE':
            case 'SELECT':
            break;

            case 'SELECT_SWITCH':
            break;

            case 'FILE':
		    case 'IMAGE':
            case 'UPLOAD':
            break;

            case 'SUBMIT':
            case 'BUTTON':
            break;

            case 'CAPTCHA':
            break;

            default:
                die( "CForm: Ungltiger Feld-Typ: $sName=$sValue" );
            break;
        }

        $this->aFields[ $sName ][ 'type' ] = $sValue;

        return( true );
    }

    /** Damit kann berprft werden, ob ein Parameter geschickt wurde
        @param $sName Name eines Parameters
        @return true/false
    */
    function QueryIs( $sName, $i = 0 )
    {
        global $oApp;

        $sPostfix = '';
        if ( $this->aFields[ $sName ][ 'multiple' ] )
            $sPostfix = '_row' . $i;
        if ( $this->aFields[ $sName ][ 'type' ] == 'FILE'  || $this->aFields[ $sName ][ 'type' ] == 'IMAGE' || $this->aFields[ $sName ][ 'type' ] == 'UPLOAD' )
            $sPostfix .= '_old';

        return( $oApp->IsParameter( $this->GetField( $sName ) . $sPostfix ) );
    }

    /** Holt sich fr alle Formularfelder die Werte.
    */
    function QueryData()
    {
        foreach( $this->aFields as $sName => $aField )
            $this->QueryField( $sName );
    }

    /** Resets the field: clear the parameter and initialize the field value
        @param $sName name of the field
    */
    function ResetField( $sName )
    {
        global $oApp;

        // Referenz auf das Feld holen
        $aField =& $this->aFields[ $sName ];

        // Clear parameters
        if ( $aField[ 'multiple' ] )
            $iRows = $this->GetRows();
        else
            $iRows = 1;

        for ( $i = 1; $i <= $iRows; $i++ )
        {
            $sPostfix = '';

            if ( $aField[ 'multiple' ] )
                $sPostfix = '_row' . $i;

            $oApp->ClearParameter( $this->GetField( $sName ) . $sPostfix );

            if ( $aField[ 'type' ] == 'FILE' || $aField[ 'type' ] == 'IMAGE' || $aField[ 'type' ] == 'UPLOAD' )
            {
                $oApp->ClearParameter( $this->GetField( $sName ) . $sPostfix . '_old' );
                $oApp->ClearParameter( $this->GetField( $sName ) . $sPostfix . '_new' );
                $oApp->ClearParameter( $this->GetField( $sName ) . $sPostfix . '_new_width' );
                $oApp->ClearParameter( $this->GetField( $sName ) . $sPostfix . '_new_height' );
                $oApp->ClearParameter( $this->GetField( $sName ) . $sPostfix . '_type' );
                $oApp->ClearParameter( $this->GetField( $sName ) . $sPostfix . '_name' );
                $oApp->ClearParameter( $this->GetField( $sName ) . $sPostfix . '_size' );
                $oApp->ClearParameter( $this->GetField( $sName ) . $sPostfix . ':noresize' );
                $oApp->ClearParameter( $this->GetField( $sName ) . $sPostfix . '_delete' );
            }
        }

        // Initialize form value
        $this->QueryField( $sName );
    }

    /** Holt sich fr ein Formularfeld die Daten aus den Parametern
    */
    function QueryField( $sName )
    {
        global $oApp;

        // Referenz auf das Feld holen
        $aField =& $this->aFields[ $sName ];

        if ( $aField[ 'multiple' ] )
            $iRows = $this->GetRows();
        else
            $iRows = 1;

        $aValue = array();

        for ( $i = 1; $i <= $iRows; $i++ )
        {
            $sPostfix = '';

            if ( $aField[ 'multiple' ] )
                $sPostfix = '_row' . $i;

            if ( $aField[ 'readonly' ] == false && $oApp->IsParameter( $this->GetField( $sName ) . $sPostfix ) )
                $sValue = trim( $oApp->GetParameter( $this->GetField( $sName ) . $sPostfix ) );
            // don't use default values for submit buttons!
            elseif ( $this->GetType( $sName ) == 'SUBMIT' )
                $sValue = '';
            else
                // Default data is not formated!
                // format data here
                $sValue = trim( $this->FormatValue( $sName, $this->GetDefault( $sName ), false ) );

            if ( $aField[ 'type' ] == 'YESNO' )
            {
                $sValue = strtolower( $sValue );
                if ( $sValue != 'y' && $sValue != 'n' )
                    $sValue = 'n';
            }

            if ( $aField[ 'type' ] == 'TRISTATE' )
            {
                $sValue = strtolower( $sValue );
                if ( $sValue != 'y' && $sValue != 'n' && $sValue !== null && $sValue !== '' )
                    $sValue = 'n';
            }

            if ( $aField[ 'type' ] == 'FILE' || $aField[ 'type' ] == 'IMAGE' || $aField[ 'type' ] == 'UPLOAD' )
            {
                $aField[ 'upload_old' ][ $i ] = $oApp->GetParameter( $this->GetField( $sName )  . $sPostfix . '_old' );         // Alter Dateiname
                if ( $aField[ 'readonly' ] )
                {
                    unset( $aField[ 'upload_temp' ][ $i ] );
                    unset( $aField[ 'upload_new' ][ $i ] );
                    unset( $aField[ 'upload_new_width' ][ $i ] );
                    unset( $aField[ 'upload_new_height' ][ $i ] );
                    unset( $aField[ 'upload_type' ][ $i ] );
                    unset( $aField[ 'upload_name' ][ $i ] );
                    unset( $aField[ 'upload_size' ][ $i ] );
                    unset( $aField[ 'noresize' ][ $i ] );
                    unset( $aField[ 'upload_delete' ][ $i ]);
                }
                else
                {
                    if ( $oApp->IsParameter( $this->GetField( $sName ) . $sPostfix ) )
                    {
                        $aField[ 'upload_temp' ][ $i ] = $oApp->GetParameter( $this->GetField( $sName ) . $sPostfix );                  // Temporrer Dateiname
                        $aField[ 'upload_type' ][ $i ] = $oApp->GetParameter( $this->GetField( $sName ) . $sPostfix . '_type' );        // Dateityp
                        $aField[ 'upload_name' ][ $i ] = $oApp->GetParameter( $this->GetField( $sName ) . $sPostfix . '_name' );        // Name der Original-Datei
                        $aField[ 'upload_size' ][ $i ] = $oApp->GetParameter( $this->GetField( $sName ) . $sPostfix . '_size' );        // Dateigre in Byte
                        $aField[ 'noresize' ][ $i ] = $oApp->GetParameter( $this->GetField( $sName ) . $sPostfix . ':noresize' );
                    }
                    $aField[ 'upload_new' ][ $i ] = $oApp->GetParameter( $this->GetField( $sName )  . $sPostfix . '_new' );         // Neuer Dateiname vom Bildarchiv untergejubelt
                    $aField[ 'upload_new_width' ][ $i ] = $oApp->GetParameter( $this->GetField( $sName )  . $sPostfix . '_new_width' );          // Gewnschte Bildbreite (nur fr _new)
                    $aField[ 'upload_new_height' ][ $i ] = $oApp->GetParameter( $this->GetField( $sName )  . $sPostfix . '_new_height' );        // Gewnschte Bildhhe (nur fr _new)
                    $aField[ 'upload_delete' ][ $i ] = $oApp->GetParameter( $this->GetField( $sName ) . $sPostfix . '_delete' );    // Flag, ob der Upload beim Speichern gelscht werden soll
                }

                // Wenn wir kein Bild haben, dann das _old in den Value kopieren.
                if ( $aField[ 'upload_size' ][ $i ] == 0 )
                    $sValue = $aField[ 'upload_old' ][ $i ];

                // Wenn wir ein neues Bild haben, dann die Resize-Parameter bernehmen
                if ( !IsNull( $aField[ 'upload_new' ][ $i ] ) )
                {
                    if ( !IsNull( $aField[ 'upload_new_width' ][ $i ] ) || !IsNull( $aField[ 'upload_new_height' ][ $i ] ) )
                    {
                        $aField[ 'image_width' ] = $aField[ 'upload_new_width' ][ $i ];
                        $aField[ 'image_height' ] = $aField[ 'upload_new_height' ][ $i ];
                    }
                }

                // Auf dem Mac steht der volle Pfad in upload_name. Nur den Dateinamen extrahieren
                $aPath = pathinfo( $aField[ 'upload_name' ][ $i ] );
                $aField[ 'upload_name' ][ $i ] = $aPath[ 'basename' ];
                $aField[ 'upload_name#filename' ][ $i ] = basename( $aPath[ 'basename' ], '.' . $aPath[ 'extension' ] );
                $aField[ 'upload_name#extension' ][ $i ] = $aPath[ 'extension' ];
            }

            if ( $aField[ 'type' ] == 'CAPTCHA' )
            {
                if ( IsNull( $sValue ) )
                    $sValue = $this->CaptchaCreate();
            }

            $aValue[ $i ] = $sValue;
        }
        $aField[ 'value' ] = $aValue;
    }

    /** Liefert den Feldnamen inkl. Postfix und Prefix
    */
    function GetField( $sName )
    {
        if ( !isset( $this->aFields[ $sName ] ) || $this->GetFieldParameter( $sName, 'prefix' ) )
        {
            $sPrefix = $this->GetPrefix();
            if ( !IsNull( $sPrefix ) )
                $sName = $sPrefix . '_' . $sName;
        }

        $sPostfix = $this->GetPostfix();
        if ( !IsNull( $sPostfix ) )
            $sName .= '_' . $sPostfix;

        return( $sName );
    }

    function GetFieldsCount()
    {
        if ( !is_array( $this->aFields ) )
            return( 0 );

        return( count( $this->aFields ) );
    }

    function GetFieldnames()
    {
        $aFieldnames = array();

        foreach( $this->aFields as $sName => $aField )
        	$aFieldnames[] = $sName;

        return( $aFieldnames );
    }

    function GetError( $sName = null, $iRow = 1 )
    {
        if ( $sName !== null )
            return( $this->aFields[ $sName ][ 'error' ][ $iRow ] );

        foreach( $this->aFields as $aField )
            if ( $aField[ 'error' ][ $iRow ] )
                return( true );

        return( false );
    }

    function SetError( $sName, $fValue = true, $iRow = 1 )
    {
        $this->aFields[ $sName ][ 'error' ][ $iRow ] = $fValue;
    }

    function FormatValue( $sName, $sValue, $fGet = null )
    {
        global $oApp;
        global $oFactory;

        if ( $fGet === null )
            $fGet = true;

        $iLanguage = $oApp->GetLanguage();
		switch( $this->GetType( $sName ) )
        {
			case 'DATE':
			    switch( $iLanguage )
			    {
			        case 0:
			            if ( $fGet )
			            {
        			        $this->oDate->FromString( $sValue, 0 );
        			        $sValue = $this->oDate->Format( 3, null, true );
        			    }
        			    else
			            {
        			        $this->oDate->FromString( $sValue, 3 );
        			        $sValue = $this->oDate->Format( 0, null, true );
        			    }
		            break;

			        case 1:
                    default:
			            if ( $fGet )
			            {
        			        $this->oDate->FromString( $sValue, 3 );
        			        $sValue = $this->oDate->Format( 3, null, true );
                        }
        			    else
			            {
        			        $this->oDate->FromString( $sValue, 3 );
        			        $sValue = $this->oDate->Format( 3, null, true );
        			    }
		            break;
                }
				break;

			case 'DATETIME':
			    switch( $iLanguage )
			    {
			        case 0:
			            if ( $fGet )
			            {
        			        $this->oDate->FromString( $sValue, 2 );
        			        $sValue = $this->oDate->Format( 4, null, true );
        			    }
        			    else
        			    {
        			        $this->oDate->FromString( $sValue, 4 );
        			        $sValue = $this->oDate->Format( 2, null, true );
                        }
		            break;

			        case 1:
                    default:
			            if ( $fGet )
			            {
        			        $this->oDate->FromString( $sValue, 4 );
        			        $sValue = $this->oDate->Format( 4, null, true );
        			    }
        			    else
        			    {
        			        $this->oDate->FromString( $sValue, 4 );
        			        $sValue = $this->oDate->Format( 4, null, true );
                        }
		            break;
                }
				break;

            case 'YESNO':
                $sValue = strtolower( $sValue );
                if ( $sValue != 'y' && $sValue != 'n' )
                    $sValue = 'n';
            break;

            case 'TRISTATE':
                $sValue = strtolower( $sValue );
                if ( $sValue != 'y' && $sValue != 'n' && !IsNull( $sValue ) )
                    $sValue = 'n';
            break;

	        case 'FLOAT':
	        case 'REAL':
	        case 'CURRENCY':
	        case 'DOUBLE':
	            if ( $fGet )
    	            $sValue = str_replace( ',', '.', $sValue );
    	        else
    	            $sValue = str_replace( '.', ',', $sValue );
	            break;

	        case 'PERCENT':
	            if ( !IsNull( $sValue ) )
    	            if ( $fGet )
    	            {
        	            $sValue = str_replace( ',', '.', $sValue );
        	            $sValue = $sValue / 100;
        	        }
        	        else
        	        {
        	            $sValue = $sValue * 100;
        	            $sValue = str_replace( '.', ',', $sValue );
                    }
	            break;

	        case 'FILE':
	        case 'IMAGE':
	        case 'UPLOAD':
	            // if files have been uploaded to the server, but not processed by Upload() set value to null;
                if ( is_uploaded_file( $sValue ) )
    	            if ( $fGet )
                        $sValue = Null;
            break;

        }

        return( $sValue );
    }

    function GetValue( $sName, $iRow = null, $fFormat = null )
    {
        if ( $iRow === null )
            $iRow = 1;
        if ( $fFormat === null )
            $fFormat = true;

        $sValue = $this->aFields[ $sName ][ 'value' ][ $iRow ];

        // Wenn das Feld keinen Wert hat, dann den Wert des Syncmasters bernehmen
        if ( IsNull( $sValue ) )
            if ( $this->GetType( $sName ) != 'FILE' && $this->GetType( $sName ) != 'IMAGE' && $this->GetType( $sName ) != 'UPLOAD' )
            {
                $sSyncMaster = $this->GetSyncMaster( $sName );
                if ( $sSyncMaster !== null )
                    $sValue = $this->aFields[ $sSyncMaster ][ $this->GetSyncMasterValue( $sName ) ][ $iRow ];
            }

        // Im Formular wird nur mit formatierten Werten gearbeitet.
        // Da hier die Daten nach aussen gehen, mssen Sie zurckformatiert werden.
        if ( $fFormat )
            return( $this->FormatValue( $sName, $sValue ) );
        else
            return( $sValue );
    }

    function GetValueOption( $sName, $iRow = 1 )
    {
        $aOptions = $this->GetOptions( $sName );
        return( $aOptions[ $this->GetValue( $sName, $iRow ) ] );
    }

    function SetValue( $sName, $sValue, $iRow = 1 )
    {
        // Im Formular wird nur mit formatierten Werten gearbeitet.
        // Da hier die Daten von aussen kommen, werden diese hier formatiert.
        $this->aFields[ $sName ][ 'value' ][ $iRow ] = $this->FormatValue( $sName, $sValue, false );
    }

    function ClearValue( $sName, $iRow = 1 )
    {
        unset( $this->aFields[ $sName ][ 'value' ][ $iRow ] );
    }

	function GetValues( $fStripTags = null )
	{
	    if ( $fStripTags === null )
	        $fStripTags = false;

		$aValues = Array();
		foreach ( $this->aFields as $aField )
		{
			$aValues[ $aField[ 'name' ] ] = $this->GetValue( $aField[ 'name' ] );
			if ( $fStripTags )
			    $aValues[ $aField[ 'name' ] ] = strip_tags( $aValues[ $aField[ 'name' ] ] );
		}
		return( $aValues );
	}

	/** Setzt fr alle Multiple Felder die Werte
	    @param aValues Result Set einer DB Abfrage or a simple array of name/values
	*/
	function SetValues( $aValues )
	{
        $i = 0;

        if ( is_array( $aValues[ 1 ] ) )
        {
            // Alle angegeben Felder lschen
            foreach( $this->aFields as $sName => $aField )
                if ( $aField[ 'multiple' ] )
                    unset( $this->aFields[ $sName ][ 'value' ] );

            foreach( $aValues as $sKey => $aRow )
            {
                $i++;
                foreach( $this->aFields as $sName => $aField )
                    if ( $aField[ 'multiple' ] )
                        $this->SetValue( $sName, $aRow[ $sName ], $i );
            }
        }
        else
            // only set values for existing fields (will create empty fields else!!!)
            foreach( $this->aFields as $sName => $aField )
                if ( !$aField[ 'multiple' ] )
                    $this->SetValue( $sName, $aValues[ $sName ] );
	}

    function GetFieldParameter( $sName, $sParameter )
    {
        return( $this->aFields[ $sName ][ $sParameter ] );
    }

    function SetFieldParameter( $sName, $sParameter, $sValue )
    {
        $this->aFields[ $sName ][ $sParameter ] = $sValue;
    }

    function GetType( $sName )
    {
		return( $this->GetFieldParameter( $sName, 'type' ) );
    }

    function SetNotEmpty( $sName, $fValue = null )
    {
        if ( $fValue === null )
            $fValue = true;

        $this->SetFieldParameter( $sName, 'notempty', $fValue );
    }

    function SetValidate( $sName, $fValue = null )
    {
        if ( $fValue === null )
            $fValue = true;

        $this->SetFieldParameter( $sName, 'validate', $fValue );
    }

    function SetHidden( $sName, $fValue = null )
    {
        if ( $fValue === null )
            $fValue = true;

        $this->SetFieldParameter( $sName, 'hidden', $fValue );
    }
    function GetHidden( $sName )
    {
        return( $this->GetFieldParameter( $sName, 'hidden' ) );
    }

    function GetOptions( $sName )
    {
        return( $this->GetFieldParameter( $sName, 'options' ) );
    }
    function SetOptions( $sName, $aValues, $aStyles = null )
    {
        $this->SetFieldParameter( $sName, 'options', $aValues );
        $this->SetFieldParameter( $sName, 'styles', $aStyles );
    }

    function SetWidth( $sName, $sValue )
    {
        $this->SetFieldParameter( $sName, 'width', $sValue );
    }

    function SetHeight( $sName, $sValue )
    {
        $this->SetFieldParameter( $sName, 'height', $sValue );
    }

    function SetMaxlength( $sName, $sValue )
    {
        $this->SetFieldParameter( $sName, 'maxlength', $sValue );
    }

    function SetLimit( $sName, $sValue )
    {
        $this->SetFieldParameter( $sName, 'limit', $sValue );
    }

    function SetValueMin( $sName, $iValue )
    {
        $this->SetFieldParameter( $sName, 'value_min', $iValue );
    }

    function SetValueMax( $sName, $iValue )
    {
        $this->SetFieldParameter( $sName, 'value_max', $iValue );
    }

    /** Setzt einen Pfad, zb. fr einen Bildupload
        @param sName Feldname
        @param sValue Pfad (absolut zum Webroot)
        @return void
    */
    function SetUploadPath( $sName, $sValue )
    {
        $this->SetFieldParameter( $sName, 'upload_path', $sValue );
    }

    /** Liet den Wert des Pfades
        @param sName Feldname
        @return String Pfad absolut zum Webroot
    */
    function GetUploadPath( $sName )
    {
        return( $this->GetFieldParameter( $sName, 'upload_path' ) );
    }

    /** Setzt eine Dateinamens/Pfad Erweiterung, die dem Dateinamen automatisch vorne angehngt wird.
        @param sName Feldname
        @param sValue String
        @return void
    */
    function SetUploadPrefix( $sName, $sValue )
    {
        $this->SetFieldParameter( $sName, 'upload_prefix', $sValue );
    }

    /** Liet den Wert des Prefix
        @param sName Feldname
        @return String
    */
    function GetUploadPrefix( $sName )
    {
        return( $this->GetFieldParameter( $sName, 'upload_prefix' ) );
    }

    /** Setzt eine Dateinamens/Pfad Erweiterung, die dem Dateinamen automatisch hinten angehngt wird (vor der Extension)
        @param sName Feldname
        @param sValue String
        @return void
    */
    function SetUploadPostfix( $sName, $sValue )
    {
        $this->SetFieldParameter( $sName, 'upload_postfix', $sValue );
    }

    /** Liet den Wert des Postfix
        @param sName Feldname
        @return String
    */
    function GetUploadPostfix( $sName )
    {
        return( $this->GetFieldParameter( $sName, 'upload_postfix' ) );
    }

    /** Setzt die erlaubten Dateitypen
        @param sName Feldname
        @param sValue Dateitypen, mehrere durch '|' getrennt, zb. 'gif|jpg|jpeg'
        @return void
    */
    function SetUploadType( $sName, $sValue )
    {
        $this->SetFieldParameter( $sName, 'upload_type_allowed', $sValue );
    }

    /** Liet den Wert der erlaubten Dateitypen
        @param sName Feldname
        @return String Erlaubte Dateitypen
    */
    function GetUploadType( $sName )
    {
        return( $this->GetFieldParameter( $sName, 'upload_type_allowed' ) );
    }

    /** Setzt die erlaubte Dateigre
        @param sName Feldname
        @param sValue Dateigre in Byte
        @return void
    */
    function SetUploadMaxsize( $sName, $sValue )
    {
        $this->SetFieldParameter( $sName, 'upload_maxsize', $sValue );
    }

    /** Liet den Wert der erlaubten Dateigre
        @param sName Feldname
        @return String Erlaubte Dategre in Byte
    */
    function GetUploadMaxsize( $sName )
    {
        return( $this->GetFieldParameter( $sName, 'upload_maxsize' ) );
    }

    /** Setzt die Anzahl an Verzeichnisebenen, um zu viele Dateien in einem Verzeichnis zu vermeiden.
        @param sName Feldname
        @param iValue Levels
        @return void
    */
    function SetUploadLevel( $sName, $iValue )
    {
        $this->SetFieldParameter( $sName, 'upload_level', $iValue );
    }

    /** Liet den Wert fr die Verzeichnisebenen
        @param sName Feldname
        @return Integer
    */
    function GetUploadLevel( $sName )
    {
        return( $this->GetFieldParameter( $sName, 'upload_level' ) );
    }

    /** Image display width (width for displaying the image in the form)
        @param sName field anme
        @param sValue width in pixel
        @return void
    */
    function SetImageDisplayWidth( $sName, $sValue )
    {
        $this->SetFieldParameter( $sName, 'image_display_width', $sValue );
    }

    /** Legt fest, ob Bilder auch vergrert werden sollen
        @param sName Feldname
        @param fValue true/false
        @return void
    */
    function SetImageExact( $sName, $sValue )
    {
        $this->SetFieldParameter( $sName, 'image_exact', $fValue );
    }

    /** Liest den Wert, ob Bilder auch vergrert werden sollen
        @param sName Feldname
        @return true/false
    */
    function GetImageExact( $sName )
    {
        return( $this->GetFieldParameter( $sName, 'image_exact' ) );
    }

    /** Set image width/height mode
    	@param sName Feldname
    	@param iValue 0 normal, 1 min, 2 max
    	@return void
    */
    function SetImageMode( $sName, $iValue )
    {
        $this->SetFieldParameter( $sName, 'image_mode', $iValue );
    }

    /** Get image mode
        @param sName Feldname
        @return 0, 1 or 2
    */
    function GetImageMode( $sName )
    {
        return( $this->GetFieldParameter( $sName, 'image_mode' ) );
    }

    /** Legt die Qualitt der verlustbehafteter Komprimierung der Bilder fest.
        @param sName Feldname
        @param iValue bei JPG: 0-100
        @return void
    */
    function SetImageQuality( $sName, $iValue )
    {
        $this->SetFieldParameter( $sName, 'image_quality', $iValue );
    }

    /** Liest die Qualittsstufe der Bilder
        @param sName Feldname
        @return 0-100 oder Null.
    */
    function GetImageQuality( $sName )
    {
        return( $this->GetFieldParameter( $sName, 'image_quality' ) );
    }

    /** Setzt die Image-Breite
        @param sName Feldname
        @param sValue Breite in Pixel
        @return void
    */
    function SetImageWidth( $sName, $sValue )
    {
        $this->SetFieldParameter( $sName, 'image_width', $sValue );
    }

    /** Liet den Wert fr die Image-Breite
        @param sName Feldname
        @return Breite in Pixel
    */
    function GetImageWidth( $sName )
    {
        return( $this->GetFieldParameter( $sName, 'image_width' ) );
    }

    /** Setzt die Image-Hhe
        @param sName Feldname
        @param sValue Hhe in Pixel
        @return void
    */
    function SetImageHeight( $sName, $sValue )
    {
        $this->SetFieldParameter( $sName, 'image_height', $sValue );
    }

    /** Liet den Wert fr die Image-Hhe
        @param sName Feldname
        @return Hhe in Pixel
    */
    function GetImageHeight( $sName )
    {
        return( $this->GetFieldParameter( $sName, 'image_height' ) );
    }

    /** Fgt eine Validierungsfunktion (Regular Expression) hinzu, die erfllt sein mu
        @param $sName Name der Variable
        @param $sValue Validierungsfunktion
        @return void
    */
    function SetValidation( $sName, $sValue )
    {
        $this->SetFieldParameter( $sName, 'validation', $sValue );
    }

    /** Liefert die Validierungsfunktion
        @param $sName
        @return String
    */
    function GetValidation( $sName )
    {
        return( $this->GetFieldParameter( $sName, 'validation' ) );
    }

    /** Value should be trimed before validation
        @param $sName name of field
        @param $fValue true/false
        @return void
    */
    function SetTrim( $sName, $fValue )
    {
        $this->SetFieldParameter( $sName, 'trim', $fValue );
    }
    function GetTrim( $sName )
    {
        return( $this->GetFieldParameter( $sName, 'trim' ) );
    }

    /** Sets/Clears the disabled flag for a field
        @param $sName Name der Variable
        @param $fValue default true
        @return void
    */
    function SetDisabled( $sName, $fValue = true )
    {
        $this->SetFieldParameter( $sName, 'disabled', $fValue );
    }

    /** Checks if field is disabled
        @param $sName
        @return bool
    */
    function GetDisabled( $sName )
    {
        return( $this->GetFieldParameter( $sName, 'disabled' ) );
    }

    /** Setzt den SyncMaster fr das angegebene Feld
        GetValue liefert den Wert des SyncMaster Feldes zurck, wenn das Feld leer ist.
        @param sName Name des Feldes
        @param sMaster Name des Master-Feldes
        @param sValue Name of the $aField entry, which value is copied (eg. value, upload_name)
        @param bool $fStrict Sync the master field with the slave and ignore slave value, default null (false)
        @return void
    */
    function SetSyncMaster( $sName, $sMaster, $sValue = null, $fStrict = null  )
    {
        if ( $sValue === null )
        {
            $sValue = 'value';
        }

        if ( $fStrict === null )
        {
            $fStrict = false;
        }

        $this->SetFieldParameter( $sName, 'sync_master', $sMaster );
        $this->SetFieldParameter( $sName, 'sync_master_value', $sValue );
        $this->SetFieldParameter( $sName, 'sync_master_strict', $fStrict );
    }

    /** Liefert den SyncMaster
        @param $sName
        @return String
    */
    function GetSyncMaster( $sName )
    {
        return( $this->GetFieldParameter( $sName, 'sync_master' ) );
    }

    /** Liefert den SyncMaster default value
        @param $sName
        @return String
    */
    function GetSyncMasterValue( $sName )
    {
        return( $this->GetFieldParameter( $sName, 'sync_master_value' ) );
    }

    /**
     * Returns sync strict mode
     * @param string $sName Name of the field
     * @return bool
    */
    function GetSyncMasterStrict( $sName )
    {
        return( $this->GetFieldParameter( $sName, 'sync_master_strict' ) );
    }

    /** Used to force two fields to be equal (eg. password fields or email fields)
        @param sName name of main field
        @param sName2 name of other field
        @param sOperator fields comparison operator =, <, >, >=, <=, <>, !=
        @return void
    */
    function SetEqual( $sName, $sName2, $sOperator = null )
    {
        if ( $sOperator === null )
            $sOperator = '=';

        $aValue = $this->GetEqual( $sName, 'equal' );
        $aValue[ $sName2 ] = $sOperator;

        $this->SetFieldParameter( $sName, 'equal', $aValue );
    }

    /** Returns
        @param $sName
        @return Array
    */
    function GetEqual( $sName )
    {
        return( $this->GetFieldParameter( $sName, 'equal' ) );
    }

    /** Setzt einen Callback
        @param sName Feldname
        @param sValue Hhe in Pixel
        @return void
    */
    function SetCallback( &$rObject, $sFunction )
    {
        $this->rCallback = &$rObject;
        $this->sCallback = $sFunction;
    }

    function AddOnLoad( $sValue )
    {
        $this->aOnLoad[] = $sValue;
    }

    function GetOnLoad()
    {
        $sBuffer = '';
        foreach( $this->aOnLoad as $sValue )
            $sBuffer .= $sValue;
        return( $sBuffer );
    }

    function AddOnSubmit( $sValue )
    {
        $this->aOnSubmit[] = $sValue;
    }

    function GetOnSubmit()
    {
        $sBuffer = '';
        foreach( $this->aOnSubmit as $sValue )
            $sBuffer .= $sValue;
        return( $sBuffer );
    }

    /** Fgt den Namen eines zu parsenden Blocks hinzu
        @param $sValue Name eines Blocks
        @param $aValid Array mit IDs und true/false, ob der Block fr eine bestimmte Zeile geparst werden soll.
        @return void
    */
    function AddBlock( $sValue, $aValid = null )
    {
        $this->aBlocks[] = array
        (
            'block' => $sValue,
            'valid' => $aValid
        );
    }

    /** Checks, if a button has been clicked
        @param $sName name of the button
        @param $i row number, default null
        @return true/false
        @note It was not a good idea to name the default button submit, because this conflicts with the submit() method in the browser DOM. Better use action.
    */
    function IsSubmitted( $sName = 'submit', $i = null )
    {
        global $oApp;

        $sNameInForm = $this->GetField( $sName );
        if ( $i !== null )
            $sNameInForm .= '_row' . $i;

        if ( $this->GetValue( 'action' ) == $sName )
            return( true );

        if ( !IsNull( $this->GetValue( $sName ) ) )
            return( true );

        if ( !IsNull( $oApp->GetParameter( $sNameInForm ) ) )
            return( true );

        if ( !IsNull( $oApp->GetParameter( $sNameInForm . '_x' ) ) && !IsNull( $oApp->GetParameter( $sNameInForm . '_y' ) ) )
            return( true );

        return( false );
    }

    function Validate()
    {
        global $oApp;
        $fOk = true;

        foreach( $this->aFields as $sName => $aField )
        {
            if ( $aField[ 'multiple' ] )
                $iRows = $this->GetRows();
            else
                $iRows = 1;

            for( $i = 1; $i <= $iRows; $i++ )
            {
                $sValue = $aField[ 'value' ][ $i ];
                if ( $this->GetTrim( $sName ) )
                    $sValue = trim( $sValue );

                if ( $aField[ 'notempty' ] && IsNull( $sValue ) )
                    $aField[ 'error' ][ $i ] = true;

        		if ( $aField[ 'validate' ] )
        			switch( $aField[ 'type' ] )
        		    {
        		        case 'USERNAME':
        				    if ( !IsNull( $sValue ) )
            					if ( !preg_match( '/^([0-9a-z@\._-]+)$/i', $sValue ) )
            		                $aField[ 'error' ][ $i ] = true;
        					break;

        				case 'EMAIL':
        				    if ( StringValidateEmail( $sValue ) == false )
        				        $aField[ 'error' ][ $i ] = true;
        					break;

                        case 'URL':
        				    if ( !IsNull( $sValue ) )
            					if ( !preg_match( "/^([-!#\$%&'*+/0-9=?^_`a-z{|}~ ]+\\.)([a-z]{1,5})([-!#\$%&'*+/0-9=?^_`a-z{|}~ ])/i", $sValue ) )
            		                $aField[ 'error' ][ $i ] = true;
        					break;

        				case 'CREDITCARDNUMBER':
        				    if ( !IsNull( $sValue ) )
        				    {
        				        // Kreditkartennummer berprfen
                                if ( !CreditcardNumber( $sValue ) )
            		                $aField[ 'error' ][ $i ] = true;

                                // berprfen, ob die Nummer auch zur Firma pat
            		            if ( !IsNull( $aField[ 'creditcard_type' ] ) )
                                    if ( !CreditCardType( $this->GetValue( $aField[ 'creditcard_type' ], $i ), $sValue ) )
                		                $aField[ 'error' ][ $i ] = true;
            		        }
        					break;

        				case 'CREDITCARDDATE':
      				        // Format: MM/JJ
        				    if ( !IsNull( $sValue ) )
            					if ( !preg_match( "/^(0[1-9])|(1[0-2])+/+([0-9]){2}$/", $sValue ) )
            		                $aField[ 'error' ][ $i ] = true;
        					break;

        				case 'DATE':
        				    if ( !IsNull( $sValue ) )
        				    {
                			    switch( $oApp->GetLanguage() )
                			    {
                			        case 0:
                                		list( $sDay, $sMonth, $sYear ) = preg_split( "/([^0-9])/", $sValue );
            			            break;

                			        case 1:
                                    default:
                                		list( $sYear, $sMonth, $sDay ) = preg_split( "/([^0-9])/", $sValue );
            			            break;
                                }

                                $aField[ 'error' ][ $i ] = !checkdate( (int)$sMonth, (int)$sDay, (int)$sYear );

                                // If no error so far -> check min/max values
                                if ( $aField[ 'error' ][ $i ] == false )
                                {
                                    $iTime = $this->oDate->mktime( 0, 0, 0, (int)$sMonth, (int)$sDay, (int)$sYear );

                                    if ( !IsNull( $aField[ 'value_min' ] ) )
                                        if ( $iTime < $aField[ 'value_min' ] )
                                            $aField[ 'error' ][ $i ] = true;
                                    if ( !IsNull( $aField[ 'value_max' ] ) )
                                        if ( $iTime > $aField[ 'value_max' ] )
                                            $aField[ 'error' ][ $i ] = true;
                                }
        				    }
    					break;

        				case 'TIME':
        					break;

        				case 'DATETIME':
        					break;

                        case 'PERCENT':
        				    if ( !IsNull( $sValue ) )
        				    {
            					if ( !preg_match( "/^(\+|-)?[0-9]{1,3}((,|.)[0-9]+)?$/", $sValue ) )
            		                $aField[ 'error' ][ $i ] = true;
            		            if ( !IsNull( $aField[ 'value_min' ] ) )
            		                if ( $sValue < $aField[ 'value_min' ] )
                		                $aField[ 'error' ] = true;
            		            if ( !IsNull( $aField[ 'value_max' ] ) )
            		                if ( $sValue > $aField[ 'value_max' ] )
                		                $aField[ 'error' ][ $i ] = true;
            		        }
        					break;

                        case 'ID':
                        case 'HIDDENID':
                        case 'INTEGER':
        				    if ( !IsNull( $sValue ) )
        				    {
            					if ( !preg_match( "/^(\+|-)?[0-9]+$/", $sValue ) )
            		                $aField[ 'error' ][ $i ] = true;
            		            if ( !IsNull( $aField[ 'value_min' ] ) )
            		                if ( $sValue < $aField[ 'value_min' ] )
                		                $aField[ 'error' ][ $i ] = true;
            		            if ( !IsNull( $aField[ 'value_max' ] ) )
            		                if ( $sValue > $aField[ 'value_max' ] )
                		                $aField[ 'error' ][ $i ] = true;
                            }
        					break;

                        case 'FLOAT':
                        case 'REAL':
                        case 'CURRENCY':
                        case 'DOUBLE':
        				    if ( !IsNull( $sValue ) )
        				    {
            					if ( !preg_match( "/^(\+|-)?[0-9]+((,|.)[0-9]+)?$/", $sValue ) )
            		                $aField[ 'error' ][ $i ] = true;
            		            if ( !IsNull( $aField[ 'value_min' ] ) )
            		                if ( $sValue < $aField[ 'value_min' ] )
                		                $aField[ 'error' ] = true;
            		            if ( !IsNull( $aField[ 'value_max' ] ) )
            		                if ( $sValue > $aField[ 'value_max' ] )
                		                $aField[ 'error' ][ $i ] = true;
        					}
        					break;

        			    case 'FILE':
        			    case 'IMAGE':
        			    case 'UPLOAD':
        			        if ( !IsNull( $aField[ 'upload_name' ][ $i ] ) )
        			        {
                                // Dateierweiterung berprfen
                                if ( !IsNull( $aField[ 'upload_type_allowed' ] ) )
                                {
            			            $sExtension = Extension( $aField[ 'upload_name' ][ $i ] );

            			            $aExtension = explode( '|', $aField[ 'upload_type_allowed' ] );
            			            if ( !in_array( $sExtension, $aExtension ) )
            			                $aField[ 'error' ][ $i ] = true;
                                }

                                // Maximale Dateigre berprfen
        			            if ( !IsNull( $aField[ 'upload_maxsize' ] ) )
        			                if ( $aField[ 'upload_size'][ $i ] > $aField[ 'upload_maxsize' ] )
            			                $aField[ 'error' ][ $i ] = true;
        			        }
        			        break;

                        case 'CAPTCHA':
        				    if
        				    (
        				        IsNull( $sValue ) ||
        				        IsNull( $this->aFields[ $sName . '_verify' ][ 'value' ][ $i ] ) ||
        				        StringDecrypt( $sValue, $oApp->GetPassword() . date( 'Y-m-d' ) ) != $this->aFields[ $sName . '_verify' ][ 'value' ][ $i ]
        				    )
        				    {
        				        // create new captcha string
        				        $aField[ 'value' ][ $i ] = $this->CaptchaCreate();

        				        // reset verify value
                                $this->aFields[ $sName . '_verify' ][ 'value' ][ $i ] = null;

        				        // set error = true
                                $aField[ 'error' ][ $i ] = true;
                                $this->aFields[ $sName . '_verify' ][ 'error' ][ $i ] = true;
                            }
        					break;

        			    default:
        			        if ( !IsNull( $aField[ 'validation' ] ) )
            				    if ( !IsNull( $sValue ) )
                					if ( !preg_match( '/' . $aField[ 'validation' ] . '/', $sValue ) )
                		                $aField[ 'error' ][ $i ] = true;
        			        break;
        			}

        		// Wenn ein Fehler gefunden wurde, dann Feld zurckspeichern
                if ( $aField[ 'error' ][ $i ] == true )
                {
                    $fOk = false;
                    $this->aFields[ $sName ] = $aField;
                }
            }
        }

        foreach( array_keys( $this->aFields ) as $sName )
        {
            $aEqual = $this->GetEqual( $sName );

            if ( ArrayCount( $aEqual ) > 0 )
                foreach( $aEqual as $sEqual => $sOperator )
                    for( $i = 1; $i <= $iRows; $i++ )
                    {
                        $fError = false;
                        if ( !IsNull( $this->aFields[ $sName ][ 'value' ][ $i ] ) && !IsNull( $this->aFields[ $sEqual ][ 'value' ][ $i ] ) )
                            switch( $sOperator )
                            {
                                case '!=':
                                case '<>':
                                    if ( $this->aFields[ $sName ][ 'value' ][ $i ] == $this->aFields[ $sEqual ][ 'value' ][ $i ] )
                                        $fError = true;
                                break;

                                case '>':
                                    if ( $this->aFields[ $sName ][ 'value' ][ $i ] <= $this->aFields[ $sEqual ][ 'value' ][ $i ] )
                                        $fError = true;
                                break;

                                case '>=':
                                    if ( $this->aFields[ $sName ][ 'value' ][ $i ] < $this->aFields[ $sEqual ][ 'value' ][ $i ] )
                                        $fError = true;
                                break;

                                case '<':
                                    if ( $this->aFields[ $sName ][ 'value' ][ $i ] >= $this->aFields[ $sEqual ][ 'value' ][ $i ] )
                                        $fError = true;
                                break;

                                case '<=':
                                    if ( $this->aFields[ $sName ][ 'value' ][ $i ] > $this->aFields[ $sEqual ][ 'value' ][ $i ] )
                                        $fError = true;
                                break;

                                case '=':
                                default:
                                    if ( $this->aFields[ $sName ][ 'value' ][ $i ] != $this->aFields[ $sEqual ][ 'value' ][ $i ] )
                                        $fError = true;
                                break;
                            }

                        if ( $fError )
                        {
                            $this->aFields[ $sName ][ 'error' ][ $i ] = true;
                            $this->aFields[ $sEqual ][ 'error' ][ $i ] = true;
                            $fOk = false;
                        }
                    }
        }


        // store result internal for later use in output
        $this->fValid = $fOk;

        return( $fOk );
    }

    function Upload( $iRow = Null, $fCopy = false )
    {
        global $oApp;
        global $oFactory;
        global $oError;
        global $oResource;

        $fOk = true;

        foreach( $this->aFields as $sName => $aField )
        {
            if ( $aField[ 'type' ] == 'FILE' || $aField[ 'type' ] == 'IMAGE' || $aField[ 'type' ] == 'UPLOAD' )
            {
                if ( $aField[ 'multiple' ] )
                {
                    if ( $iRow === null )
                    {
                        $iRow = 1;
                        $iRows = $this->GetRows();
                    }
                    else
                    {
                        $iRows = $iRow;
                    }
                }
                else
                {
                    $iRow = 1;
                    $iRows = 1;
                }

                // 2010.03.31 DOH    Create path to file: file is either below static -> prepend with $sRoot, or is already an absolute path
                $sPath = $aField[ 'upload_path' ];
                if ( substr( $sPath, 0, 7 ) == 'static/' )
                    $sPath = $oApp->PathLink( $sPath );
                elseif ( substr( $sPath, 0, 5 ) == 'temp/' )
                    $sPath = $oApp->PathLink( $sPath );

                for( $i = $iRow; $i <= $iRows; $i++ )
                {
                    if ( is_uploaded_file( $aField[ 'value' ][ $i ] ) )
                    {
                        // if copy mode, the set old file name to null to avoid deleting the original file.
                        if ( $fCopy )
                            $aField[ 'upload_old' ][ $i ] = null;
                        if ( !FileUpload( $sPath, $aField[ 'value' ][ $i ], $aField[ 'upload_name' ][ $i ], $aField[ 'upload_old' ][ $i ], $aField[ 'upload_prefix' ], $aField[ 'upload_postfix' ], $aField[ 'upload_level' ] ) )
                        {
                            $this->aFields[ $sName ][ 'value' ][ $i ] = '';
                            $this->aFields[ $sName ][ 'error' ][ $i ] = true;
                            $fOk = false;
                        }
                        else
                        {
                            if ( $aField[ 'type' ] == 'IMAGE' )
                            {
                                $sExtension = strtolower( Extension( $aField[ 'value' ][ $i ] ) );
                                if ( $sExtension == 'gif' || $sExtension == 'jpg' || $sExtension == 'jpeg' || $sExtension == 'png' )
                                    $this->aFields[ $sName ][ 'value' ][ $i ] = $aField[ 'value' ][ $i ];
                                else
                                {
                                    // Create image class
                                    $oImage = $oFactory->Image();

                                    // Assign filename
                                    $oImage->SetFilename( $sPath . $aField[ 'value' ][ $i ] );
                                    $oImage->SetQuality( $aField[ 'image_quality' ] );

                                    // Create filename for new file
                                    $sTo = FileTemp( $sPath, 'jpg', $aField[ 'upload_prefix' ], $aField[ 'upload_postfix' ], $aField[ 'upload_level' ], false );

                                    // Convert image to jpg
                                    if ( $oImage->Convert( $sPath . $sTo ) )
                                    {
                                        unlink( $sPath . $aField[ 'value' ][ $i ] );
                                        $this->aFields[ $sName ][ 'value' ][ $i ] = $sTo;
                                    }
                                    else
                                    {
                                        if ( is_object( $oError ) && is_object( $oResource ) )
                                            $oError->Add( $oResource->Error( 'image_convert', $sPath . $aField[ 'value' ][ $i ], $sPath . $sTo ) );

                                        unlink( $sPath . $aField[ 'value' ][ $i ] );
                                        $this->aFields[ $sName ][ 'value' ][ $i ] = '';
                                        $this->aFields[ $sName ][ 'error' ][ $i ] = true;
                                        $fOk = false;
                                    }
                                }
                            }
                            else
                                $this->aFields[ $sName ][ 'value' ][ $i ] = $aField[ 'value' ][ $i ];
                        }
                    }
                    elseif ( !IsNull( $aField[ 'upload_delete' ][ $i ] ) && !IsNull( $aField[ 'value' ][ $i ] ) )
                    {
                        // Clear the value for the copy
                        if ( $fCopy )
                            $this->aFields[ $sName ][ 'value' ][ $i ] = '';
                        else
                        {
                            // Das File soll gelscht werden.
                            if ( !FileUploadDelete( $sPath, $aField[ 'value' ][ $i ] ) )
                            {
                                $aField[ 'error' ][ $i ] = true;
                                $fOk = false;
                            }
                            else
                                $this->aFields[ $sName ][ 'value' ][ $i ] = '';
                        }
                    }
                    elseif ( !IsNull( $aField[ 'upload_new' ][ $i ] ) )
                    {
                        $sFile = $oApp->PathLink( $aField[ 'upload_new' ][ $i ] );

                        // Aus dem Bildarchiv wird in upload_new der Dateiname eingetragen.
                        // Hier wird das Bild aus dem Bildarchiv kopiert.
                        if ( !FileUploadCopy( $sPath, '', $sFile, $aField[ 'upload_prefix' ], $aField[ 'upload_postfix' ], $aField[ 'upload_level' ] ) )
                        {
                            $aField[ 'error' ][ $i ] = true;
                            $fOk = false;
                        }
                        else
                        {
                            $this->aFields[ $sName ][ 'value' ][ $i ] = $sFile;
                            $aField[ 'value' ][ $i ] = $sFile;

                            // Set upload_temp to trigger resize
                            $this->aFields[ $sName ][ 'upload_temp' ][ $i ] = $this->aFields[ $sName ][ 'value' ][ $i ];
                        }
                    }
                    elseif ( $fCopy && !IsNull( $aField[ 'value' ][ $i ] ) )
                    {
                        // Wenn der Datensatz kopiert wird, mssen die Upload-Dateien ebenfalls kopiert werden.
                        if ( !FileUploadCopy( $sPath, $sPath, $aField[ 'value' ][ $i ], $aField[ 'upload_prefix' ], $aField[ 'upload_postfix' ], $aField[ 'upload_level' ] ) )
                        {
                            $aField[ 'error' ][ $i ] = true;
                            $fOk = false;
                        }
                        else
                            $this->aFields[ $sName ][ 'value' ][ $i ] = $aField[ 'value' ][ $i ];
                    }
                }
            }
        }

        // SyncMaster Werte bernehmen
        foreach( $this->aFields as $sName => $aField )
        {
            $sSyncMaster = $this->GetSyncMaster( $sName );
            $fSyncStrict = $this->GetSyncMasterStrict( $sName );

            if ( $sSyncMaster !== null )
            {
                if ( $aField[ 'multiple' ] )
                {
                    if ( $iRow === null )
                    {
                        $iRow = 1;
                        $iRows = $this->GetRows();
                    }
                    else
                    {
                        $iRows = $iRow;
                    }
                }
                else
                {
                    $iRow = 1;
                    $iRows = 1;
                }

                for( $i = $iRow; $i <= $iRows; $i++ )
                {
                    // Wenn das Feld keinen Wert hat, dann den Wert des Syncmasters bernehmen
                    $sValue = $aField[ 'value' ][ $i ];
                    if ( $fSyncStrict || IsNull( $sValue ) )
                    {
                        $sValue = $this->aFields[ $sSyncMaster ][ $this->GetSyncMasterValue( $sName ) ][ $i ];
                        if ( $aField[ 'type' ] == 'FILE'  || $aField[ 'type' ] == 'IMAGE' || $aField[ 'type' ] == 'UPLOAD' )
                        {
                            // Slave has no upload
                            if ( IsNull( $aField[ 'upload_temp' ][ $i ] ) )
                            {
                                // Master has value, master has new upload
                                if ( !IsNull( $sValue ) && !IsNull( $this->aFields[ $sSyncMaster ][ 'upload_temp' ][ $i ] ) )
                                {
                                    // 2010.03.31 DOH    Create path to file: file is either below static -> prepend with $sRoot, or is already an absolute path
                                    $sPath = $aField[ 'upload_path' ];
                                    if ( substr( $sPath, 0, strlen( 'static/' ) ) == 'static/' )
                                        $sPath = $oApp->PathLink( $sPath );

                                    // Upload-Datei kopiert
                                    if ( !FileUploadCopy( $sPath, $sPath, $sValue, $aField[ 'upload_prefix' ], $aField[ 'upload_postfix' ], $aField[ 'upload_level' ] ) )
                                    {
                                        $aField[ 'error' ][ $i ] = true;
                                        $fOk = false;
                                    }
                                    else
                                    {
                                        // Zustzlich noch Upload-Temp Wert bernehmen, um Resize vorzugauckeln,
                                        // da ein Upload stattgefunden hat
                                        $this->aFields[ $sName ][ 'upload_temp' ][ $i ] = $this->aFields[ $sSyncMaster ][ 'upload_temp' ][ $i ];
                                        $this->aFields[ $sName ][ 'value' ][ $i ] = $sValue;
                                    }
                                }
                                elseif ( !IsNull( $sValue ) && !IsNull( $this->aFields[ $sSyncMaster ][ 'upload_new' ][ $i ] ) )
                                {
                                    // 2010.03.31 DOH    Create path to file: file is either below static -> prepend with $sRoot, or is already an absolute path
                                    $sPath = $aField[ 'upload_new' ];
                                    if ( substr( $sPath, 0, strlen( 'static/' ) ) == 'static/' )
                                        $sPath = $oApp->PathLink( $sPath );

                                    // Upload-Datei kopiert
                                    if ( !FileUploadCopy( $sPath, $sPath, $sValue, $aField[ 'upload_prefix' ], $aField[ 'upload_postfix' ], $aField[ 'upload_level' ] ) )
                                    {
                                        $aField[ 'error' ][ $i ] = true;
                                        $fOk = false;
                                    }
                                    else
                                    {
                                        // Zustzlich noch Upload-Temp Wert bernehmen, um Resize vorzugauckeln,
                                        // da ein Upload stattgefunden hat
                                        $this->aFields[ $sName ][ 'upload_temp' ][ $i ] = $this->aFields[ $sSyncMaster ][ 'upload_new' ][ $i ];
                                        $this->aFields[ $sName ][ 'value' ][ $i ] = $sValue;
                                    }
                                }
                                elseif ( !IsNull( $this->aFields[ $sSyncMaster ][ 'upload_delete' ][ $i ] ) && !IsNull( $aField[ 'value' ][ $i ] ) )
                                {
                                    // Clear the value for the copy
                                    if ( $fCopy )
                                    {
                                        $this->aFields[ $sName ][ 'value' ][ $i ] = '';
                                    }
                                    else
                                    {
                                        // 2010.03.31 DOH    Create path to file: file is either below static -> prepend with $sRoot, or is already an absolute path
                                        $sPath = $aField[ 'upload_path' ];
                                        if ( substr( $sPath, 0, strlen( 'static/' ) ) == 'static/' )
                                            $sPath = $oApp->PathLink( $sPath );

                                        // Das File soll gelscht werden.
                                        if ( !FileUploadDelete( $sPath, $aField[ 'value' ][ $i ] ) )
                                        {
                                            $aField[ 'error' ][ $i ] = true;
                                            $fOk = false;
                                        }
                                        else
                                        {
                                            $this->aFields[ $sName ][ 'value' ][ $i ] = '';
                                        }
                                    }
                                }
                            }
                        }
                        else
                        {
                            if ( !IsNull( $sValue ) )
                            {
                                $this->aFields[ $sName ][ 'value' ][ $i ] = $sValue;
                            }
                        }
                    }
                }
            }
        }

        return( $fOk );
    }

    function Resize( $iRow = '' )
    {
        global $oApp;
        global $oError;
        global $oResource;
        global $oFactory;

        // Mode: 0 -> no resize
        if ( $oApp->GetFeature( 'ipage', 'resize' ) == 0 )
        {
            return( true );
        }

        // Create image class
        $oImage = $oFactory->Image();

        $fOk = true;

        foreach( $this->aFields as $sName => $aField )
        {
            if ( $this->aFields[ $sName ][ 'type' ] == 'IMAGE' && ( !IsNull( $aField[ 'image_width' ] ) || !IsNull( $aField[ 'image_height' ] ) ) )
            {
                // 2010.03.31 DOH    Create path to file: file is either below static -> prepend with $sRoot, or is already an absolute path
                $sPath = $aField[ 'upload_path' ];
                if ( substr( $sPath, 0, strlen( 'static/' ) ) == 'static/' )
                {
                    $sPath = $oApp->PathLink( $sPath );
                }

                if ( $aField[ 'multiple' ] )
                {
                    if ( $iRow === null )
                    {
                        $iRow = 1;
                        $iRows = $this->GetRows();
                    }
                    else
                    {
                        $iRows = $iRow;
                    }
                }
                else
                {
                    $iRow = 1;
                    $iRows = 1;
                }

                for( $i = $iRow; $i <= $iRows; $i++ )
                {
                    if ( !IsNull( $aField[ 'value' ][ $i ] ) && !IsNull( $aField[ 'upload_temp' ][ $i ] ) && $aField[ 'noresize' ][ $i ] != 'y' )
                    {
                        $oImage->SetFilename( $sPath . $aField[ 'value' ][ $i ] );
                        $oImage->SetQuality( $aField[ 'image_quality' ] );

                        if ( !$oImage->Resize( $aField[ 'image_width' ], $aField[ 'image_height' ], $aField[ 'image_exact' ], $aField[ 'image_mode' ] ) )
                        {
                            if ( is_object( $oError ) && is_object( $oResource ) )
                            {
                                $oError->Add( $oResource->Error( 'image_resize', $sPath . $aField[ 'value' ][ $i ] ) );
                            }

                            unlink( $sPath . $aField[ 'value' ][ $i ] );
                            $this->aFields[ $sName ][ 'value' ][ $i ] = '';
                            $this->aFields[ $sName ][ 'error' ][ $i ] = true;
                            $fOk = false;
                        }
                    }
                }
            }
        }

        return( $fOk );
    }

    function OutputTpl( &$oTemplate, $sBlock = null, $sSub = null )
    {
        if ( $sBlock === null )
            $sBlock = 'main';

        $aVars = $oTemplate->GetVars();

        if ( !parent::OutputTpl( $oTemplate, $sBlock, $sSub ) )
            return( false );

        $sName = $this->GetPrefix();
        if ( !IsNull( $sName ) )
            $sName .= '_';
        $sName .= 'form_rows';
        $oTemplate->assign( $sName, $this->GetRows() );
        $oTemplate->assign( 'name', $this->GetName() );
        $oTemplate->assign( 'postfix', $this->GetPostfix() );

        $oTemplate->parse( $sBlock . '.' . $this->GetName() . '#header' );

        // Parse block named error if last validation returned invalid
        if ( !$this->fValid )
            $oTemplate->parse( $sBlock . '.' . $this->GetName() . '.error' );

        $iRows = $this->GetRows();

        if ( $iRows == 0 )
            $this->OutputRow( $oTemplate, $sBlock . '.' . $this->GetName() );
        else
        {
            $aVarsX = $oTemplate->GetVars();
            for( $i = 1; $i <= $iRows; $i++ )
            {
                $oTemplate->SetVars( $aVarsX );
                $oTemplate->assign( 'row', 'row' . $i );
                $this->OutputRow( $oTemplate, $sBlock . '.' . $this->GetName() . '.ROW', $i );
            }

            // Zustzliche Blcke parsen
            foreach( $this->aBlocks as $aBlock )
            {
                if ( is_array( $aBlock[ 'valid' ] ) )
                    if ( IsKey( $aBlock[ 'valid' ], 1 ) )
                        if ( !$aBlock[ 'valid' ][ 1 ] )
                            continue;

                $oTemplate->parse( $sBlock . '.' . $this->GetName() . '.' . $aBlock[ 'block' ] );
            }

            $oTemplate->parse( $sBlock . '.' . $this->GetName() );
        }
        $oTemplate->parse( $sBlock . '.' . $this->GetName() . '#footer' );

        $oTemplate->SetVars( $aVars );
    }

    function OutputRow( &$oTemplate, $sBlock, $iRow = 1 )
    {
        global $oApp;
        global $oFactory;

//        global $i;

        $aValues = Array();

        // Zuerst alle Fehlermeldungen der Felder ausgeben
        foreach( $this->aFields as $sName => $aField )
        {
            if ( $aField[ 'multiple' ] )
                $i = $iRow;
            else
                $i = 1;

            // Fr mehrsprachige Felder die Variable multilanguage setzen
            if ( $aField[ 'multilanguage' ] && $oApp->GetLanguageCount( true ) > 1 )
                $oTemplate->assign( 'multilanguage', 'multilanguage' );
            else
                $oTemplate->assign( 'multilanguage', '' );

            if ( $aField[ 'error' ][ $i ] )
            {
                $oTemplate->parse( $sBlock . '.' . $sName . '.type=' . $this->GetType( $sName ) . '.error' );
                $oTemplate->parse( $sBlock . '.' . $sName . '.error' );
                $oTemplate->parse( $sBlock . '.' . $sName . '.error#begin' );
                $oTemplate->parse( $sBlock . '.' . $sName . '.error#end' );

                $oTemplate->Parse( $sBlock . '.' . $sName . '.empty.error' );
                $oTemplate->Parse( $sBlock . '.' . $sName . '.empty.error#begin' );
                $oTemplate->Parse( $sBlock . '.' . $sName . '.empty.error#end' );
                $oTemplate->parse( $sBlock . '.' . $sName . '#empty.error' );
                $oTemplate->parse( $sBlock . '.' . $sName . '#empty.error#begin' );
                $oTemplate->parse( $sBlock . '.' . $sName . '#empty.error#end' );

                $oTemplate->parse( $sBlock . '.' . $sName . '.notempty.error' );
                $oTemplate->parse( $sBlock . '.' . $sName . '.notempty.error#begin' );
                $oTemplate->parse( $sBlock . '.' . $sName . '.notempty.error#end' );
                $oTemplate->parse( $sBlock . '.' . $sName . '#notempty.errro' );
                $oTemplate->parse( $sBlock . '.' . $sName . '#notempty.errro#begin' );
                $oTemplate->parse( $sBlock . '.' . $sName . '#notempty.errro#end' );
            }
        }

        // Wenn wir mehr als eine Sprache haben, dann pro Feld einen eigenen Language Subblock ausfhren
        if ( $oApp->GetLanguageCount() > 1 )
            foreach( $this->aFields as $sName => $aField )
                $oTemplate->parse( $sBlock . '.' . $sName . '.language' );

        // Jetzt die Feldinhalte aufbereiten
        foreach( $this->aFields as $sName => $aField )
        {
            switch( $aField[ 'type' ] )
            {
                case 'SELECT_SWITCH':
                    // Aufteilung
                    $aValues = explode( ',', $aField[ 'value' ][ $iRow ] );
                    $aOptions = $this->GetOptions( $sName );
                    $aStyles = $this->GetFieldParameter( $sName, 'styles' );
    				$aSelected = Array();
    				$aFree = Array();
    				$iValue = '';
    				if ( is_array( $aOptions ) )
        				foreach( $aOptions as $iOption => $sOption )
        				{
        					if ( ArrayIsIn( $aValues, $iOption ) )
        					{
            				    if ( IsNull( $iValue ) )
            				        $iValue = $iOption;

        						$aSelected[ $iOption ] = $sOption;
        				    }
        					else
        						$aFree[ $iOption ] = $sOption;
        				}
    				$this->SetOptions( $sName, $aOptions );
    				$this->SetOptions( $sName . '_selected', $aSelected, $aStyles );
    				$this->SetOptions( $sName . '_free', $aFree, $aStyles );
    				$this->SetValue( $sName . '_selected', $iValue, $iRow );
                break;
            }
        }

        // Jetzt die Feldinhalte zuweisen
        foreach( $this->aFields as $sName => $aField )
        {
            if ( $aField[ 'multiple' ] )
                $i = $iRow;
            else
                $i = 1;

            $sBuffer = '';

            if ( $aField[ 'prefix' ] )
            {
                $sPrefix = $this->GetPrefix();
                if ( !IsNull( $sPrefix ) )
                    $sNameInForm = $sPrefix . '_' . $sName;
                else
                    $sNameInForm = $sName;
            }
            else
                $sNameInForm = $sName;

            // Value fr Callback setzen
            $aValues[ $sName ] = $aField[ 'value' ][ $i ];

            switch( $aField[ 'type' ] )
            {
                case 'CHECKBOX':
                    if ( !IsNull( $aField[ 'value' ][ $i ] ) )
                        $sBuffer = 'checked';
                    else
                        $sBuffer = '';
                break;

                case 'GENDER':
                case 'RADIO':
                    if ( IsNull( $aField[ 'value' ][ $i ] ) )
                    {
                        $oTemplate->assign( $sNameInForm . '_checked', 'checked' );
                        $oTemplate->assign( $sNameInForm . '#checked', 'checked' );
                    }
                    else
                    {
                        $oTemplate->assign( $sNameInForm . '_checked_' . $aField[ 'value' ][ $i ], 'checked' );
                        $oTemplate->assign( $sNameInForm . '#checked_' . $aField[ 'value' ][ $i ], 'checked' );
                    }
                break;

                case 'YESNO':
                    $oTemplate->assign( $sNameInForm . '#checked_' . $aField[ 'value' ][ $i ], 'checked' );
                    if ( $aField[ 'value' ][ $i ] == 'y' )
                        $sBuffer = 'checked';
                    else
                        $sBuffer = '';
                break;

                case 'COUNTRY':
                case 'DISPLAY':
                case 'LANGUAGE':
                case 'SELECT':
                case 'URL_TYP':
                case 'FOREIGNID':
                case 'FOREIGNNAME':
                case 'TRISTATE':
                    $sBuffer = $this->OutputSelect( $aField, $aField[ 'value' ][ $i ] );

                    // Fr eine Selectbox den korrekten Selected-Parameter definieren
                    $sValue = strip_tags( $aField[ 'value' ][ $i ] );
                    $sValue = str_replace( "\r", '', $sValue );
                    $sValue = str_replace( "\n", '', $sValue );
                    $sValue = str_replace( "\"", '', $sValue );
                    $sValue = str_replace( "'", '', $sValue );
                    $sValue = str_replace( ' ', '_', $sValue );

                    if ( $sValue == '' )
                    {
                        $oTemplate->assign( $sNameInForm . '_selected', 'selected="selected"' );
                        $oTemplate->assign( $sNameInForm . '#selected', 'selected="selected"' );
                    }
                    else
                    {
                        $oTemplate->assign( $sNameInForm . '_selected_' . $sValue, 'selected="selected"' );
                        $oTemplate->assign( $sNameInForm . '#selected_' . $sValue, 'selected="selected"' );
                    }

                    // String fr ausgewhlten Wert setzen
                    if ( is_array( $aField[ 'options' ] ) )
                    {
                        $iValue = $aField[ 'value' ][ $i ];
                        $sValue = $aField[ 'options' ][ $iValue ];
                        $oTemplate->assign( $sNameInForm . '_display', $sValue );

                        // Liste mit allen Options erzeugen
                        $sList = '';
                        foreach( $aField[ 'options' ] as $iKey => $sValue )
                            if ( is_array( $aField[ 'styles' ] ) )
                                $sList .= '<span style="' . $aField[ 'styles' ][ $iKey ] . '">' . $sValue . '</span><br>';
                            else
                                $sList .= $sValue . '<br>';
                        $oTemplate->assign( $sNameInForm . '_list', $sList );
                    }
                break;

                case 'IMAGE':
    	            // if files have been uploaded to the server, but not processed by Upload() set value to null;
                    if ( is_uploaded_file( $aField[ 'value' ][ $i ] ) )
                    {
                        $this->aFields[ $sName ][ 'value' ][ $i ] = Null;
                        $aField[ 'value' ][ $i ] = Null;
                    }

                    // assign image size
                    // 2010.03.31 DOH    Create path to file: file is either below static -> prepend with $sRoot, or is already an absolute path
                    $sPath = $aField[ 'upload_path' ];
                    if ( substr( $sPath, 0, strlen( 'static/' ) ) == 'static/' )
                        $sPath = $oApp->PathLink( $sPath );
                    $sBuffer = $sPath . $aField[ 'value' ][ $i ];
                    if ( !IsNull( $aField[ 'value' ][ $i ] ) && file_exists( $sBuffer ) )
                    {
                        $oTemplate->Assign( $sNameInForm . '#size', filesize( $sBuffer ) );
                        $oTemplate->Assign( $sNameInForm . '#extension', Extension( $sBuffer ) );
                        $aSize = GetImageSize( $sBuffer );
                        $oTemplate->Assign( $sNameInForm . '#imagewidth', $aSize[ 0 ] );
                        $oTemplate->Assign( $sNameInForm . '#imageheight', $aSize[ 1 ] );
                    }
                    else
                    {
                        $oTemplate->Assign( $sNameInForm . '#size', null );
                        $oTemplate->Assign( $sNameInForm . '#extension', null );
                        $oTemplate->Assign( $sNameInForm . '#imagewidth', 0 );
                        $oTemplate->Assign( $sNameInForm . '#imageheight', 0 );
                    }

                    $sBuffer = htmlspecialchars( $aField[ 'value' ][ $i ] );
                break;

                case 'FILE':
                case 'UPLOAD':
    	            // if files have been uploaded to the server, but not processed by Upload() set value to null;
                    if ( is_uploaded_file( $aField[ 'value' ][ $i ] ) )
                    {
                        $this->aFields[ $sName ][ 'value' ][ $i ] = Null;
                        $aField[ 'value' ][ $i ] = Null;
                    }

                    // 2010.03.31 DOH    Create path to file: file is either below static -> prepend with $sRoot, or is already an absolute path
                    $sPath = $aField[ 'upload_path' ];
                    if ( substr( $sPath, 0, strlen( 'static/' ) ) == 'static/' )
                        $sPath = $oApp->PathLink( $sPath );
                    $sBuffer = $sPath . $aField[ 'value' ][ $i ];
                    if ( !IsNull( $aField[ 'value' ][ $i ] ) && file_exists( $sBuffer ) )
                        $oTemplate->assign( $sNameInForm . '#size', filesize( $sBuffer ) );
                    else
                        $oTemplate->assign( $sNameInForm . '#size', null );

                    $sBuffer = htmlspecialchars( $aField[ 'value' ][ $i ] );
                break;

                case 'TEXTBOX':
                    $oTemplate->assign( $sNameInForm . '#editor', str_replace( array( chr( 10 ), chr( 13 ) ), '', $aField[ 'value' ][ $i ] ) );
					$sBuffer = htmlspecialchars( $aField[ 'value' ][ $i ] );
                break;

                default:
					$sBuffer = htmlspecialchars( $aField[ 'value' ][ $i ] );
                break;
            }
            $oTemplate->assign( $sNameInForm . '#value', $aField[ 'value' ][ $i ] );
            $oTemplate->assign( $sNameInForm, $sBuffer );

            // Feldinhalt aufbereiten
    	    $sValue = $aValues[ $sName ];

            // Feldparameter eintragen
            foreach( $aField as $sParameter => $sValue )
            {
                $oTemplate->assign( $sNameInForm . '#' . $sParameter, $sValue );
            }

            if ( $aField[ 'disabled' ] )
                $oTemplate->assign( $sNameInForm . '#disabled', 'disabled="disabled"' );
            else
                $oTemplate->assign( $sNameInForm . '#disabled', '' );

            if ( $aField[ 'limit' ] > 0 )
            {
                $sBuffer = substr( strip_tags( $aField[ 'value' ][ $i ] ), 0, $aField[ 'limit' ] );
                $oTemplate->assign( $sNameInForm . '#limited', $sBuffer );
            }
            else
            {
                $oTemplate->assign( $sNameInForm . '#limited', $aField[ 'value' ][ $i ] );
            }
        }

        // Jetzt die Feldinhalte ausgeben
        foreach( $this->aFields as $sName => $aField )
        {
            if ( $aField[ 'multiple' ] )
                $i = $iRow;
            else
                $i = 1;

            // Fr mehrsprachige Felder die Variable multilanguage setzen
            if ( $aField[ 'multilanguage' ] && $oApp->GetLanguageCount( true ) > 1 )
                $oTemplate->assign( 'multilanguage', 'multilanguage' );
            else
                $oTemplate->assign( 'multilanguage', '' );

    		switch( $this->GetType( $sName ) )
            {
                case 'YESNO':
                    if ( $aField[ 'value' ][ $i ] == 'y' )
                    {
                        $oTemplate->parse( $sBlock . '.' . $sName . '#yes#begin' );
                        $oTemplate->parse( $sBlock . '.' . $sName . '#yes' );
                        $oTemplate->parse( $sBlock . '.' . $sName . '#yes#end' );
                    }
                    else
                    {
                        $oTemplate->parse( $sBlock . '.' . $sName . '#no#begin' );
                        $oTemplate->parse( $sBlock . '.' . $sName . '#no' );
                        $oTemplate->parse( $sBlock . '.' . $sName . '#no#end' );
                    }
                break;

                case 'IMAGE':
                    if ( !IsNull( $aField[ 'image_width' ] ) || !IsNull( $aField[ 'image_height' ] ) )
                        $oTemplate->parse( $sBlock . '.' . $sName . '.noresize' );
                break;
            }

            if ( IsNull( $aField[ 'value' ][ $i ] ) )
            {
                $oTemplate->parse( $sBlock . '.' . $sName . '.empty' );
                $oTemplate->parse( $sBlock . '.' . $sName . '#empty' );
            }
            else
            {
                $oTemplate->parse( $sBlock . '.' . $sName . '.notempty' );
                $oTemplate->parse( $sBlock . '.' . $sName . '#notempty' );
            }

            if ( $aField[ 'notempty' ] )
            {
                $oTemplate->parse( $sBlock . '.' . $sName . '#title.must' );
                $oTemplate->parse( $sBlock . '.' . $sName . '#header.must' );
                $oTemplate->parse( $sBlock . '.' . $sName . '#footer.must' );
                $oTemplate->parse( $sBlock . '.' . $sName . '#begin.must' );
                $oTemplate->parse( $sBlock . '.' . $sName . '#end.must' );
                $oTemplate->parse( $sBlock . '.' . $sName . '.must' );
            }

            $oTemplate->parse( $sBlock . '.' . $sName . '.type=' . $this->GetType( $sName ) );

            $oTemplate->parse( $sBlock . '.' . $sName . '.title' );
            $oTemplate->parse( $sBlock . '.' . $sName . '#title' );
            $oTemplate->parse( $sBlock . '.' . $sName . '#header' );
            $oTemplate->parse( $sBlock . '.' . $sName . '#footer' );
            $oTemplate->parse( $sBlock . '.' . $sName . '#begin' );
            $oTemplate->parse( $sBlock . '.' . $sName . '#end' );
            $oTemplate->parse( $sBlock . '.' . $sName );
        }

        // Zustzliche Blcke parsen
        foreach( $this->aBlocks as $aBlock )
        {
            $i = $iRow;

            if ( is_array( $aBlock[ 'valid' ] ) )
                if ( IsKey( $aBlock[ 'valid' ], $i ) )
                    if ( !$aBlock[ 'valid' ][ $i ] )
                        continue;

            $oTemplate->parse( $sBlock . '.' . $aBlock[ 'block' ] );
        }

        // Callback
        if ( is_object( $this->rCallback ) )
        {
            $rObject =& $this->rCallback;
            $sFunction = $this->sCallback;
            $rObject->$sFunction( $aValues, $oTemplate, $sBlock, $iRow );
        }

        // OnSubmit setzen
        $oTemplate->assign( 'onsubmit', $this->GetOnSubmit() );

        $oTemplate->parse( $sBlock );
    }

    function OutputSelect( $aField, $sDefault )
    {
        $fSelected = false;

        $aOptions = $aField[ 'options' ];

        $sBuffer = '';
        if ( is_array( $aOptions ) )
        {
	        foreach( $aOptions as $sValue => $sOption )
    	    {
        		if ( strcmp( $sDefault, $sValue ) == 0 && !$fSelected )
        		{
        		    $fSelected = true;
        			$sSelected = ' selected="selected"';
        	    }
        		else
                {
    	    		$sSelected = '';
                }

                $sOption = str_replace( '&', '&amp;', strip_tags( $sOption ) );
      		    $sBuffer .= '<option value="' . $sValue . '" title="' . $sOption . '"' . $sSelected . '>' . $sOption . '</option>' . "\n";
            }
    	}

    	return( $sBuffer );
    }

    function SetDefaultData( $aValue )
    {
        if ( is_array( $aValue ) )
            $this->aDefault = $aValue;
        else
            $this->aDefault = array();
    }

    function SetDefault( $sName, $sValue )
    {
        $this->aDefault[ $sName ] = $sValue;
    }
    function GetDefault( $sName )
    {
        return( $this->aDefault[ $sName ] );
    }

    function CaptchaCreate()
    {
        global $oApp;

        // Create Captcha
        $sChars  = 'abcdefghijkmnpqrstuwxyz';   // Kein o und kein l
        $sChars .= 'ABCDEFGHJKLMNPQRSTUWXYZ';   // Kein O und kein I
        $sChars .= '23456789';                  // Keine 0 und keine 1

        // Zufallszahlengenerator initialisieren
        mt_srand( (double)microtime() * 1000000 );

        $sValue = '';
        $iCharsLength = strlen( $sChars ) - 1;
        for( $j = 0; $j < 5; ++$j )
            $sValue .= $sChars[ mt_rand( 0, $iCharsLength ) ];

        $sValue = StringEncrypt( $sValue, $oApp->GetPassword() . date( 'Y-m-d' ) );

        return( $sValue );
    }
}
