<?php

defined( 'oPage' ) or die();

include_once $sRoot . 'include/email/class.phpmailer.php';

class CMail extends CControl
{
    var $oEmail;
    var $aValues;

    /** Email PGP verschlsseln
        @default false
    */
    var $fPgp = false;

    /** PGP User mit dem verschlsselt werden soll
        @default = '';
    */
    var $sPgpUser = '';

    /** E-Mail auch an Empfnger aus dem Template verschicken
        @default true
    */
    var $fRecipientsFromTemplate = true;

    /** Absender-E-Mail Adresse aus Template ermitteln
        @default true
    */
    var $fFromFromTemplate = true;

    /** Modul which will be outputed within the email
        @default null
    */
    var $oModul = null;

    function CMail( $sName = 'mail' )
    {
        global $oParameter;
        global $oApp;

        $this->CControl( $sName );
    $this->oEmail = new PhpMailer();
        $this->oEmail->PluginDir = $oApp->Pathlink( 'include/email/' );
        $this->oEmail->SetLanguage( $oApp->GetLanguageShortText(), $oApp->Pathlink( 'include/email/language/' ) );
        $this->oEmail->CharSet = $oApp->GetCharset();

        $this->SetTimeout( 45 );

        // Mailsystem setzen
        // Default: ber SMTP Server versenden
        switch( MAIL_SERVER )
        {
            case 'type:mail':
                $this->SetMail();
            break;

            case 'type:sendmail':
                $this->SetSendmail();
                $sSendmail = $oApp->GetCommand( 'cmd_sendmail' );
                if ( !IsNull( $sSendmail ) )
                    $this->oEmail->Sendmail = $sSendmail;
            break;

            default:
                $this->SetSmtp( MAIL_SERVER );
            break;
        }
    }

    function Copy( $oCopy = Null )
    {
        if ( !is_object( $oCopy ) )
        {
            $sClass = get_class( $this );
            $oCopy = new $sClass( '' );
        }
        $oCopy = parent::Copy( $oCopy );

        // Hier wird nur eine Referenz weitergegeben! Eigentlich sollte der Copy-Constructor aufgerufen werden, aber dann mte man die fremde Klasse modifizieren...
        $oCopy->oEmail = $this->oEmail;
        $oCopy->aValues = $this->aValues;
        $oCopy->fPgp = $this->fPgp;
        $oCopy->fRecipientsFromTemplate = $this->fRecipientsFromTemplate;
        $oCopy->fFromFromTemplate = $this->fFromFromTemplate;
        $oCopy->oModul = $this->oModul;

        return( $oCopy );
    }

    // $sValue: Name der SMTP Server "host1;host2"
    function SetSmtp( $sValue )
    {
        $this->oEmail->IsSMTP();        // set mailer to use SMTP
        $this->oEmail->Host = $sValue;  // specify main and backup server
    }

    // Statt SMTP -> PHP mail() verwenden
    function SetMail()
    {
        $this->oEmail->IsMail();
    }

    // Statt SMTP -> Sendmail direkt verwenden
    function SetSendmail()
    {
        $this->oEmail->IsSendmail();
    }

    function SetHtml( $fValue = Null )
    {
        if ( $fValue === null )
            $fValue = true;
        $this->oEmail->IsHTML( $fValue );
    }

    function SetPgp( $fValue )
    {
        $this->fPgp = $fValue;
    }
    function GetPgp()
    {
        return( $this->fPgp );
    }

    function SetPgpUser( $sValue )
    {
        $this->sPgpUser = $sValue;
    }
    function GetPgpUser()
    {
        return( $this->sPgpUser );
    }

    function SetRecipientsFromTemplate( $fValue )
    {
        $this->fRecipientsFromTemplate = $fValue;
    }
    function GetRecipientsFromTemplate()
    {
        return( $this->fRecipientsFromTemplate );
    }

    function SetFromFromTemplate( $fValue )
    {
        $this->fFromFromTemplate = $fValue;
    }
    function GetFromFromTemplate()
    {
        return( $this->fFromFromTemplate );
    }

    function SetModul( &$oModul )
    {
        $this->oModul = &$oModul;
    }
    function &GetModul()
    {
        $oModul = &$this->oModul;
        return( $oModul );
    }

    function SetFrom( $sEmail, $sName = '' )
    {
        $this->oEmail->From = $sEmail;
        $this->oEmail->FromName = $sName;
    }

    function IsFrom()
    {
        return( $this->oEmail->From != '' );
    }

    function SetTo( $sEmail, $sName = '' )
    {
        $this->oEmail->AddAddress( $sEmail, $sName );
    }

    function IsTo()
    {
        return( count( $this->oEmail->to ) > 0 );
    }

    // Does not work with type:mail!
    function SetCc( $sEmail, $sName = '' )
    {
        if ( $this->oEmail->Mailer == 'mail' )
            $this->SetTo( $sEmail, $sName );
        else
            $this->oEmail->AddCC( $sEmail, $sName );
    }

    function IsCC()
    {
        return( count( $this->oEmail->cc ) > 0 );
    }

    // Does not work with type:mail!
    function SetBcc( $sEmail, $sName = '' )
    {
        if ( $this->oEmail->Mailer == 'mail' )
            $this->SetTo( $sEmail, $sName );
        else
            $this->oEmail->AddBCC( $sEmail, $sName );
    }

    function IsBCC()
    {
        return( count( $this->oEmail->bcc ) > 0 );
    }

    function SetSubject( $sSubject )
    {
        $this->oEmail->Subject = $sSubject;
    }

    function GetSubject()
    {
        return( $this->oEmail->Subject );
    }

    function SetValues( $aValues )
    {
        $this->aValues = $aValues;
    }

    function GetValues()
    {
        return( $this->aValues );
    }

    function AddAttachment( $sPath, $sName = '', $sEncoding = 'base64', $sType = 'application/octet-stream' )
    {
        return( $this->oEmail->AddAttachment( $sPath, $sName, $sEncoding, $sType ) );
    }

    function AddStringAttachment( $sBuffer, $sName, $sEncoding = 'base64', $sType = 'application/octet-stream' )
    {
        return( $this->oEmail->AddStringAttachment( $sBuffer, $sName, $sEncoding, $sType ) );
    }

    /** Send an email.
        @param $sTemplate main template (text or html)
        @param $sTemplate2 extra template (text only)
        @param $sBlockAdditional additional block e.g. main.tracking
    */
    function Send( $sTemplate, $sTemplate2 = null, $sBlockAdditional = null )
    {
        global $oFactory;

        $oTemplate = $oFactory->Template( $sTemplate );
        if ( $sTemplate2 !== null )
            $oTemplate2 = $oFactory->Template( $sTemplate2 );
        else
            $oTemplate2 = null;

        return( $this->SendTpl( $oTemplate, $oTemplate2, $sBlockAdditional ) );
    }

    /** Send an email.
        @param $oTemplate main template (text or html)
        @param $oTemplate2 extra template (text only)
        @param $sBlockAdditional additional block e.g. main.tracking
    */
    function SendTpl( $oTemplate, $oTemplate2 = null, $sBlockAdditional = null )
    {
        global $oApp;
        global $oParameter;

        // set subject
        if ( IsNull( $this->GetSubject() ) )
        {
            $this->OutputTpl( $oTemplate, 'subject' );
            $oTemplate->parse( 'subject' );
            $sBuffer = $oTemplate->text( 'subject' );
            $this->SetSubject( $sBuffer );
        }

        // set from
        if ( !$this->IsFrom() && is_object( $this->oModul ) )
            $this->SetFrom( $this->oModul->GetEmailFrom(), $this->oModul->GetEmailFromName() );
        if ( $this->GetFromFromTemplate() )
        {
            $this->OutputTpl( $oTemplate, 'from' );
            $oTemplate->Parse( 'from' );
            $sBuffer = $oTemplate->Text( 'from' );
            if ( !IsNull( $sBuffer ) )
            {
                $aFroms = explode( ';', $sBuffer );
                foreach( $aFroms as $sFrom )
                {
                    $aFrom = explode( '|', $sFrom );
                  $this->SetFrom( $aFrom[ 0 ], $aFrom[ 1 ] );
                }
            }
        }

        // set to
        if ( !$this->IsTo() && !$this->IsCC() && !$this->IsBCC() && is_object( $this->oModul ) )
            $this->SetTo( $this->oModul->GetEmailAdmin(), $this->oModul->GetEmailAdminName() );
        if ( $this->GetRecipientsFromTemplate() )
        {
            $this->OutputTpl( $oTemplate, 'recipients' );
            $oTemplate->Parse( 'recipients' );
            $sBuffer = $oTemplate->Text( 'recipients' );
            if ( !IsNull( $sBuffer ) )
            {
                $aRecipients = explode( ';', $sBuffer );
                foreach( $aRecipients as $sRecipient )
                {
                    $aRecipient = explode( '|', $sRecipient );
                  $this->SetTo( $aRecipient[ 0 ], $aRecipient[ 1 ] );
                }
            }

            $this->OutputTpl( $oTemplate, 'recipients_cc' );
            $oTemplate->Parse( 'recipients_cc' );
            $sBuffer = $oTemplate->Text( 'recipients_cc' );
            if ( !IsNull( $sBuffer ) )
            {
                $aRecipients = explode( ';', $sBuffer );
                foreach( $aRecipients as $sRecipient )
                {
                    $aRecipient = explode( '|', $sRecipient );
                  $this->SetCc( $aRecipient[ 0 ], $aRecipient[ 1 ] );
                }
            }

            $this->OutputTpl( $oTemplate, 'recipients_bcc' );
            $oTemplate->Parse( 'recipients_bcc' );
            $sBuffer = $oTemplate->Text( 'recipients_bcc' );
            if ( !IsNull( $sBuffer ) )
            {
                $aRecipients = explode( ';', $sBuffer );
                foreach( $aRecipients as $sRecipient )
                {
                    $aRecipient = explode( '|', $sRecipient );
                  $this->SetBcc( $aRecipient[ 0 ], $aRecipient[ 1 ] );
                }
            }
        }

        // Parse additional block
        if ( $sBlockAdditional !== '' && $sBlockAdditional !== null )
            if ( $oTemplate->IsBlock( 'main.' . $sBlockAdditional ) )
            {
                $this->OutputTpl( $oTemplate, 'main.' . $sBlockAdditional );
                $oTemplate->Parse( 'main.' . $sBlockAdditional );
            }

        // Set main body
        $this->OutputTpl( $oTemplate );
        $oTemplate->Parse();
        $sBuffer = $oTemplate->Text();

        if ( $this->GetPgp() )
            $sBuffer = $this->PGPEncrypt( $sBuffer );
        $this->oEmail->Body = $sBuffer;

        // Add attachment (if in template)
        if ( $oTemplate->IsBlock( 'attachment' ) )
        {
            $oTemplate->Parse( 'attachment.filename' );
            $sFilename = $oTemplate->Text( 'attachment.filename' );
            $oTemplate->Reset( 'attachment.filename' );

            if ( $oTemplate->IsBlock( 'attachment.mail' ) )
            {
                $this->OutputTpl( $oTemplate, 'attachment' );
                $sBuffer = $oTemplate->Text( 'attachment.mail' );
                $this->AddStringAttachment( $sBuffer, $sFilename );
            }
            elseif ( $oTemplate->IsBlock( 'attachment.file' ) )
            {
                $oTemplate->Parse( 'attachment.file' );
                $sFile = $oTemplate->Text( 'attachment.file' );
                $this->AddAttachment( $oApp->Pathlink( $sFile ), $sFilename );
            }
        }

        // Set alternative body
        if ( is_object( $oTemplate2 ) )
        {
            $this->OutputTpl( $oTemplate2 );
            $oTemplate2->Parse();
            $sBuffer = $oTemplate2->Text();

            if ( $this->GetPgp() )
                $sBuffer = $this->PGPEncrypt( $sBuffer );
            $this->oEmail->AltBody = $sBuffer;

            // Add attachment (if in template2)
            if ( $oTemplate2->IsBlock( 'attachment' ) )
            {
                $oTemplate2->Parse( 'attachment.filename' );
                $sFilename = $oTemplate2->Text( 'attachment.filename' );
                $oTemplate2->Reset( 'attachment.filename' );

                $this->OutputTpl( $oTemplate2, 'attachment' );
                $oTemplate2->Parse( 'attachment' );
                $sBuffer = $oTemplate2->Text( 'attachment' );
                $this->AddStringAttachment( $sBuffer, $sFilename );
            }
        }
        else
            $this->oEmail->AltBody = '';

        return( $this->oEmail->Send() );
    }

    function OutputTpl( &$oTemplate, $sBlock = null, $sSub = null )
    {
        global $oApp;
        global $oHook;

        if ( $sBlock === null )
            $sBlock = 'main';

        $aVars = $oTemplate->GetVars();

        if ( !parent::OutputTpl( $oTemplate, $sBlock, $sSub ) )
            return( false );

        // assign modul parameters
        $oTemplate->Assign( $this->GetName(), $this->aValues );

        // output parent object
        parent::OutputTpl( $oTemplate, $sBlock );

        // set main block
        $sBlock .= '.' . $this->GetName();

        // output modul
        if ( is_object( $this->oModul ) )
        {
            if ( isset( $oHook ) )
                $oHook->Execute( $this->oModul->GetName(), 'mail', $this );
            $this->oModul->OutputTpl( $oTemplate, $sBlock );
        }

        // output mail
        $this->aValues = $this->GetValues();
      $this->PrepareRowEdit( $this->aValues, 'created' );
        if ( is_array( $this->aValues ) )
        {
            $oTemplate->Assign( 'DATA', $this->aValues );
            foreach( $this->aValues as $sName => $sValue )
            {
                parent::OutputValue( $oTemplate, $sName, $this->aValues, $sBlock );
            }
        }

        $oTemplate->Reset( $sBlock );
        $oTemplate->Parse( $sBlock );
        $oTemplate->SetVars( $aVars );
    }

    /** Encrypt content with pgp
        @param $sContent content
        @return string encryptet content
    */
    function PGPEncrypt( $sContent )
    {
        global $oApp;

        // PGP Verschlsselung
        $sUser = $this->GetPgpUser();
        if ( $this->GetPgp() && !IsNull( $sUser ) )
        {
            // Name der Ausgabedatei (wird im aktuellen Verzeichnis angelegt.
            $sOutput = md5( uniqid( rand() ) );

            // PGP Verschlsselung
            $sCommand = $oApp->GetCommand( 'cmd_pgp' );
            $iFile = popen( "$sCommand $sUser $sOutput", 'w' );
            if ( !$iFile )
                return( false );

            fputs( $iFile, $sContent );
            pclose( $iFile );

            // Ausgabedatei lesen
            FileRead( $sOutput, $sBuffer );

            // Wenn ein Fehler bei der Verschlsselung aufgetreten ist (zb. wenn es fr die Email Adresse keinen Schlssel gibt),
            // dann den Text unverschlsselt verschicken.
            if ( !IsNull( $sBuffer ) )
                $sContent = $sBuffer;

            // Ausgabedatei lschen
            unlink( $sOutput );
        }

        return( $sContent );
    }

    /** Sets the SMTP TCP/IP Timeout
        @param $iValue Timeout in seconds
        @return void
     */
    function SetTimeout( $iValue )
    {
      $this->oEmail->Timeout = $iValue;
    }

    function GetError()
    {
        return( $this->oEmail->ErrorInfo );
    }
}
