<?php

defined( 'oPage' ) or die();

class CMessage extends CControl
{
    var $aEntries;

    function CMessage( $sName = 'message' )
    {
        $this->CControl( $sName );

        // Message-Array initialisieren
        $this->aEntries = array();
    }

    function Copy( $oCopy = Null )
    {
        if ( !is_object( $oCopy ) )
        {
            $sClass = get_class( $this );
            $oCopy = new $sClass( '' );
        }
        $oCopy = CControl::Copy( $oCopy );

        $oCopy->aEntries = $this->aEntries;

        return( $oCopy );
    }

    function Add( $sMessage, $sType = null )
    {
        if ( IsNull( $sMessage ) )
            return( false );
        if ( $sType === null )
            $sType = 'message';

        $aEntry = array();
		$aEntry[ $sType ] = $sMessage;
        $this->aEntries[] = $aEntry;

        return( true );
    }

    function OutputTpl( &$oTemplate, $sBlock = null, $sSub = null )
    {
        if ( !$this->IsData() )
            return( false );

        if ( $sBlock === null )
            $sBlock = 'main';

        if ( !parent::OutputTpl( $oTemplate, $sBlock, $sSub ) )
            return( false );

        $aVars = $oTemplate->GetVars();

        $sBlock .= '.' . $this->GetName();

        if ( $oTemplate->IsBlock( $sBlock . '.HEADER' ) )
            $oTemplate->parse( $sBlock . '.HEADER' );

		foreach( $this->aEntries as $aEntry )
        {
			$oTemplate->assign( 'DATA', $aEntry );

            foreach( array_keys( $aEntry ) as $sKey )
                $this->OutputValue( $oTemplate, $sKey, $aEntry, $sBlock . '.DATA' );

    	    $oTemplate->parse( $sBlock . '.DATA' );
        }

        if ( $oTemplate->IsBlock( $sBlock . '.FOOTER' ) )
            $oTemplate->parse( $sBlock . '.FOOTER' );

    	$oTemplate->parse( $sBlock );
		$oTemplate->SetVars( $aVars );
    }

    function IsData()
    {
		if ( ArrayCount( $this->aEntries ) > 0 )
		    return( true );

		return( false );
    }
}
