<?php

defined( 'oPage' ) or die();

class CSort extends CControl
{
	var $oForm;
	var $aFields = Array();

	function CSort( $sName = 'sort' )
    {
        global $oFactory;

        $this->CControl( $sName );
		$this->oForm = $oFactory->Control( 'CForm', $sName );
    }

    function Copy( $oCopy = Null )
    {
        $oCopy = CControl::Copy( $oCopy );
        $oCopy->oForm = $this->oForm->Copy();
        $oCopy->aFields = $this->aFields;
        return( $oCopy );
    }

    function OutputTpl( &$oTemplate, $sBlock = null, $sSub = null )
    {
        if ( !parent::OutputTpl( $oTemplate, $sBlock, $sSub ) )
            return( false );

		foreach ( $this->aFields as $sName => $aField )
		{
		    $this->oForm->SetValue( 'field_' . $sName . '#id', $aField[ 'id' ] );
			$this->oForm->SetValue( 'field_' . $sName, $aField[ 'mode' ] );
		}

		$this->oForm->OutputTpl( $oTemplate, $sBlock );
    }

	function AddField( $sName )
	{
		$this->aFields[ $sName ] = Array();
		$this->oForm->AddField( 'field_' . $sName . '#up', 'SUBMIT' );
		$this->oForm->AddField( 'field_' . $sName . '#down', 'SUBMIT' );
		$this->oForm->AddField( 'field_' . $sName . '#id', 'TEXT' );
		$this->oForm->AddField( 'field_' . $sName, 'TEXT' );
	}

    function SetPrefix( $sValue )
    {
        $this->oForm->SetPrefix( $sValue );
        CControl::SetPrefix( $sValue );
    }

    function SetWidth( $sName, $sValue )
    {
        $this->oForm->SetWidth( 'field_' . $sName, $sValue );
    }

    function SetHeight( $sName, $sValue )
    {
        $this->oForm->SetHeight( 'field_' . $sName, $sValue );
    }

    function SetOptions( $sName, $aValues )
    {
        $this->oForm->SetOptions( 'field_' . $sName, $aValues );
    }

    function SetMaxlength( $sName, $sValue )
    {
        $this->oForm->SetMaxlength( 'field_' . $sName, $sValue );
    }

    function Action()
    {
        $fRead = false;

        /** Complex mode
            In complex mode, the sort control stores the order, in which
            the sort buttons of the different fields have been clicked.
            The resulting order by statements are sorted by the internal id,
            which is increased with every new click on an up- or down button.
        */
		$iID = 0;

        // Get data from from
        // And look for biggest id
		foreach ( $this->aFields as $sName => $aField )
		{
			$this->aFields[ $sName ][ 'id' ] = $this->oForm->GetValue( 'field_' . $sName . '#id' );
    		$this->aFields[ $sName ][ 'mode' ] = $this->oForm->GetValue( 'field_' . $sName );

			if ( $this->aFields[ $sName ][ 'id' ] > $iID )
				$iID = $this->aFields[ $sName ][ 'id' ];
		}

		foreach ( $this->aFields as $sName => $aField )
		{
			$sMode = '';

			if ( $this->oForm->IsSubmitted( 'field_' . $sName . '#up' ) )
			{
				$fRead = true;
				$sMode = 'asc';
		    }
			elseif ( $this->oForm->IsSubmitted( 'field_' . $sName . '#down' ) )
			{
				$fRead = true;
				$sMode = 'desc';
            }

			if ( $sMode != '' )
			{
			    if ( IsNull( $this->aFields[ $sName ][ 'mode' ] ) )
                {
    				$this->aFields[ $sName ][ 'mode' ] = $sMode;
    				$this->aFields[ $sName ][ 'id' ] = ++$iID;
    		    }
                else if ( $this->aFields[ $sName ][ 'mode' ] != $sMode )
                {
    				$this->aFields[ $sName ][ 'mode' ] = $sMode;
    		    }
    		    else
                {
    				$this->aFields[ $sName ][ 'mode' ] = '';
    				$this->aFields[ $sName ][ 'id' ] = '';
    		    }
			}
		}

		return( $fRead );
	}

	function Get()
	{
		$aValues = Array();
		foreach ( $this->aFields as $sName => $aField )
			if ( $aField[ 'mode' ] != '' )
			{
				$aValues[ $aField[ 'id' ] ][ 'field' ] = $sName;
				$aValues[ $aField[ 'id' ] ][ 'mode' ] = $aField[ 'mode' ];
			}
		ksort( $aValues );
		$aSort = Array();
		foreach ( $aValues as $aValue )
			$aSort[ $aValue[ 'field' ] ] = $aValue[ 'mode' ];

		return( $aSort );
	}
}
