<?php

defined( 'oPage' ) or die();

class CSortSimple extends CControl
{
	var $oForm;
	var $aFields = Array();

	function CSortSimple( $sName = 'sortsimple' )
    {
        global $oFactory;

        $this->CControl( $sName );
		$this->oForm = $oFactory->Control( 'CForm', $sName );
    }

    function Copy( $oCopy = Null )
    {
        $oCopy = CControl::Copy( $oCopy );
        $oCopy->oForm = $this->oForm->Copy();
        $oCopy->aFields = $this->aFields;
        return( $oCopy );
    }

    function OutputTpl( &$oTemplate, $sBlock = null, $sSub = null )
    {
        if ( !parent::OutputTpl( $oTemplate, $sBlock, $sSub ) )
            return( false );

        foreach ( $this->aFields as $sName => $aField )
			$this->oForm->SetValue( 'field_' . $sName, $aField[ 'mode' ] );

		$this->oForm->OutputTpl( $oTemplate, $sBlock );
    }

	function AddField( $sName )
	{
		$this->aFields[ $sName ] = Array();
		$this->oForm->AddField( 'field_' . $sName . '#up', 'SUBMIT' );
		$this->oForm->AddField( 'field_' . $sName . '#down', 'SUBMIT' );
		$this->oForm->AddField( 'field_' . $sName, 'TEXT' );
	}

    function SetPrefix( $sValue )
    {
        $this->oForm->SetPrefix( $sValue );
        parent::SetPrefix( $sValue );
    }

    function SetWidth( $sName, $sValue )
    {
        $this->oForm->SetWidth( 'field_' . $sName, $sValue );
    }

    function SetHeight( $sName, $sValue )
    {
        $this->oForm->SetHeight( 'field_' . $sName, $sValue );
    }

    function SetOptions( $sName, $aValues )
    {
        $this->oForm->SetOptions( 'field_' . $sName, $aValues );
    }

    function SetMaxlength( $sName, $sValue )
    {
        $this->oForm->SetMaxlength( 'field_' . $sName, $sValue );
    }

    function Action()
    {
        $fRead = false;

        /** Simple mode
            In simple mode only the last click on an up- or down button
            is recorded and used. No history or multiple sort modes are
            available.
        */
        // Get data from from and
        // Check if a up/down button has been clicked
		foreach ( $this->aFields as $sName => $aField )
		{
    		$this->aFields[ $sName ][ 'mode' ] = $this->oForm->GetValue( 'field_' . $sName );

			if ( $this->oForm->IsSubmitted( 'field_' . $sName . '#up' ) )
				$fRead = true;
			elseif ( $this->oForm->IsSubmitted( 'field_' . $sName . '#down' ) )
				$fRead = true;
		}

        // If one button has been clicked, get the data and clear all other fields
        if ( $fRead )
    		foreach ( $this->aFields as $sName => $aField )
    		{
    			if ( $this->oForm->IsSubmitted( 'field_' . $sName . '#up' ) )
    				$this->aFields[ $sName ][ 'mode' ] = 'asc';
    			elseif ( $this->oForm->IsSubmitted( 'field_' . $sName . '#down' ) )
    				$this->aFields[ $sName ][ 'mode' ] = 'desc';
                else
    				$this->aFields[ $sName ][ 'mode' ] = '';
    		}

		return( $fRead );
	}

	function Get()
	{
    	$aSort = Array();
    	foreach ( $this->aFields as $sName => $aField )
    		if ( $aField[ 'mode' ] != '' )
    			$aSort[ $sName ] = $aField[ 'mode' ];

		return( $aSort );
	}
}
