<?php

defined( 'oPage' ) or die();

function Debug( $Something = null, $fHtml = null )
{
    if ( $Something !== null )
        return( DebugPrint( $Something, $fHtml ) );

    $aDebug = debug_backtrace();

    echo '<h1>Debug</h1>' . "\n";
    $iCounter = count( $aDebug );
    for( $i = 0; $i != $iCounter; ++$i )
    {
        echo '<table width="100%" border="0" cellpadding="0" cellspacing="0" style="border 1px solid black; background-color: white; font-color: black;">' . "\n";

        // print function name and arguments
        echo '<tr>' . "\n";
        echo '    <td>' . "\n";
        // print the function name
        if ( isset( $aDebug[ $i ][ 'function' ] ) )
            echo 'function <font color="#FF3300">' . $aDebug[ $i ][ 'function' ] . '(</font> ';
        // print the arguments
        if ( isset( $aDebug[ $i ][ 'args' ] ) )
        {
            echo '<font color="#2020F0">';
            $iArguments = count( $aDebug[ $i ][ 'args' ] );
            for( $j = 0; $j != $iArguments; ++$j )
            {
                if ( $aDebug[ $i ][ 'args' ][ $j ] === 'true' )
                    echo 'true';
                elseif ( $aDebug[ $i ][ 'args' ][ $j ] === 'false' )
                    echo 'false';
                elseif ( $aDebug[ $i ][ 'args' ][ $j ] === null )
                    echo 'null';
                elseif ( is_string( $aDebug[ $i ][ 'args' ][ $j ] ) )
                    echo '\'' . $aDebug[ $i ][ 'args' ][ $j ] . '\'';
                else
                    echo $aDebug[ $i ][ 'args' ][ $j ];

                if ( ( $j + 1 ) < $iArguments )
                    echo ', ';
            }
            echo '</font>';
        }
        if ( isset( $aDebug[ $i ][ 'function' ] ) )
            echo '<font color="#FF3300"> )</font>' . "\n";
        echo '    </td>' . "\n";
        echo '</tr>' . "\n";

        // print source filename and line of code
        if ( isset( $aDebug[ $i ][ 'file' ] ) || isset( $aDebug[ $i ][ 'line' ] ) )
        {
            echo '<tr>' . "\n";
            echo '    <td>' . "\n";
            echo '        {<br />' . "\n";
            if ( isset( $aDebug[ $i ][ 'file' ] ) )
                echo '        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $aDebug[ $i ][ 'file' ] . "\n";
            if ( isset( $aDebug[ $i ][ 'line' ] ) )
                echo $aDebug[ $i ][ 'line' ] . "\n";
            echo '        <br />}' . "\n";
            echo '    </td>' . "\n";
            echo '</tr>' . "\n";
        }
        echo '</table>' . "\n";

        if ( ( $i + 1 ) != $iCounter )
        {
            echo "<br>\n";
            echo 'was called by:' . "\n";
        }
    }
}

function DebugPrint( $Something, $fHtml = null )
{
    if ( is_array( $Something ) )
        DebugArray( $Something, $fHtml );
    if ( is_string( $Something ) )
        DebugString( $Something, $fHtml );
}

// Gibt den Inhalt eines eindimensionnalen Arrays aus: Key=Value
// param: 	Array
// return: 	nix
function DebugArray( $aArray, $fHtml = null )
{
    if ( $fHtml === null )
        $fHtml = false;

    foreach( $aArray as $sKey => $sValue )
    {
        if ( is_array( $sValue ) )
        {
            echo "$sKey = ARRAY<br>\n";
            DebugPrint( $sValue, $fHtml );
        }
        elseif ( is_object( $sValue ) )
        {
            if ( $fHtml )
                echo htmlspecialchars( "$sKey = " . get_class( $sValue ) . "<br>\n" );
            else
                echo "$sKey = " . get_class( $sValue ) . "<br>\n";
        }
		elseif ( $sValue === null )
		{
            if ( $fHtml )
                echo htmlspecialchars( "$sKey = null<br>\n" );
            else
                echo "$sKey = null<br>\n";
		}
        else
            if ( $fHtml )
                echo htmlspecialchars( "$sKey = $sValue<br>\n" );
            else
                echo "$sKey = $sValue<br>\n";
    }
    echo "<hr>\n";
}

// param: 	String
// return: 	nix
function DebugString( $sString, $fHtml = null )
{
    if ( $fHtml === null )
        $fHtml = false;

    if ( $fHtml )
        echo htmlspecialchars( "$sKey = $sValue<br>\n" );
    else
        echo $sString . "<br>\n";
}
