/*
 * cookie.js 0.1
 *
 * Functions to set and retrieve cookies with JavaScript
 * Released as part of the oPage Web Content Management Framework
 * http://www.opage.at
 *
 * Released under the GNU GPL license
 * Author: Hannes Dorn <hannes@dorn.cc>
 *
 */

function CookieWrite( Name, Value, Path, Expires, Domain )
{
    if ( Expires )
    {
        dateExpire = Expires;
    }
    else
    {
        dateExpire = new Date();
        iDays = 365;
        dateExpire.setTime( dateExpire.getTime() + ( 24 * 60 * 60 * 1000 * iDays ) );
    }

    document.cookie = Name + "=" + escape( Value ) + ";" +
        ( ( Path ) ? "path=" + Path + ";" : "" ) +
        ( ( Domain ) ? "domain=" + Domain + ";" : "" ) +
        "expires=" + dateExpire.toGMTString() + ";";
}

function CookieRead( Name )
{
    if ( !document.cookie )
    {
        return ( '' );
    }

    i = document.cookie.indexOf( Name + '=' );
    if ( i == -1 )
    {
        return ( '' );
    }
    i = i + Name.length + 1;

    iBegin = i;
    iEnd = document.cookie.indexOf( ";", i );

    if ( iEnd == -1 )
    {
        iEnd = document.cookie.length;
    }

    Value = unescape( document.cookie.substring( iBegin, iEnd ) );

    return ( Value );
}

function CookieDelete( Name, Path, Domain )
{
    dateExpire = new Date();
    iDays = -1;
    dateExpire.setTime( dateExpire.getTime() + ( 24*60*60*1000*iDays ) );

    document.cookie = Name + "=;" +
        ( ( Path ) ? "path=" + Path + ";" : "" ) +
        ( ( Domain ) ? "domain=" + Domain + ";" : "" );
        "expires=" + dateExpire.toGMTString() + ";";
}
