/*
 * css.js 0.2
 *
 * Functions to change css styles and classes with JavaScript
 * Released as part of the oPage Web Content Management Framework
 * http://www.opage.at
 *
 * Released under the GNU GPL license
 * Author: Hannes Dorn <hannes@dorn.cc>
 *
 */

function HasClass( oObject, sClass )
{
    if ( !oObject )
        return( false );

    i = oObject.className.indexOf( sClass );

    if ( i == -1 )
        return( false );

    return( true );
}

function SetClass( oObject, sClass )
{
    if ( !oObject )
        return;

    i = oObject.className.indexOf( sClass );

    if ( i == -1 )
        oObject.className = oObject.className + ' ' + sClass;
}

function DelClass( oObject, sClass )
{
    if ( !oObject )
        return;

    i = oObject.className.indexOf( sClass );

    if ( i >= 0 )
        oObject.className = oObject.className.substr( 0, i ) + oObject.className.substr( i + 1 );
}

function ChangeClass( sClass, sAttribute, sValue )
{
    var sClasses;
    var i;
    var iMax;
    var a;
    var aMax;

    if ( document.all )
        sClasses = 'rules';
    else
        if ( document.getElementById )
	        sClasses = 'cssRules';

    for ( i = 0, iMax = document.styleSheets.length; i < iMax; i++ )
        for ( a = 0, aMax = document.styleSheets[ i ][ sClasses ].length; a < aMax; a++ )
            if ( document.styleSheets[ i ][ sClasses ][ a ].selectorText.toLowerCase() == sClass )
                document.styleSheets[ i ][ sClasses ][ a ].style[ sAttribute ] = sValue;
}

function SetStyle( oObject, sStyle, sValue )
{
    if ( !oObject )
        return;

    oObject.style[ sStyle ] = sValue;
}

function CssToggleDisplay( sId )
{
    var oObject = document.getElementById( sId );
    if ( oObject.style.display == 'none' )
        oObject.style.display = '';
    else
        oObject.style.display = 'none';

    if ( window.onresize )
    {
        var onResize = window.onresize;
        onResize();
    }
}
