/*
 * system.js 0.3
 *
 * Some functions to get system information
 * Released as part of the oPage Web Content Management Framework
 * http://www.opage.at
 *
 * Released under the GNU GPL license
 * Author: Hannes Dorn <hannes@dorn.cc>
 * See also http://www.mozilla.org/docs/web-developer/sniffer/browser_type.html
 *
 */

function SystemGetOs()
{
    var indl = eval( navigator.appVersion.indexOf("(") + 1 );
    var indr = eval( navigator.appVersion.indexOf(")") );
    var isos = navigator.appVersion.substring(indl,indr);
    if ( navigator.platform ) isos=navigator.platform

    return( isos );
}

function SystemGetBrowser()
{
    return( navigator.appName );
}

function SystemGetBrowserMajor()
{
    return( parseInt( navigator.appVersion ) );
}

function SystemGetBrowserMinor()
{
    return( parseFloat( navigator.appVersion ) );
}

function SystemIs()
{
    // convert all characters to lowercase to simplify testing
    var agt = navigator.userAgent.toLowerCase()

    // *** BROWSER VERSION ***
    this.is_major = SystemGetBrowserMajor();
    this.is_minor = SystemGetBrowserMinor()

    // Note: Opera and WebTV spoof Navigator.  We do strict client detection.
    // If you want to allow spoofing, take out the tests for opera and webtv.
    this.is_nav  = ((agt.indexOf('mozilla')!=-1) && (agt.indexOf('spoofer')==-1) && (agt.indexOf('compatible') == -1) && (agt.indexOf('opera')==-1) && (agt.indexOf('webtv')==-1) && (agt.indexOf('hotjava')==-1));
    this.is_nav2 = (this.is_nav && (this.is_major == 2));
    this.is_nav3 = (this.is_nav && (this.is_major == 3));
    this.is_nav4 = (this.is_nav && (this.is_major == 4));
    this.is_nav4up = (this.is_nav && (this.is_major >= 4));
    this.is_navonly = (this.is_nav && ((agt.indexOf(";nav") != -1) || (agt.indexOf("; nav") != -1)) );
    this.is_nav6 = (this.is_nav && (this.is_major == 5));
    this.is_nav6up = (this.is_nav && (this.is_major >= 5));
    this.is_gecko = (agt.indexOf('gecko') != -1);

    this.is_ie     = ((agt.indexOf("msie") != -1) && (agt.indexOf("opera") == -1));
    this.is_ie3    = (this.is_ie && (this.is_major < 4));
    this.is_ie4    = (this.is_ie && (this.is_major == 4) && (agt.indexOf("msie 4")!=-1) );
    this.is_ie4up  = (this.is_ie && (this.is_major >= 4));
    this.is_ie5    = (this.is_ie && (this.is_major == 4) && (agt.indexOf("msie 5.0")!=-1) );
    this.is_ie5_5  = (this.is_ie && (this.is_major == 4) && (agt.indexOf("msie 5.5") !=-1));
    this.is_ie5up  = (this.is_ie && !this.is_ie3 && !this.is_ie4);
    this.is_ie5_5up =(this.is_ie && !this.is_ie3 && !this.is_ie4 && !this.is_ie5);
    this.is_ie6    = (this.is_ie && (this.is_major == 4) && (agt.indexOf("msie 6.")!=-1) );
    this.is_ie6up  = (this.is_ie && !this.is_ie3 && !this.is_ie4 && !this.is_ie5 && !this.is_ie5_5);

    // KNOWN BUG: On AOL4, returns false if IE3 is embedded browser
    // or if this is the first browser window opened.  Thus the
    // variables is_aol, is_aol3, and is_aol4 aren't 100% reliable.
    this.is_aol   = (agt.indexOf("aol") != -1);
    this.is_aol3  = (this.is_aol && this.is_ie3);
    this.is_aol4  = (this.is_aol && this.is_ie4);
    this.is_aol5  = (agt.indexOf("aol 5") != -1);
    this.is_aol6  = (agt.indexOf("aol 6") != -1);

    this.is_opera = (agt.indexOf("opera") != -1);
    this.is_opera2 = (agt.indexOf("opera 2") != -1 || agt.indexOf("opera/2") != -1);
    this.is_opera3 = (agt.indexOf("opera 3") != -1 || agt.indexOf("opera/3") != -1);
    this.is_opera4 = (agt.indexOf("opera 4") != -1 || agt.indexOf("opera/4") != -1);
    this.is_opera5 = (agt.indexOf("opera 5") != -1 || agt.indexOf("opera/5") != -1);
    this.is_opera5up = (this.is_opera && !this.is_opera2 && !this.is_opera3 && !this.is_opera4);
    this.is_opera6 = (agt.indexOf("opera 6") != -1 || agt.indexOf("opera/6") != -1);
    this.is_opera6up = (this.is_opera5up && !this.is_opera5);

    this.is_webtv = (agt.indexOf("webtv") != -1);

    this.is_TVNavigator = ((agt.indexOf("navio") != -1) || (agt.indexOf("navio_aoltv") != -1));
    this.is_AOLTV = this.is_TVNavigator;

    this.is_hotjava = (agt.indexOf("hotjava") != -1);
    this.is_hotjava3 = (this.is_hotjava && (this.is_major == 3));
    this.is_hotjava3up = (this.is_hotjava && (this.is_major >= 3));

    // *** JAVASCRIPT VERSION CHECK ***
    this.is_js = null;
    if (this.is_nav2 || this.is_ie3) this.is_js = 1.0;
    else if (this.is_nav3) this.is_js = 1.1;
    else if (this.is_opera5up) this.is_js = 1.3;
    else if (this.is_opera) this.is_js = 1.1;
    else if ((this.is_nav4 && (this.is_minor <= 4.05)) || this.is_ie4) this.is_js = 1.2;
    else if ((this.is_nav4 && (this.is_minor > 4.05)) || this.is_ie5) this.is_js = 1.3;
    else if (this.is_hotjava3up) this.is_js = 1.4;
    else if (this.is_nav6 || this.is_gecko) this.is_js = 1.5;
    // NOTE: In the future, update this code when newer versions of JS
    // are released. For now, we try to provide some upward compatibility
    // so that future versions of Nav and IE will show they are at
    // *least* JS 1.x capable. Always check for JS version compatibility
    // with > or >=.
    else if (this.is_nav6up) this.is_js = 1.5;
    // NOTE: ie5up on mac is 1.4
    else if (this.is_ie5up) this.is_js = 1.3

    // HACK: no idea for other browsers; always check for JS version with > or >=
    else this.is_js = 0.0;

    return( this );
}

function SystemGetJavascriptVersion()
{
    var oIs = SystemIs();

    return( this.is_js );
}

function SystemIsCSS( member )
{
    PLtagArray = "";
    PLop = '["';
    PLcl = '"]';
    PLstyleKey = ".style";
    PLshowKey = "visible";
    PLhideKey = "hidden";
    if ( document.documentElement && document.getElementById )
    {
        PLtagArray="document.getElementById";
        PLop = '("';
        PLcl = '")';
    }
    else if ( document.layers )
    {
        PLtagArray="document.layers";
        PLstyleKey="";
        PLshowKey="show";
        PLhideKey="hide";
    }
    else if ( document.all )
    {
        PLtagArray="document.all";
    }
    else if ( window.document.getElementById )
    {
         PLtagArray="window.document.getElementById";
         PLop = '("';
         PLcl = '")';
    }

    if( eval( PLtagArray ) && eval( PLtagArray + PLop + member + PLcl ) )
        return( true );

    return( false );
}
