<?php

defined( 'oPage' ) or die();

class CMenu extends CModul
{
    /** filter for content pages
    */
    var $fPageContent = null;

    /** filter for admin pages
    */
    var $fPageAdmin = null;

    function CMenu( $sName = null )
    {
        $this->SetDefault( 'menu' );

        // Zuerst die Basisklasse initialisieren
        $this->CModul( $sName );

        // Nur Werte anzeigen, die Display gesetzt haben
        $this->SetFilter( 'display', 'n', '<>' );

        $this->SetOrder( 'sort' );
        $this->SetOrder( 'id' );

        $this->SetFieldUse( 'section_id', false );
        $this->SetFieldUse( 'use_page_title', false );
        $this->SetFieldUse( 'parameter', false );
        $this->SetFieldUse( 'template_targetname', false );

        $this->SetFieldUseAdminList( 'sort' );
        $this->SetFieldUseAdminList( 'name' );
        $this->SetFieldUseAdminList( 'parent_name' );
    }

    /** Initialisiert die Liste mit den Feldern
        Folgende Felder werden untersttzt:
        DATA.id
        DATA.name
        DATA.parent
        return nix
    */
    function SetFields()
    {
        $this->SetField( 'id', 'ID' );
        $this->SetField( 'section_id', 'HIDDENID' );
        $this->SetField( 'sort', 'INTEGER' );
        $this->SetField( 'name', 'FOREIGNNAME' );
        $this->SetField( 'parent_name', 'FOREIGNNAME' );
        $this->SetField( 'parameter' );
        $this->SetField( 'template_targetname' ); // name of the target variable in the template
        $this->SetField( 'use_page_title', 'YESNO', true );
        $this->SetField( 'display', 'DISPLAY', true );

        CModul::SetFields();
    }

    function AdminListProperties( &$oAdmin, $sName )
    {
        global $oFactory;

        switch( $sName )
        {
            // name is used differently here as usually
            case 'name':
                $oPage = $oFactory->Modul( 'CPage' );

                $sFilter = null;
                if ( $oPage->GetFieldUse( 'page_content' ) )
                    if ( $this->fPageContent !== null )
                        $sFilter .= ( $sFilter ? ' and ' : '' ) . $this->GetField( 'page_content' ) . '=' . ( $this->fPageContent ? '\'y\'' : '\'n\'' );
                if ( $oPage->GetFieldUse( 'page_view' ) )
                    if ( $this->fPageView !== null )
                        $sFilter .= ( $sFilter ? ' and ' : '' ) . $this->GetField( 'page_view' ) . '=' . ( $this->fPageView ? '\'y\'' : '\'n\'' );
                if ( $oPage->GetFieldUse( 'page_admin' ) )
                    if ( $this->fPageAdmin !== null )
                        $sFilter .= ( $sFilter ? ' and ' : '' ) . $this->GetField( 'page_admin' ) . '=' . ( $this->fPageAdmin ? '\'y\'' : '\'n\'' );

                $oPage->ClearOrders();
                $oPage->SetOrder( 'title_display' );
                $oAdmin->SetOptions( $sName, $oPage->GetList( array( 'title', 'name' ), $sFilter, null, 'name', array( '0' => ' ', '2a' => '(', '2b' => ')' ) ) );
                $oAdmin->SetMaxlength( $sName, 255 );
            break;

            // parent_name is used differently here as usually
            case 'parent_name':
                $oPage = $oFactory->Modul( 'CPage' );

                $sFilter = null;
                if ( $oPage->GetFieldUse( 'page_content' ) )
                    if ( $this->fPageContent !== null )
                        $sFilter .= ( $sFilter ? ' and ' : '' ) . $this->GetField( 'page_content' ) . '=' . ( $this->fPageContent ? '\'y\'' : '\'n\'' );
                if ( $oPage->GetFieldUse( 'page_view' ) )
                    if ( $this->fPageView !== null )
                        $sFilter .= ( $sFilter ? ' and ' : '' ) . $this->GetField( 'page_view' ) . '=' . ( $this->fPageView ? '\'y\'' : '\'n\'' );
                if ( $oPage->GetFieldUse( 'page_admin' ) )
                    if ( $this->fPageAdmin !== null )
                        $sFilter .= ( $sFilter ? ' and ' : '' ) . $this->GetField( 'page_admin' ) . '=' . ( $this->fPageAdmin ? '\'y\'' : '\'n\'' );

                $oPage->ClearOrders();
                $oPage->SetOrder( 'title_display' );
                $oAdmin->SetOptions( $sName, $oPage->GetList( array( 'title', 'name' ), $sFilter, null, 'name', array( '0' => ' ', '2a' => '(', '2b' => ')' ) ) );
                $oAdmin->SetMaxlength( $sName, 255 );
            break;

            // because of name and parent_name, call parent::AdminListProperties only for other fields
            default:
                parent::AdminListProperties( $oAdmin, $sName );
            break;
        }
    }

    function AdminProperties( &$oAdmin, $sName )
    {
        global $oFactory;

        switch( $sName )
        {
            // name is used differently here as usually
            case 'name':
                $oPage = $oFactory->Modul( 'CPage' );

                $sFilter = null;
                if ( $oPage->GetFieldUse( 'page_content' ) )
                    if ( $this->fPageContent !== null )
                        $sFilter .= ( $sFilter ? ' and ' : '' ) . $this->GetField( 'page_content' ) . '=' . ( $this->fPageContent ? '\'y\'' : '\'n\'' );
                if ( $oPage->GetFieldUse( 'page_view' ) )
                    if ( $this->fPageView !== null )
                        $sFilter .= ( $sFilter ? ' and ' : '' ) . $this->GetField( 'page_view' ) . '=' . ( $this->fPageView ? '\'y\'' : '\'n\'' );
                if ( $oPage->GetFieldUse( 'page_admin' ) )
                    if ( $this->fPageAdmin !== null )
                        $sFilter .= ( $sFilter ? ' and ' : '' ) . $this->GetField( 'page_admin' ) . '=' . ( $this->fPageAdmin ? '\'y\'' : '\'n\'' );

                $oPage->ClearOrders();
                $oPage->SetOrder( 'name' );
                $oAdmin->SetOptions( $sName, $oPage->GetList( array( 'title', 'name' ), $sFilter, null, 'name', array( '0' => ' ', '2a' => '(', '2b' => ')' ) ) );
                $oAdmin->SetMaxlength( $sName, 255 );
            break;

            // parent_name is used differently here as usually
            case 'parent_name':
                $oPage = $oFactory->Modul( 'CPage' );

                $sFilter = null;
                if ( $oPage->GetFieldUse( 'page_content' ) )
                    if ( $this->fPageContent !== null )
                        $sFilter .= ( $sFilter ? ' and ' : '' ) . $this->GetField( 'page_content' ) . '=' . ( $this->fPageContent ? '\'y\'' : '\'n\'' );
                if ( $oPage->GetFieldUse( 'page_view' ) )
                    if ( $this->fPageView !== null )
                        $sFilter .= ( $sFilter ? ' and ' : '' ) . $this->GetField( 'page_view' ) . '=' . ( $this->fPageView ? '\'y\'' : '\'n\'' );
                if ( $oPage->GetFieldUse( 'page_admin' ) )
                    if ( $this->fPageAdmin !== null )
                        $sFilter .= ( $sFilter ? ' and ' : '' ) . $this->GetField( 'page_admin' ) . '=' . ( $this->fPageAdmin ? '\'y\'' : '\'n\'' );

                $oPage->ClearOrders();
                $oPage->SetOrder( 'name' );
                $oAdmin->SetOptions( $sName, $oPage->GetList( array( 'title', 'name' ), $sFilter, null, 'name', array( '0' => ' ', '2a' => '(', '2b' => ')' ) ) );
                $oAdmin->SetMaxlength( $sName, 255 );
            break;

            // because of name and parent_name, call parent::AdminListProperties only for other fields
            default:
                parent::AdminProperties( $oAdmin, $sName );
            break;
        }
    }

    function SetPageContent( $fValue = null )
    {
        $this->fPageContent = $fValue;
    }

    function SetPageView( $fValue = null )
    {
        $this->fPageView = $fValue;
    }

    function SetPageAdmin( $fValue = null )
    {
        $this->fPageAdmin = $fValue;
    }
}
