<?php

defined( 'oPage' ) or die();

class CModule extends CModul
{
    function CModule( $sName = null )
    {
        $this->SetDefault( 'module' );

        // Zuerst die Basisklasse initialisieren
        $this->CModul( $sName );

        // Nur Werte anzeigen, die Display gesetzt haben
        $this->SetFilter( 'display', 'n', '<>' );

        $this->SetOrder( 'name' );

        $this->SetFieldUseAdminList( 'id', true );
        $this->SetFieldUseAdminList( 'name', true );
        $this->SetFieldUseAdminList( 'title', true );
    }

    /** Initialisiert die Liste mit den Feldern
        Folgende Felder werden untersttzt:
        DATA.id
        DATA.name
        DATA.title
        return nix
    */
    function SetFields()
    {
        $this->SetField( 'id', 'ID' );
        $this->SetField( 'name' );
        $this->SetField( 'title' );
        $this->SetField( 'display', 'DISPLAY' );

        CModul::SetFields();
    }

    function AdminListProperties( &$oAdmin, $sName )
    {
        switch( $sName )
        {
            case 'name':
                $oAdmin->SetWidth( $sName, 30 );
                $oAdmin->SetMaxlength( $sName, 255 );
                break;

            case 'title':
                $oAdmin->SetWidth( $sName, 50 );
                $oAdmin->SetLimit( $sName, 255 );
                break;

            default:
                parent::AdminListProperties( $oAdmin, $sName );
                break;
        }
    }

    function AdminProperties( &$oAdmin, $sName )
    {
        switch( $sName )
        {
            case 'name':
                $oAdmin->SetWidth( $sName, 30 );
                $oAdmin->SetMaxlength( $sName, 255 );
                break;

            case 'title':
                $oAdmin->SetWidth( $sName, 70 );
                $oAdmin->SetLimit( $sName, 255 );
                break;

            default:
                parent::AdminProperties( $oAdmin, $sName );
                break;
        }
    }

    function PrepareRow( &$aRow )
    {
        $this->PrepareText( $aRow, 'name' );
        $this->PrepareText( $aRow, 'title' );

        return( parent::PrepareRow( $aRow ) );
    }
}
