<?php

defined( 'oPage' ) or die();

class CPage extends CModul
{
    function CPage( $sName = Null )
    {
        $this->SetDefault( 'page' );

        $this->CModul( $sName );

        $this->SetOrder( 'id' );

        $this->SetFieldUse( 'onclick', false );
        $this->SetFieldUse( 'page_content', false );
        $this->SetFieldUse( 'page_view', false );
        $this->SetFieldUse( 'page_admin', false );

        $this->SetFieldUseAdminList( 'name' );
        $this->SetFieldUseAdminList( 'path' );
        $this->SetFieldUseAdminList( 'title_display' );
    }

    function SetFields()
    {
        $this->SetField( 'id', 'ID', Null, 'page_id' );
		$this->SetField( 'name' );
        $this->SetField( 'path' );
        $this->SetField( 'target' );
        $this->SetField( 'onclick' );
        $this->SetField( 'title', Null, true );
        $this->SetField( 'title_display', Null, true );
        $this->SetField( 'title_navigation', Null, true );
        $this->SetField( 'title_menu', Null, true );
        $this->SetField( 'page_content', 'YESNO', true );
        $this->SetField( 'page_view', 'YESNO', true );
        $this->SetField( 'page_admin', 'YESNO', true );

        return( true );
    }

    function AdminListProperties( &$oAdmin, $sName )
    {
        global $oFactory;

        parent::AdminListProperties( $oAdmin, $sName );

        switch( $sName )
        {
            case 'name':
                $oAdmin->SetWidth( $sName, 20 );
                $oAdmin->SetMaxlength( $sName, 255 );
                break;

            case 'path':
                $oAdmin->SetWidth( $sName, 40 );
                $oAdmin->SetMaxlength( $sName, 255 );
                break;

            case 'title_display':
                $oAdmin->SetWidth( $sName, 40 );
                $oAdmin->SetMaxlength( $sName, 255 );
                break;
        }
    }

    function AdminProperties( &$oAdmin, $sName )
    {
        global $oFactory;

        parent::AdminProperties( $oAdmin, $sName );

        switch( $sName )
        {
            case 'name':
                $oAdmin->SetWidth( $sName, 20 );
                $oAdmin->SetMaxlength( $sName, 255 );
                break;

            case 'path':
                $oAdmin->SetWidth( $sName, 137 );
                $oAdmin->SetMaxlength( $sName, 255 );
                break;

            case 'target':
                $oAdmin->SetWidth( $sName, 20 );
                $oAdmin->SetMaxlength( $sName, 255 );
                break;

            case 'onclick':
                $oAdmin->SetWidth( $sName, 137 );
                $oAdmin->SetMaxlength( $sName, 255 );
                break;

            case 'title':
                $oAdmin->SetWidth( $sName, 137 );
                $oAdmin->SetMaxlength( $sName, 255 );
                break;

            case 'title_display':
                $oAdmin->SetWidth( $sName, 137 );
                $oAdmin->SetMaxlength( $sName, 255 );
                $oAdmin->SetSyncMaster( $sName, 'title' );
                break;

            case 'title_navigation':
                $oAdmin->SetWidth( $sName, 137 );
                $oAdmin->SetMaxlength( $sName, 255 );
                $oAdmin->SetSyncMaster( $sName, 'title' );
                break;

            case 'title_menu':
                $oAdmin->SetWidth( $sName, 137 );
                $oAdmin->SetMaxlength( $sName, 255 );
                $oAdmin->SetSyncMaster( $sName, 'title' );
                break;
        }
    }
}
