<?php

defined( 'oPage' ) or die();

/** Postpend mu bei allen Seiten am Ende importiert werden.
   Verwendete globale Objekte:
   oSession     Speicherung von username
   oSession     Speicherung von fullname
*/

class CUser extends CModul
{
    /** Rechte
        Key: Name des Rechts
        Value: true
    */
    var $aRights = array();

    /** Clients
        key: integer
        value: row (array with name/values)
    */
    var $aClients = array();

    function CUser( $sName = null )
    {
        global $oApp;

        $this->SetDefault( 'user' );

        // Zuerst die Basisklasse initialisieren
        $this->CModul( $sName );

        // Filter setzen
        $this->SetFilter( 'display', 'n', '<>' );

        $this->SetFieldUseAdminList( 'id', true );
        $this->SetFieldUseAdminList( 'username', true );
        $this->SetFieldUseAdminList( 'password', true );
        $this->SetFieldUseAdminList( 'fullname', true );
        $this->SetFieldUseAdminList( 'display', true );

        if ( $oApp->GetLanguageCount() == 1 )
            $this->SetFieldUseAdmin( 'language_admin', false );

        if ( $oApp->GetLanguageCount( true ) == 1 )
            $this->SetFieldUseAdmin( 'language_content', false );
    }

    function SetFields()
    {
        $this->SetField( 'id', 'ID', Null, 'user_id' );
        $this->SetField( 'username', 'USERNAME' );
        $this->SetField( 'password', 'PASSWORD' );
        $this->SetField( 'fullname' );
        $this->SetField( 'display', 'DISPLAY' );
        $this->SetField( 'language_admin', 'LANGUAGE' );
        $this->SetField( 'language_content', 'LANGUAGE' );

        CModul::SetFields();

        return( true );
    }

    function AdminList( &$oAdmin )
    {
        global $oApp;
        global $oFactory;

        if ( $oApp->GetFeature( 'user', 'rights' ) == 1 )
        {
            $oUserRight = $oFactory->Modul( 'CUserUserRight' );
            $this->AddModul( $oUserRight, 'id', 'id' );
        }

        if ( $oApp->GetFeature( 'user', 'rights' ) == 2 )
        {
            $oUserGroup = $oFactory->Modul( 'CUserUserGroup' );
            $this->AddModul( $oUserGroup, 'id', 'id' );
        }

        if ( $oApp->GetFeature( 'user', 'client' ) == 1 )
        {
            $oUserClient = $oFactory->Modul( 'CUserUserClient' );
            $this->AddModul( $oUserClient, 'id', 'id' );
        }

        return( CModul::AdminList( $oAdmin ) );
    }

    function AdminListProperties( &$oAdmin, $sName )
    {
        CModul::AdminListProperties( $oAdmin, $sName );

        switch( $sName )
        {
            case 'username':
                $oAdmin->SetWidth( $sName, 15 );
                $oAdmin->SetMaxlength( $sName, 32 );
            break;

            case 'password':
                $oAdmin->SetWidth( $sName, 15 );
                $oAdmin->SetMaxlength( $sName, 32 );
            break;

            case 'fullname':
                $oAdmin->SetReadonly( $sName, true );
                $oAdmin->SetLimit( $sName, 30 );
                $oAdmin->SetMaxlength( $sName, 255 );
            break;
        }
    }

    function Admin( &$oAdmin )
    {
        global $oApp;
        global $oFactory;

        if ( $oApp->GetFeature( 'user', 'rights' ) == 1 )
        {
            $oUserRight = $oFactory->Modul( 'CUserUserRight' );
            $this->AddModul( $oUserRight, 'id', 'id' );

            $oAdmin->AddField( 'rightx', 'SELECT_SWITCH', Null, Null, true );
            $oAdmin->SetWidth( 'rightx', 250 );
            $oRight = $oFactory->Modul( 'CUserRight' );
            $aRight = $oRight->GetList( 'title' );
            $oAdmin->SetOptions( 'rightx', $aRight );

            $oAdmin->SetRelation( 'rightx', $oUserRight );
        }

        if ( $oApp->GetFeature( 'user', 'rights' ) == 2 )
        {
            $oUserGroup = $oFactory->Modul( 'CUserUserGroup' );
            $this->AddModul( $oUserGroup, 'id', 'id' );

            $oAdmin->AddField( 'groupx', 'SELECT_SWITCH', Null, Null, true );
            $oAdmin->SetWidth( 'groupx', 250 );
            $oGroup = $oFactory->Modul( 'CUserGroup' );
            $aGroup = $oGroup->GetList( 'name' );
            $oAdmin->SetOptions( 'groupx', $aGroup );

            $oAdmin->SetRelation( 'groupx', $oUserGroup );
        }

        if ( $oApp->GetFeature( 'user', 'client' ) == 1 )
        {
            $oUserClient = $oFactory->Modul( 'CUserUserClient' );
            $this->AddModul( $oUserClient, 'id', 'id' );

            $oAdmin->AddField( 'clientx', 'SELECT_SWITCH', Null, Null, true );
            $oAdmin->SetWidth( 'clientx', 250 );
            $oClient = $oFactory->Modul( 'CUserClient' );
            $aClient = $oClient->GetList();
            $oAdmin->SetOptions( 'clientx', $aClient );

            $oAdmin->SetRelation( 'clientx', $oUserClient );
        }

        return( CModul::Admin( $oAdmin ) );
    }

    function AdminProperties( &$oAdmin, $sName )
    {
        global $oApp;

        CModul::AdminProperties( $oAdmin, $sName );

        switch( $sName )
        {
            case 'username':
                $oAdmin->SetWidth( $sName, 50 );
                $oAdmin->SetMaxlength( $sName, 32 );
                break;

            case 'password':
                $oAdmin->SetWidth( $sName, 50 );
                $oAdmin->SetMaxlength( $sName, 32 );
                break;

            case 'fullname':
                $oAdmin->SetWidth( $sName, 50 );
                $oAdmin->SetMaxlength( $sName, 255 );
                break;

            case 'language_admin':
                $aLanguage = array();
                for( $i = 0; $i < $oApp->GetLanguageCount(); $i++ )
                {
                    $iId = $oApp->GetLanguageIdByIndex( $i );
                    $aLanguage[ $iId ] = $oApp->GetLanguageText( $iId );
                }
                $oAdmin->SetOptions( $sName, $aLanguage );
                $oAdmin->SetDefault( $sName, $oApp->GetLanguage() );
                break;

            case 'language_content':
                $aLanguage = array();
                for( $i = 0; $i < $oApp->GetLanguageCount( true ); $i++ )
                {
                    $iId = $oApp->GetLanguageIdByIndex( $i, true );
                    $aLanguage[ $iId ] = $oApp->GetLanguageText( $iId, true );
                }
                $oAdmin->SetOptions( $sName, $aLanguage );
                $oAdmin->SetDefault( $sName, $oApp->GetLanguage( -1, true ) );
                break;
        }
    }

    function UserCheck( $sRedirect )
    {
        global $oApp;

        if ( $sRedirect == null )
            $sRedirect = $oApp->GetRoot() . 'index.php?redirect=' . urlencode( $oApp->GetBackUrl() );

        if ( !$this->IsLoggedOn() )
        {
            header( 'Location: ' . $sRedirect );
            exit;
        }

        return( true );
    }

    function IsLoggedOn()
    {
        global $oSession;

        if ( !is_object( $oSession ) )
            return( false );

        if ( !is_array( $oSession->GetValue( $this->GetName() ) ) )
            return( false );

        if ( IsNull( $this->GetId() ) )
            return( false );

        return( true );
    }

    function Logon( $sUsername, $sPassword )
    {
        global $oApp;
        global $oDb;
        global $oFactory;
        global $oSession;

        $sTable = $this->GetTable();
        $sFields = $this->GetFields();
        $sFilter = $this->GetField( 'display' ) . "='y' and " . $this->GetField( 'username' ) . "='" . addslashes( $sUsername ) . "' and " . $this->GetField( 'password' ) . "='" . addslashes( $sPassword ) . "'";

		$aResult = $oDb->Read( $sTable, $sFields, $sFilter );

		if ( ArrayCount( $aResult ) == 0 )
		    return( false );

		$aUser = array_shift( $aResult );

		$oSession->SetValue( 'username', $sUsername );
        $oSession->SetValue( 'fullname', $aUser[ 'fullname' ] );
        $oSession->SetValue( 'rights', '' );
        $oSession->SetValue( 'language_admin', $aUser[ 'language_admin' ] );
        $oSession->SetValue( 'language_content', $aUser[ 'language_content' ] );

        $oApp->SetLanguage( $aUser[ 'language_admin' ] );
        $oApp->WriteLanguage( $aUser[ 'language_content' ] );

        if ( $oApp->GetFeature( 'user', 'rights' ) > 0 )
        {
            // array for list of right names
            $aRights = array();

            // user admin always get super powers
            if ( $sUsername == 'admin' )
                $aRights[ 'admin#admin' ] = true;

            // Feature Level 1: User <-> Rechte
            if ( $oApp->GetFeature( 'user', 'rights' ) == 1 )
            {
                // Rechte des Users ermitteln
                $sIds = '';
                if ( !IsNull( $aUser[ 'id' ] ) )
                {
                    $oUserRight = $oFactory->Modul( 'CUserUserRight' );
                    $oUserRight->SetFilter( 'id', $aUser[ 'id' ] );
                    $oUserRight->QueryData();
                    $sIds = $oUserRight->GetValuesString( 'rightx', true );
                }
            }

            // Feature Level 2: User <-> Gruppe <-> Rechte
            if ( $oApp->GetFeature( 'user', 'rights' ) == 2 )
            {
                // Gruppen des Users ermitteln
                $sIds = '';
                if ( !IsNull( $aUser[ 'id' ] ) )
                {
                    $oUserGroup = $oFactory->Modul( 'CUserUserGroup' );
                    $oUserGroup->SetFilter( 'id', $aUser[ 'id' ] );
                    $oUserGroup->QueryData();
                    $sIds = $oUserGroup->GetValuesString( 'groupx', true );
                }

                // Rechte der Gruppen ermitteln
                if ( !IsNull( $sIds ) )
                {
                    $oGroupRight = $oFactory->Modul( 'CUserGroupRight' );
                    $oGroupRight->SetFilter( 'id', $sIds, 'in', false );
                    $oGroupRight->QueryData();
                    $sIds = $oGroupRight->GetValuesString( 'rightx', true );
                }
            }

            // Rechtenamen lesen
            if ( !IsNull( $sIds ) )
            {
                $oRight = $oFactory->Modul( 'CUserRight' );
                $oRight->SetFilter( 'id', "($sIds)", 'in', false );
                $oRight->QueryData();
                $aResult = $oRight->GetResult();
                foreach( $aResult as $aRow )
                    $aRights[ $aRow[ 'name' ] ] = true;
            }

            // Rechtenamen in die Session eintragen
            $oSession->SetValue( 'rights', $aRights );
        }
        else
            $oSession->SetValue( 'rights', '' );

        // Set or Clear rights
        $this->SetRights();

        // Feature client
        if ( $oApp->GetFeature( 'user', 'client' ) == 1 )
        {
            // get clients for user
            $sIds = '';
            if ( !IsNull( $aUser[ 'id' ] ) )
            {
                $oUserClient = $oFactory->Modul( 'CUserUserClient' );
                $oUserClient->SetFilter( 'id', $aUser[ 'id' ] );
                $oUserClient->QueryData();
                $sIds = $oUserClient->GetValuesString( 'clientx', true );
            }

            // get client data for user
            $aClients = array();
            if ( !IsNull( $sIds ) )
            {
                $oClient = $oFactory->Modul( 'CUserClient' );
                $oClient->SetFilter( 'id', $sIds, 'in', false );
                $oClient->QueryData();

                // Get fieldname for id
                $sName = $oApp->GetFeature( 'user', 'client_id' );
                if ( $sName === '' || $sName === null )
                {
                    die( 'set feature client_id' );
                }

                $aClients = $oClient->GetValues( $sName );
            }

            // Store clients in the session
            $oSession->SetValue( 'clients', $aClients );
        }

        // Set or Clear clients
        $this->SetClients();

		return( true );
    }

    function Logoff()
    {
        global $oSession;

        $oSession->SetValue( 'username', '' );
        $oSession->SetValue( 'fullname', '' );
        $oSession->SetValue( 'rights', '' );
        $oSession->SetValue( 'clients', '' );

        return( true );
    }

    /** Liefert den Namen des aktuellen Benutzers
        @param none
        @return String mit dem Benutzernamen
    */
    function GetUser()
    {
        global $oSession;
        return( $oSession->GetValue( 'username' ) );
    }

    /** Liefert den vollen Namen des aktuellen Benutzers
        @param none
        @return String mit dem vollen Namen
    */
    function GetFullname()
    {
        global $oSession;
        return( $oSession->GetValue( 'fullname' ) );
    }

    /** berprft, ob der aktuelle User dieses Recht hat
        Zuerst wird berprft, ob er genau das Recht hat.
        Dann wird berprft, ob er ein Recht hat, da dieses Recht beinhaltet.

        section.modul#read
        -> section.modul#add
        -> section.modul#change
        -> section.modul#delete
           -> section.modul#admin

              -> section.#read
                 -> section.#add
                 -> section.#change
                 -> section.#delete
                    -> section.#admin

                       -> modul#read
                          -> modul#add
                          -> modul#change
                          -> modul#delete
                             -> modul#admin

                                -> admin#read
                                   -> admin#add
                                   -> admin#change
                                   -> admin#delete
                                      -> admin

        Todo: parameter with section or automatically detect section (separated by .)
        Todo: import and export right

    */
    function Right( $sModul, $sRight )
    {
        if ( !is_array( $this->aRights ) )
            return( false );
        if ( count( $this->aRights ) == 0 )
            return( false );

        // Gibts genau diesen Eintrag, dann den Wert zurckgeben
        if ( $this->aRights[ "$sModul#$sRight" ] === true )
            return( true );
        if ( $this->aRights[ "$sModul#$sRight" ] === false )
            return( false );

        // Wenn Read gewnscht, aber nicht vorhanden, dann geht auch add, change oder delete des Moduls.
        if ( $sRight == 'read' )
        {
            if ( $this->aRights[ "$sModul#add" ] === true )
                return( true );
            if ( $this->aRights[ "$sModul#add" ] === false )
                return( false );
            if ( $this->aRights[ "$sModul#change" ] === true )
                return( true );
            if ( $this->aRights[ "$sModul#change" ] === false )
                return( false );
            if ( $this->aRights[ "$sModul#delete" ] === true )
                return( true );
            if ( $this->aRights[ "$sModul#delete" ] === false )
                return( false );
        }

        // Hat der User vielleicht das Admin-Recht fr den Modul?
        if ( $sRight != 'admin' )
            if ( $this->Right( $sModul, 'admin' ) )
                return( true );

        // Wenn im Modul ein Punkt ist, dann abschneiden
        // hp.article -> hp
        $i = strrpos( $sModul, '.' );
        if ( $i !== false )
        {
            $sModul = substr( $sModul, 0, $i - 1 );
            if ( $this->Right( $sModul, $sRight ) )
                return( true );
        }

        // Wenn das Modulrecht nicht vorhanden ist, dann gibts vielleicht ein allgemeines Recht
        if ( $sModul != 'admin' )
            if ( $this->Right( 'admin', $sRight ) )
                return( true );

        return( false );
    }

    function SetClients( $aValue = null )
    {
        global $oSession;

        if ( $aValue === null )
            $this->aClients = $oSession->GetValue( 'clients' );
        else
            $this->aClients = $aValue;

        if ( !is_array( $this->aClients ) )
            $this->aClients = array();
    }

    function GetClients()
    {
        return( $this->aClients );
    }

    function SetRights( $aValue = null )
    {
        global $oSession;

        if ( IsNull( $aValue ) )
            $this->aRights = $oSession->GetValue( 'rights' );
        else
            $this->aRights = $aValue;
    }

	function Setup()
	{
        global $oDb;

        if ( !parent::Setup() )
            return( false );

        // 2008.11.11 DOH: This does not work for fields with UTF-8: MySQL reserves 3 bytes for one char, but an index is only allowed to have 1000 bytes, so combining 2 fields with 255 chars each would result in possible max 1500 bytes
        if ( $this->GetFieldUse( 'username' ) && $this->GetFieldUse( 'password' ) )
            $oDb->TableIndexCreate( $this->GetTable( 1 ), 'username_password', 'INDEX', array( 'username', 'password' ) );
        if ( $this->GetFieldUse( 'username' ) )
            $oDb->TableIndexCreate( $this->GetTable( 1 ), 'username', 'INDEX', array( 'username' ) );
        if ( $this->GetFieldUse( 'password' ) )
            $oDb->TableIndexCreate( $this->GetTable( 1 ), 'password', 'INDEX', array( 'password' ) );

	    return( true );
	}
}
