<?php

include_once '../../../include/opage.php';

$sModul = $oApp->GetParameter( 'm' );
$sId = $oApp->GetParameter( 'i' );
if
(
    ( $sModul !== '' && $sModul !== null )
    && ( $sId !== '' && $sId !== null )
)
{
    if ( $oApp->GetFeature( 'download', 'customeronly' ) == 1 )
    {
        $oCustomer->UserCheck();
    }
}

/** parameters
mode        counter mode
type        counter type, default download

Download 1:
m           modul
i           id
f           fieldname (default: filename)
r           row
t           filemode, download or open, default download

Download 2:
title       counter title
filename    filename on server, must start with "static/"
name        filename on client
filemode    download or open, default download
*/

$oWebpage = $oFactory->Webpage( 'download' );
$oWebpage->Init();

// Counter-Mode ermitteln
$sMode = $oApp->GetParameter( 'mode' );
if ( IsNull( $sMode ) )
{
    $sMode = 'm';
}

// Counter-Type ermitteln
$sType = '';
if ( isset( $oPlugins ) )
{
    // get section controller
    $oSectionController = $oPlugins->Get( 'section' );

    // if section controller is available
    if ( $oSectionController != null )
    {
        // get subsection name
        $sType = $oSectionController->GetSubSection();
        if ( $sType !== null && $sType !== '' )
        {
            $sType .= '_download';
        }
    }
}

$sModul = $oApp->GetParameter( 'm' );
$sId = $oApp->GetParameter( 'i' );

if
(
    ( $sModul !== '' && $sModul !== null )
    && ( $sId !== '' && $sId !== null )
)
{
    // Get row
    $sRow = $oApp->GetParameter( 'r' );

    // Get fieldname
    $sFieldname = $oApp->GetParameter( 'f' );
    if ( $sFieldname === '' || $sFieldname === null )
    {
        $sFieldname = 'filename';
    }
    else
    {
        // fieldname by be 'fieldname{row}_file' (usualy backend) or just 'fieldname' (usualy frontend)
        if ( substr( $sFieldname, -5 ) == '_file' )
        {
            $sFieldname = substr( $sFieldname, 0, -5 );
        }

        if ( is_numeric( substr( $sFieldname, -1 ) ) )
        {
            $sRow = '';
        }
        while( is_numeric( substr( $sFieldname, -1 ) ) )
        {
            $sRow .= substr( $sFieldname, -1 );
            $sFieldname = substr( $sFieldname, 0, -1 );
        }
    }

    $oModul = $oFactory->Modul( $sModul );
    $oModul->SetFilter( 'id', $sId );
    $oModul->QueryData();

    if ( $oModul->IsData() )
    {
        // Limit data to public/private?
        if
        (
            isset( $oCustomer ) && is_object( $oCustomer ) &&
            (
                $oModul->GetFieldUse( $sFieldname . $sRow . '_public' ) ||
                $oModul->GetFieldUse( $sFieldname . $sRow . '_private' )
            )
        )
        {
            if ( $oCustomer->IsLoggedOn() )
            {
                $oModul->SetFilter( $sFieldname . $sRow . '_private', 'y' );
            }
            else
            {
                $oModul->SetFilter( $sFieldname . $sRow . '_public', 'y' );
            }

            $oModul->QueryData();

            if ( !$oModul->IsData() )
            {
                $oCustomer->UserCheck( $oApp->GetRoot() . 'index.php?subsection=' . urlencode( 'Benutzer_Anmeldung' ) . '&redirect=' . urlencode( $oApp->GetBackUrl() ) );
            }
        }

        // Set counter type (if not set already)
        if ( $sType === null || $sType === '' )
        {
            $sType = $oModul->GetName() . '_download';
        }

        $sTitle = $oModul->Get( $sFieldname . $sRow . '_title' );
        $sFilename = $oModul->Get( $sFieldname . $sRow . '_file' );

        // 2010.03.31 DOH    Create path to file: file is either below static -> prepend with $sRoot, or is already an absolute path
        $sPath = $oModul->GetFieldPath( $sFieldname . $sRow . '_file' );
        if ( substr( $sPath, 0, strlen( 'static/' ) ) == 'static/' )
        {
            $sPath = $sRoot . $sPath;
        }

        // Filename for user
        $sName = $oModul->Get( $sFieldname . $sRow . '_name' );

        // Filemode (download or open), default: download
        $sFilemode = $oApp->GetParameter( 't' );

        // Call hook system
        if ( isset( $oHook ) )
        {
            $aParameter = array
            (
                'fieldname' => $sFieldname,
                'row' => $sRow,
                'title' => $sTitle,
                'filename' => $sFilename,
                'path' => $sPath,
                'name' => $sName,
                'filemode' => $sFilemode
            );
            $oHook->Execute( $oModul->GetName(), 'download', $oModul, $aParameter );
        }
    }
}
else
{
    // Set counter type (if not set already)
    if ( $sType === null || $sType === '' )
    {
        $sType = $oApp->GetParameter( 'type' );
    }

    // Titel ermitteln
    $sTitle = $oApp->GetParameter( 'title' );

    // Dateiname ermitteln
    $sFilename = $oApp->GetParameter( 'filename' );

    // 2010.03.31 DOH    Create path to file: file must be below 'static/' for security reasons
    $sPath = $sRoot;
    if ( substr( $sFilename, 0, strlen( 'static/' ) ) != 'static/' )
    {
        $sPath .= 'static/';
    }

    // Filename for user
    $sName = $oApp->GetParameter( 'name' );

    // Filemode (download or open), default: download
    $sFilemode = $oApp->GetParameter( 'filemode' );
}

// Set default counter type (if not set already)
if ( $sType === null || $sType === '' )
{
    $sType = 'download';
}

// Check, if we got a filename
if ( $sFilename === null || $sFilename === '' )
{
    exit( "<h1>Es wurde kein Dateiname angegeben.</h1>" );
}

// Increase counter
if ( !$oApp->GetAdmin() )
{
    if ( isset( $oCounter ) )
    {
        $oCounter->SetMode( $sMode );
        $oCounter->Increase( $sType, $sFilename, $sTitle );
    }
}

// Download or open the file
if ( !FileDownload( $sPath . $sFilename, $sName, $sFilemode ) )
{
    exit( "<h1>Die Datei ist nicht vorhanden.</h1>" );
}
