<?php

defined( 'oPage' ) or die();

/** Plugin base class for a plugin
*/
class CPlugin
{
    /** @var $sPath string plugin path
    */
    var $sPath;

    /** @var $sName string name of the plugin
     */
    var $sName;

    /** @var $sBlock string name of the plugin block, default content
     */
    var $sBlock = 'content';

    /** @var $fWebpageXRun bool Run output for WebpageX, default: true
    */
    var $fWebpageXRun = true;

    /** @var $fWebpageRunView bool Run view on every page or just by calling view.php, default: false
    */
    var $fWebpageRunView = false;

    function CPlugin()
    {
    }

    /** Setup plugins
        @param &$oSetup CSetup reference to the setup object
    */
    function Setup( &$oSetup )
    {
        return( false );
    }

    /** Setup modul
        @param &$oObject CModul reference to the module object
        @param &$sClass string class name
    */
    function SetupModulData( &$oObject, $sClass )
    {
        return( false );
    }

    /** Factory extension for the plugin
        @param $sClass string name of the wanted class
        @param &$sCreate receives the name of the real class
        @param &$sName string name of the module
        @param &$sInclude filename of the module
    */
    function FactoryModul( $sClass, &$sCreate, &$sName, &$sInclude )
    {
        return( false );
    }

    /** Factory extension for the plugin
        @param $oObject reference of the instanced module
        @param $sClass name of the wanted class
    */
    function FactoryModulConfigure( &$oObject, $sClass )
    {
        return( false );
    }

    /** Factory extension for the plugin
        @param $sClass name of the wanted class
    */
    function FactoryControl( $sClass, &$sCreate, &$sName, &$sInclude )
    {
        return( false );
    }

    /** Factory extension for the plugin
        @param $oObject reference of the instanced module
        @param $sClass name of the wanted class
    */
    function FactoryControlConfigure( &$oObject, $sClass )
    {
        return( false );
    }

    /**
     * Hook entry point for Admin
     * @param CWebpageNormal &$oWebpage webpage object
     * @param string &$sUrl a reference to the url for the filename, which should be loaded
     */
    function Admin( &$oWebpage, &$sUrl )
    {
    }

    /**
     * Hook entry point for AdminNavigation
     * @param CWebpage &$oWebpage webpage object
     * @param CModul $oModule reference to module navigation object
     */
    function AdminNavigation( &$oWebpage, &$oModule, &$iFeatureRights, &$fGlobalNavigation )
    {
    }

    /**
     * Hook entry point for AdminWebpageBasis
     * @param CWebpageBasis &$oWebpage reference to the page object
     * @param string $sPart ('constructor', 'begin', 'end')
     */
    function AdminWebpageBasis( &$oWebpage, $sPart )
    {
        /*
        global $oApp;

        switch( $sPart )
        {
            case 'constructor':
            break;

            case 'init':
            break;

            case 'begin':
            break;

            case 'end':
            break;
        }
        */
    }

    /**
     * Hook entry point for AdminWebpageNormal
     * @param CWebpageNormal &$oWebpage reference to the page object
     * @param string $sPart ('constructor', 'begin', 'end')
     */
    function AdminWebpageNormal( &$oWebpage, $sPart )
    {
        /*
        global $oApp;

        switch( $sPart )
        {
            case 'constructor':
            break;

            case 'init':
            break;

            case 'begin':
            break;

            case 'end':
            break;
        }
        */
    }

    /**
     * Hook entry point for AdminWebpageContent
     * @param CWebpageContent &$oWebpage reference to the page object
     * @param string $sPart ('constructor', 'begin', 'end')
     */
    function AdminWebpageContent( &$oWebpage, $sPart )
    {
        /*
        global $oApp;

        switch( $sPart )
        {
            case 'constructor':
            break;

            case 'init':
            break;

            case 'begin':
            break;

            case 'end':
            break;
        }
        */
    }

    /**
     * Hook entry point for AdminList
     * @param CWebpageX &$oWebpage reference to the page object
     * @param &$oModul reference to the module
     * @param &$oAdmin reference to the admin control
     */
    function AdminList( &$oWebpage, &$oModul, &$oAdmin )
    {
    }

    /**
     * Hook entry point for AdminDetail
     * @param CWebpageX &$oWebpage reference to the page object
     * @param CModul &$oModul reference to the module
     * @param CAdmin &$oAdmin reference to the admin control
     */
    function AdminDetail( &$oWebpage, &$oModul, &$oAdmin )
    {
    }

    /** Hook entry point for Webpage
        @param CWebpage &$oWebpage reference to the page object
        @param string $sPart ('constructor', 'begin', 'end')
    */
    function Webpage( &$oWebpage, $sPart )
    {
        /*
        global $oApp;

        switch( $sPart )
        {
            case 'constructor':
            break;

            case 'init':
            break;

            case 'begin':
            break;

            case 'end':
            break;
        }
        */
    }

    /** Hook entry point for WebpageBasis
        @param CWebpageBasis &$oWebpage reference to the page object
        @param string $sPart ('constructor', 'begin', 'end')
    */
    function WebpageBasis( &$oWebpage, $sPart )
    {
        /*
        global $oApp;

        switch( $sPart )
        {
            case 'constructor':
            break;

            case 'init':
            break;

            case 'begin':
            break;

            case 'end':
            break;
        }
        */
    }

    /**
     * Hook entry point for WebpageX
     * @param CWebpageX &$oWebpage reference to the page object
     * @param string $sPart ('constructor', 'begin', 'end')
     */
    function WebpageX( &$oWebpage, $sPart )
    {
        switch( $sPart )
        {
            case 'constructor':
            break;

            case 'init':
            break;

            case 'begin':
                if ( $this->GetWebpageRunView() )
                {
                    $oWebpage->Assign( $this->GetBlock(), $this->RunView( $this->GetPath() . 'view.php' ) );
                    $oWebpage->Parse( 'main.' . $this->GetBlock() );
                }
            break;

            case 'end':
            break;
        }
    }

    /**
     * Hook entry point for Index
     * @param CWebpageX &$oWebpage reference to the page object
     */
    function Index( &$oWebpage )
    {
    }

    /**
     * Executes a view.php for oWebpage and returns the output
     * @param string $sView string Filename of .php script to be executed, default view.php
     * @param array $aParameter Additional parameters, default null
     * @return string Content produced by view
    */
    function RunView( $sView = null, $aParameter = null )
    {
        global $sRoot;
        global $oFactory;
        global $oApp;
        global $oPlugins;
        global $oParameter;
        global $oSession;

        if ( $sView === null )
        {
            $sView = $this->GetPath() . 'view.php';
        }

        // Trigger an error if view does not exist
        if ( !file_exists( $sRoot . $sView ) )
        {
            trigger_error( $sView . ' does not exist', E_USER_ERROR );
            return;
        }

        // Run view and grab output
        ob_start();
        include( $sRoot . $sView );
        $sContent = ob_get_contents();
        ob_end_clean();

        return( $sContent );
    }

    /** Adds a title for the current page
     *  @param $sValue string title
     *  @param $sDelimiter string filler, default null (' - ')
     *  @param $fPrepend bool prepend instead of append, default false
     */
    function AddTitle( $sValue, $sDelimiter = null, $fPrepend = null )
    {
        global $oWebpage;
        $oWebpage->AddTitle( $sValue, $sDelimiter, $fPrepend );
    }

    /** Open a plugin specific template
        @param $sFilename string template filename, relative to plugin/xxxx/template/, default content.tpl
        @param $sName string name of the module or plugin, default name of the plugin (used to load resources)
    */
    function Template( $sFilename = null, $sName = null )
    {
        global $sRoot;
        global $oFactory;
        global $oApp;

        if ( $sFilename == null )
        {
            $sFilename = 'content.tpl';
        }
        if ( $sName == null )
        {
            $sName = $this->GetName();
        }

        $sFilename = $sRoot . $this->GetPath() . 'template/' . $sFilename;
        $sResource = $sRoot . $this->GetPath() . 'resource/' . $oApp->GetLanguageShortText() . '.res';

        $oTemplate = $oFactory->Template( $sFilename, null, null, null, $sName, $sResource );

        $oTemplate->Assign( 'plugin.path', $this->GetPath() );

        return( $oTemplate );
    }

    /** Hook entry point for Template Resource loading
        @param &$oTemplate reference to the template object
    */
    function ResourceRead( &$oTemplate, &$sResource, $sLanguage, $sName = null )
    {
        global $sRoot;

        // load plugin resources
        $sResourceFilename = $sRoot . $this->sPath . 'resource/' . $sLanguage . '.res';
        $oTemplate->ResourceRead( $sResourceFilename, $sResource );
        if ( $sName !== null && $sName !== '' )
        {
            $sResourceFilename = $sRoot . $this->sPath . 'resource/' . $sName . '#' . $sLanguage . '.res';
            $oTemplate->ResourceRead( $sResourceFilename, $sResource );
        }

        // load custom plugin resources
        $sResourceFilename = $sRoot . 'custom/' . $this->sPath . 'resource/' . $sLanguage . '.res';
        $oTemplate->ResourceRead( $sResourceFilename, $sResource );
        if ( $sName !== null && $sName !== '' )
        {
            $sResourceFilename = $sRoot . 'custom/' . $this->sPath . 'resource/' . $sName . '#' . $sLanguage . '.res';
            $oTemplate->ResourceRead( $sResourceFilename, $sResource );
        }
    }

    /** Sets the plugin path
     * 	@param $sValue string value
     */
    function SetPath( $sValue )
    {
        $this->sPath = $sValue;
    }

    /** Gets the plugin path
     * 	@return string value
     */
    function GetPath()
    {
        return( $this->sPath );
    }

    /** Sets the plugin name
     * 	@param $sValue string value
     */
    function SetName( $sValue )
    {
        $this->sName = $sValue;
    }

    /** Gets the plugin name
     * 	@return string value
     */
    function GetName()
    {
        return( $this->sName );
    }

    /** Sets the plugin block name
     * 	@param $sValue string value
     */
    function SetBlock( $sValue )
    {
        $this->sBlock = $sValue;
    }

    /** Gets the plugin name
     * 	@return string value
     */
    function GetBlock()
    {
        return( $this->sBlock );
    }

    /** Sets the WebpageXRun
     * 	@param $sValue string value
     */
    function SetWebpageXRun( $fValue = null )
    {
        if ( $fValue === null )
        {
            $fValue = true;
        }
        $this->fWebpageXRun = $fValue;
    }

    /** Gets the plugin name
     * 	@return string value
     */
    function GetWebpageXRun()
    {
        return( $this->fWebpageXRun );
    }

    /** Sets the WebpageRunView
     * 	@param $sValue string value
     */
    function SetWebpageRunView( $fValue = null )
    {
        if ( $fValue === null )
        {
            $fValue = true;
        }
        $this->fWebpageRunView = $fValue;
    }

    /** Gets the plugin name
     * 	@return string value
     */
    function GetWebpageRunView()
    {
        return( $this->fWebpageRunView );
    }
}
