<?php

defined( 'oPage' ) or defined( 'oPage install' ) or die();

function Is( $sTitle, $xVar )
{
    echo "Title: $sTitle<br>\n";
    echo "Value: $xVar<br>\n";
    echo "is_array:  " . is_array( $xVar ) . "<br>\n";
    echo "is_double: " . is_double( $xVar ) . "<br>\n";
    echo "is_float:  " . is_float( $xVar ) . "<br>\n";
    echo "is_int:    " . is_int( $xVar ) . "<br>\n";
    echo "is_string: " . is_string( $xVar ) . "<br>\n";
    echo "is_object: " . is_object( $xVar ) . "<br>\n";
    echo "isset:     " . isset( $xVar ) . "<br>\n";
    echo "empty:     " . empty( $xVar ) . "<br>\n";
    echo "=0:        " . ( $xVar == 0 ? '1' : '' ) . "<br>\n";
    echo "strlen:    " . strlen( $xVar ) . "<br>\n";
    echo "is_null:   " . is_null( $xVar ) . "<br>\n";
    echo "=='':      " . ( $xVar == '' ? '1' : '' ) . "<br>\n";
    echo "==='':     " . ( $xVar === '' ? '1' : '' ) . "<br>\n";
    echo "==null:    " . ( $xVar == null ? '1' : '' ) . "<br>\n";
    echo "===null:   " . ( $xVar === null ? '1' : '' ) . "<br>\n";
    echo "IsNull:    " . IsNull( $xVar ) . "<br>\n";
    echo "xVar?:     " . ( $xVar ? '1' : '' ) . "<br>\n";
    echo "===false:  ". ( $xVar === false ? '1' : '' ) . "<br>\n";
    echo "<br>\n";
}

function IsNull( $Value )
{
    if ( is_int( $Value ) )
        return( false );

    if ( is_string( $Value ) )
        if ( $Value != '' )
            return( false );
        else
            return( true );

    if ( isset( $Value ) )
        return( false );

    if ( empty( $Value ) )
        return( true );

    return( false );
}

/** Erzeugt ein Pawort der angegebenen Lnge
    @param iLength
    @return sPassword
*/
function StringPassword( $iLength )
{
    // do not use: 1, l, I

    $aChars = array();
    $aChars[ 0 ] = StringExpand( 'a-km-z' );
    $aChars[ 1 ] = StringExpand( 'A-HJ-Z' );
    $aChars[ 2 ] = StringExpand( '02-9' );
    $aChars[ 3 ] = StringExpand( '-_,;*={}[]()$!' );
    $iChars = count( $aChars );

    $sPassword = '';
    for( $i = 0; $i < $iLength; $i++ )
    {
        // randomize the position of the char strings
        if ( $i % $iChars == 0 )
            shuffle( $aChars );

        $sPassword .= $aChars[ $i % $iChars ][ rand( 0, strlen( $aChars[ $i % $iChars ] ) - 1 ) ];
    }

    return( $sPassword );
}

/*
//  Type:               Function
//  Description:        Expandiert einen String in einen neuen String (A-Z wird zu ABCDEF...Z)
//                      zb: "-A-Za-z0-9xxxx" wird "-ABC...XYZabc...xyz012...789xxxx"
//  Params:
//      sString         Ausgangsstring
//  Return:             Ergebnisstring
*/
function StringExpand( $sString )
{
    $sBuffer = '';

    $i = strpos( $sString, '-' );
    $iOld = -1;

    if ( substr( $sString, $i, 1 ) != '-' )
        return( $sString );

    while( substr( $sString, $i, 1 ) == '-' && $i > $iOld )
    {
        if ( $i == 0 )
        {
            $sBuffer .= '-';
            $i++;
        }
        else
        {
            if ( $iOld >= 0 )
                $sBuffer .= substr( $sString, $iOld, $i - $iOld - 1 );

            $sStart = substr( $sString, $i - 1, 1 );
            $sStop = substr( $sString, $i + 1, 1 );

            if ( ord( $sStart ) < ord( $sStop ) )
            {
                for ( $j = ord( $sStart ); $j <= ord( $sStop ); $j++ )
                    $sBuffer .= chr( $j );
            }
            else
            {
                for ( $j = ord( $sStart ); $j >= ord( $sStop ); $j-- )
                    $sBuffer .= chr( $j );
            }

            $i += 2;
        }

        $iOld = $i;
        $i = strpos( $sString, '-', $i );
    }

    if ( $iOld >= 0 )
        $sBuffer .= substr( $sString, $iOld );

    return( $sBuffer );
}

//// Fgt den String an der angegebenen Position im Buffer ein.
//// 0 = Start
//// strlen( $sBuffer ) = Ende
//function StringInsert( $sBuffer, $iPosition, $sString )
//{
//    return( substr( $sBuffer, 0, $iPosition ) . $sString . substr( $sBuffer, $iPosition ) );
//}

//// Entfernt den String an der angegebenen Position
//function StringDelete( $sBuffer, $iPosition, $iLength )
//{
//    return( substr( $sBuffer, 0, $iPosition ) . substr( $sBuffer, $iPosition + $iLength ) );
//}

/** Works like UCWord, but solves problems with non space delimiters
    @param $sBuffer
    @return string
*/
function StringUCWords( $sBuffer, $aLCase = null, $aUCase = null, $aIgnore = null )
{
    // split into words
    $aWords = array();
    $sWord = '';
    for( $i = 0; $i < strlen( $sBuffer ); ++$i )
    {
        $sWord .= $sBuffer[ $i ];
        if ( strpos( ' -/.,:;+!?', $sBuffer[ $i ] ) !== false )
        {
            $aWords[] = $sWord;
            $sWord = '';
        }
    }
    if ( $sWord <> '' )
        $aWords[] = $sWord;

    // ucfirst all words
    $aUCWords = array();
    foreach( $aWords as $sWord )
    {
        $sFiller = '';
        switch( substr( $sWord, -1, 1 ) )
        {
            case ' ':
            case '-':
            case '/':
            case '.':
            case ',':
            case ':':
            case ';':
            case '+':
            case '!':
            case '?':
                $sFiller = substr( $sWord, -1, 1 );
                $sWord = substr( $sWord, 0, -1 );
            break;
        }

        switch( $sWord )
        {
            case 'der':
            case 'die':
            case 'das':
                $sWord = strtolower( $sWord );
            break;

            case 'ag':
            case 'kg':
            case 'oeg':
            case 'fp':
            case 'vp':
            case 'sp':
            case 'orf':
            case 'edv':
            case 'dhs':
                $sWord = strtoupper( $sWord );
            break;

            default:
                $fFinished = false;

                if ( $aIgnore != null )
                    if ( ArrayIsIn( $aIgnore, $sWord, false ) )
                        $fFinished = true;

                if ( $fFinished == false && $aLCase != null )
                    if ( ArrayIsIn( $aLCase, $sWord, false ) )
                    {
                        $sWord = strtolower( $sWord );
                        $fFinished = true;
                    }

                if ( $fFinished == false && $aUCase != null )
                    if ( ArrayIsIn( $aUCase, $sWord, false ) )
                    {
                        $sWord = strtoupper( $sWord );
                        $fFinished = true;
                    }

                if ( $fFinished == false )
                {
                    $sWord = ucfirst( $sWord );
                    $fFinished = true;
                }
            break;
        }

        $aUCWords[] = $sWord . $sFiller;
    }

    // create string again
    return( implode( '', $aUCWords ) );
}

////  Type:               Function
////  Description:        Zhlt, wie oft ein bestimmtes Zeichen im Source vorkommt
////  Params:
////      sString         String
////      sChar           Zeichen, da gesucht wird
////  Return:             int, Anzahl wie oft das Zeichen im String vorkommt
//function StringCountChar( $sString, $sChar )
//{
//    $iCount = 0;
//    $i = strpos( $sString, $sChar );
//    while( substr( $sString, $i, strlen( $sChar ) ) == $sChar )
//    {
//        $iCount++;
//        $i = strpos( $sString, $sChar, $i + 1 );
//        if ( $i == '' )
//            break;
//    }
//
//    return( $iCount );
//}

////  Type:               Function
////  Description:        Sucht nach dem angegebenen String.
////  Params:
////      sString         String, der durchsucht wird
////      sSearch         String, nachdem gesucht wird
////  Return:             int, Position des Strings >= 0 oder -1, wenn nicht gefunden
//function StringPos( $sString, $sSearch, $iStart = 0 )
//{
//    if ( $iStart > 0 )
//        $sString = substr( $sString, $iStart );
//
//    $iPos = strpos( $sString, $sSearch );
//
//    // berprfen, ob auch wirklich das Zeichen gefunden wurde
//    if ( $iPos == 0 )
//        if ( substr( $sString, $iPos, strlen( $sSearch ) ) != $sSearch )
//            return( -1 );
//
//    return( $iPos + $iStart );
//}

///** Sucht nach dem angegebenen String. Ersetzt strrpos
//    @param sString String, der durchsucht wird
//    @param sSearch String, nachdem gesucht wird
//    @return int, Position des Strings >= 0 oder -1, wenn nicht gefunden
//*/
//function StringRPos( $sString, $sSearch )
//{
//    $iPos = strrpos( $sString, $sSearch );
//
//    // berprfen, ob auch wirklich das Zeichen gefunden wurde
//    if ( $iPos == 0 )
//        if ( substr( $sString, $iPos, strlen( $sSearch ) ) != $sSearch )
//            return( -1 );
//
//    return( $iPos );
//}

/** Prepares a filter string for DB Search
    @param sSearch String to be search for
    @param out sCompare: '>', '<', 'like'
    @param iFullmode 0: append %, 1: append % on both sides, 2: append nothing, default 1
    @return query string
*/
function StringDBFilter( $sSearch, &$sCompare, $iMode = null )
{
    if ( $iMode == null )
        $iMode = 1;

    // ' entfernen
    $sSearch = str_replace( "'", '', $sSearch );

	// Wenn im Suchstring ein < oder > oder = enthalten ist, dann diese auch verwenden
    if ( substr( $sSearch, 0, 2 ) == '<=' || substr( $sSearch, 0, 2 ) == '>=' || substr( $sSearch, 0, 1 ) == '!=' )
	{
	    $sCompare = substr( $sSearch, 0, 2 );
	    $sSearch = substr( $sSearch, 2 );
    }
    elseif ( substr( $sSearch, 0, 1 ) == '<' || substr( $sSearch, 0, 1 ) == '>' || substr( $sSearch, 0, 1 ) == '=' )
	{
	    $sCompare = substr( $sSearch, 0, 1 );
	    $sSearch = substr( $sSearch, 1 );
    }
    if ( $sCompare == '' )
        $sCompare = 'LIKE';

    // Wenn ein * angegeben ist, wird er durch ein % ersetzt: Aus xxxx* wird LIKE 'xxxx%', aus *xxxx wird LIKE '%xxxx', aus *xx*xx* wird LIKE '%xx%xx%', aus 'xxxx' wird '%xxxx%'
    $sSearch = str_replace( "*", "%", $sSearch );
    if ( strpos( $sSearch, '%' ) === false )
        $sSearch = '%' . $sSearch . '%';

    return( $sSearch );
}

/** Validates an email address
    @param sEmail email addres
    @return true, if email seams to be ok (or is empty), false if email is invalid
*/
function StringValidateEmail( $sEmail )
{
    if ( IsNull( $sEmail ) )
        return( true );

	if ( preg_match( "/^([-!#\$%&'*+\.\/0-9=?^_`a-z{|}~])+@([-!#\$%&'*+\/0-9=?^_`a-z{|}~]+\\.)+[a-z]{2,5}\$/i", $sEmail ) )
	    return( true );

	if ( preg_match( "/^([-!#\$%&'*+\.\/0-9=?A-Z^_`a-z{|}~])+@localhost\$/i", $sEmail ) )
	    return( true );

    return( false );
}

function StringEncryptRnd( $iLength )
{
    $sBuffer = '';
    while( $iLength-- > 0 )
        $sBuffer .= chr( mt_rand() & 0xff );

    return( $sBuffer );
}

function StringEncrypt( $sText, $sPassword, $iVLength = 16 )
{
    $sText .= "\x13";
    $iLength = strlen( $sText );

    if ( $iLength % 16 )
        $sText .= str_repeat( "\0", 16 - ( $iLength % 16 ) );

    $i = 0;
    $sEncrypted = StringEncryptRnd( $iVLength );

    $sIV = substr( $sPassword ^ $sEncrypted, 0, 512 );
    while( $i < $iLength )
    {
        $sBlock = substr( $sText, $i, 16 ) ^ pack( 'H*', md5( $sIV ) );
        $sEncrypted .= $sBlock;
        $sIV = substr( $sBlock . $sIV, 0, 512 ) ^ $sPassword;
        $i += 16;
    }

    return( base64_encode( $sEncrypted ) );
}

function StringDecrypt( $sEncrypted, $sPassword, $iVLength = 16 )
{
    $sEncrypted = base64_decode( $sEncrypted );
    $iLength = strlen( $sEncrypted );
    $i = $iVLength;

    $sText = '';
    $sIV = substr( $sPassword ^ substr( $sEncrypted, 0, $iVLength ), 0, 512 );
    while( $i < $iLength )
    {
        $sBlock = substr( $sEncrypted, $i, 16 );
        $sText .= $sBlock ^ pack( 'H*', md5( $sIV ) );
        $sIV = substr( $sBlock . $sIV, 0, 512 ) ^ $sPassword;
        $i += 16;
    }

    return( preg_replace( '/\\x13\\x00*$/', '', $sText ) );
}

if ( !function_exists( 'StringConvert' ) )
{
/** Convert a string from one charset into another. Currently only iso-8859-15, windows-1252 and utf-8 are supported
    @param $sBuffer string
    @param $sFrom charset
    @param $sTo charset
    @return string
*/
    function StringConvert( $sBuffer, $sFrom, $sTo )
    {
        switch( $sFrom )
        {
            case 'windows-1252':
                switch( $sTo )
                {
                    case 'windows-1252':
                    break;

                    case 'utf-8':
                        $sBuffer = StringWindowsToUtf8( $sBuffer );
                    break;

                    case 'iso-8859-15':
                    break;
                }
            break;

            case 'utf-8':
                switch( $sTo )
                {
                    case 'windows-1252':
                        $sBuffer = utf8_decode( $sBuffer );
                    break;

                    case 'utf-8':
                    break;

                    case 'iso-8859-15':
                        $sBuffer = utf8_decode( $sBuffer );
                    break;
                }
            break;

            case 'iso-8859-15':
                switch( $sTo )
                {
                    case 'windows-1252':
                    break;

                    case 'utf-8':
                        $sBuffer = utf8_encode( $sBuffer );
                    break;

                    case 'iso-8859-15':
                    break;
                }
            break;
        }

        return( $sBuffer );
    }
}

/** HtmlGetFile liest den Inhalt eines Files zeilenweise ein und gibt ihn als String zurck
    @param sFilename Dateiname der zu lesenden Datei
    @param sStartTag StartTag, ab dem eingefgt werden soll
    @param sStopTag  StopTag, bis zu dem eingefgt werden soll
    @return: HTML-File als String
    Wenn der StartTag nicht gefunden wird, wird die gesamte Datei gelesen
*/
function HtmlGetFile( $sFilename, $sStartTag = "<body[^>]*>", $sStopTag = "</body>" )
{
    global $oApp;

    if ( !FileRead( $sFilename, $sBuffer ) )
        return( '' );

    // get content between body tags
    if ( !IsNull( $sStartTag ) )
        // $sBuffer = eregi_replace( '^.*' . $sStartTag, '', $sBuffer );
        $sBuffer = preg_replace( '/^.*' . preg_quote( $sStartTag, '/' ) . '/i', '', $sBuffer );
    if ( !IsNull( $sStopTag ) )
        // $sBuffer = eregi_replace( $sStopTag . '.*$', '', $sBuffer );
        $sBuffer = preg_replace( '/' . preg_quote( $sStopTag, '/' ) . '.*$/i', '', $sBuffer );

    // set parameters used in html files
    $aParameter[ 'global.http' ] = $oApp->GetHttp();
    $aParameter[ 'global.root' ] = $oApp->GetRoot();
    $aParameter[ 'global.root#encoded' ] = urlencode( $oApp->GetRoot() );

    // replace parameters
    foreach( $aParameter as $sKey => $sValue )
        $sBuffer = str_replace( '{' . $sKey . '}', $sValue, $sBuffer );

    return( $sBuffer );
}

function HttpPost( $sUrl, $sData, $sHeader = null, $sContentType = null, $iTimeout = null, $sReferer = null )
{
    if ( $sContentType === null )
    {
        $sContentType = 'application/x-www-form-urlencoded';
    }

    if ( $iTimeout === null )
    {
        $iTimeout = 60;
    }

    // parse the given URL
    $aUrl = parse_url( $sUrl );

    if ( $aUrl[ 'scheme' ] != 'http' && $aUrl[ 'scheme' ] != 'https' )
    {
        die( 'Error: Only HTTP or HTTPS requests are supported!' );
    }
    if ( $aUrl[ 'port' ] == '' )
    {
        if ( $aUrl[ 'scheme' ] == 'https' )
        {
            $aUrl[ 'port' ] = '443';
        }
        else
        {
            $aUrl[ 'port' ] = '80';
        }
    }

    // open a socket connection
    $iFile = fsockopen( $aUrl[ 'host' ], $aUrl[ 'port' ], $iError, $sError, $iTimeout );

    if ( !$iFile )
    {
        $aMessage = array
        (
            'status' => 'error',
            'error' => $sError . '(' . $iError . ')'
        );

        return( $aMessage );
    }

    // send the request headers:
    fputs( $iFile, 'POST ' . $aUrl[ 'path' ] . '?' . $aUrl[ 'query' ] . " HTTP/1.1\r\n");
    fputs( $iFile, 'Host: ' . $aUrl[ 'host' ] . "\r\n" );

    if ( $sReferer != '' )
    {
        fputs( $iFile, 'Referer: ' . $sReferer . "\r\n" );
    }

    fputs( $iFile, 'Content-type: ' . $sContentType . "\r\n" );
    fputs( $iFile, 'Content-length: ' . strlen( $sData ) . "\r\n" );
    fputs( $iFile, "Connection: close\r\n\r\n" );
    fputs( $iFile, $sData );

    // receive the results of the request
    $sResult = '';
    while( !feof( $iFile ) )
    {
        $sResult .= fgets( $iFile, 128 );
    }

    // close the socket connection:
    fclose( $iFile );

    // split the result header from the content
    $aResult = explode( "\r\n\r\n", $sResult, 2 );

    $sHeader = isset( $aResult[ 0 ] ) ? $aResult[ 0 ] : '';
    $sContent = isset( $aResult[ 1 ] ) ? $aResult[ 1 ] : '';

    // return as structured array:
    $aMessage = array
    (
        'status' => 'ok',
        'header' => $sHeader,
        'content' => $sContent
    );

    return( $aMessage );
}

/** Erstellt aus einem Parameter-Array den Parameterstring fr einen Get-Url
    @param $aParameter Array mit den Namen und Parameterwerten
    @param $sSep1, default '?'
    @param $sSep2, default '&'
    @return String mit allen Parametern eg. ?name=value&name2=value2
*/
function HttpParam( $aParameter, $sSep1 = null, $sSep2 = null )
{
    if ( !is_array( $aParameter ) )
        return( '' );
    if ( $sSep1 === null )
        $sSep1 = '?';
    if ( $sSep2 === null )
        $sSep2 = '&';

    $sParameter = '';
	foreach ( $aParameter as $sKey => $sValue)
	{
	    if ( $sParameter != '' )
	        $sParameter .= $sSep2;

        if ( $sSep2 == '/' )
	        $sParameter = $sParameter . urlencode( $sKey ) .  '=' . urlencode( urlencode( $sValue ) );
	    else
	        $sParameter = $sParameter . urlencode( $sKey ) .  '=' . urlencode( $sValue );
	}

	if ( $sParameter != '' )
	    $sParameter = $sSep1 . $sParameter;

    return( $sParameter );
}

/** Analyzes and splits a http query into url and parameter array
    @param $sQuery http query like http://www.xyz.com/test.php?name1=value1&name2=value2
    @param $sUrl Output only http://www.xyz.com/test.php
    @param $aParameter Output only, array of name/value pairs (name1=value1, name2=value2)
    @param $sAnchor Output only, contains everything incl. the last #
    @return true
*/
function HttpSplit( $sQuery, &$sUrl, &$aParameter )
{
    return( HttpSplit2( $sQuery, $sUrl, $aParameter, $sAnchor ) );
}
function HttpSplit2( $sQuery, &$sUrl, &$aParameter, &$sAnchor, $sQuerySeparator = null, $sParamSeparator = null )
{
    $i = strrpos( $sQuery, '#' );
    if ( $i !== false )
    {
        $sAnchor = substr( $sQuery, $i );
        $sQuery = substr( $sQuery, 0, $i );
    }

    // find .php and extract url
    $i = strpos( $sQuery, '.php' );
    if ( $i !== false )
    {
        $sUrl = substr( $sQuery, 0, $i + 4 );
        $sQuery = substr( $sQuery, $i + 5 );
    }

    if ( $sQuerySeparator !== null )
    {
        $sQuery = str_replace( $sQuerySeparator, '?', $sQuery );
    }
    if ( $sParamSeparator !== null )
    {
        $sQuery = str_replace( $sParamSeparator, '&', $sQuery );
    }

    // since queryseparator and paramseparator may be /, sQuery may contain lots of ? and no &
    $aQuery = explode( '?', $sQuery );

    foreach( $aQuery as $sQuery )
    {
        foreach( explode( '&', $sQuery ) as $sValue )
        {
            if ( $sValue != '' )
            {
                $aEntry = explode( '=', $sValue );
                if ( $sParamSeparator == '/' )
                {
                    $aParameter[ $aEntry[ 0 ] ] = urldecode( urldecode( $aEntry[ 1 ] ) );
                }
                else
                {
                    $aParameter[ $aEntry[ 0 ] ] = urldecode( $aEntry[ 1 ] );
                }
            }
        }
    }

    return( true );
}

function HtmlUrlAbsolute( $sHtml, $sUrl, $sDir )
{
    // <a href="test.htm"> auf <a href="http://server/dir/test.htm"> ndern
    // <a href="/dir/test.htm"> auf <a href="http://server/dir/test.htm"> ndern
    $sHtml = HtmlUrlInsert( $sHtml, $sUrl, $sDir, '<img', 'src="' );
    $sHtml = HtmlUrlInsert( $sHtml, $sUrl, $sDir, '<a', 'href="' );
    $sHtml = HtmlUrlInsert( $sHtml, $sUrl, $sDir, '<td', 'background="' );

    return( $sHtml );
}

function HtmlUrlRelative( $sHtml, $sUrl, $sDir )
{
    // <a href="http://server/dir/test.htm"> auf <a href="test.htm"> ndern
    $sHtml = HtmlUrlDelete( $sHtml, $sUrl, $sDir, '<img', 'src="' );
    $sHtml = HtmlUrlDelete( $sHtml, $sUrl, $sDir, '<a', 'href="' );
    $sHtml = HtmlUrlDelete( $sHtml, $sUrl, $sDir, '<td', 'background="' );

    return( $sHtml );
}

function HtmlUrlInsert( $sHtml, $sUrl, $sDir, $sTag, $sParam )
{
    $sTag = strtolower( $sTag );
    $sParam = strtolower( $sParam );

    // $sBuffer is used for in strpos since PHP4 does not provide stripos
    $sBuffer = strtolower( $sHtml );

    $iStart = strpos( $sBuffer, $sTag );
    while( $iStart !== false && $iStart >= 0 )
    {
        $iStart += strlen( $sTag );

        $i = strpos( $sBuffer, $sParam, $iStart );
        if ( $i !== false && $i >= 0 )
        {
            $i += strlen( $sParam );

            // es darf kein http://, ftp://, mailto:, ... drinn stehen...
            $iStop1 = strpos( $sBuffer, ':', $i );
            $iStop2 = strpos( $sBuffer, '"', $i );
            if ( $iStop1 === false || $iStop1 > $iStop2 )
            {
                // If path is absolute, just prepend $sUrl, but not $sDir
                if ( substr( $sHtml, $i, 1 ) == '/' )
                {
                    $sHtml = substr( $sHtml, 0, $i ) . $sUrl . substr( $sHtml, $i );
                    $sBuffer = substr( $sBuffer, 0, $i ) . $sUrl . substr( $sBuffer, $i );
                }
                else
                {
                    $sHtml = substr( $sHtml, 0, $i ) . $sUrl . $sDir . substr( $sHtml, $i );
                    $sBuffer = substr( $sBuffer, 0, $i ) . $sUrl . $sDir . substr( $sBuffer, $i );
                }
                $iStart = $i;
            }
        }

        $iStart = strpos( $sBuffer, $sTag, $iStart );
    }

    return( $sHtml );
}

function HtmlUrlDelete( $sHtml, $sUrl, $sDir, $sTag, $sParam )
{
    $sTag = strtolower( $sTag );
    $sParam = strtolower( $sParam );

    $sBuffer = strtolower( $sHtml );
    $iStart = strpos( $sBuffer, $sTag );
    while( $iStart !== false && $iStart >= 0 )
    {
        $iStart += strlen( $sTag );

        $i = strpos( $sBuffer, $sParam, $iStart );
        if ( $i !== false && $i >= 0 )
        {
            $i += strlen( $sParam );

            // nextes " suchen
            $iStop = strpos( $sBuffer, '"', $i );
            if ( $iStop >= 0 )
            {
                $sUrlNew = substr( $sHtml, $i, $iStop - $i );

                if ( substr( $sUrlNew, 0, strlen( $sUrl ) ) == $sUrl )
                {
                    $sHtml = substr( $sHtml, 0, $i ) . substr( $sHtml, $iStop );
                    $sBuffer = substr( $sBuffer, 0, $i ) . substr( $sBuffer, $iStop );
                    $sHtml = substr( $sHtml, 0, $i ) . Pathlink( $sUrl . $sDir, $sUrlNew ) . substr( $sHtml, $i );
                    $sBuffer = substr( $sBuffer, 0, $i ) . Pathlink( $sUrl . $sDir, $sUrlNew ) . substr( $sBuffer, $i );
                    $iStart = $iStop;
                }
            }
        }

        $iStart = strpos( $sBuffer, $sTag, $iStart );
    }

    return( $sHtml );
}

/** Merged 2 Arrays miteinander, wobei die Eintrge in Array2 die Eintrge in Array1 berschreiben
    Sind beide Parameter keine Arrays, wird ein leeres Array zurckgegeben.
    Ist nur einer der beiden Parameter ein Array, so wird dieses Array zurckgegeben.
    Sind beide Parameter ein Array, so werden die Werte zusammengefhrt, wobei Array2 die Werte von Array1 berschreibt.
    @param $aArray1
    @param $aArray2
    @param $iMode   0 Array2 ergnzt/berschreibt Array1
                    1 Array2 ergnzt Array1
                    2 Array2 berschreibt Array1
                    3 Array2 ergnzt Array1, berschreibt Array1, wenn Value = Null;
    @return Array
*/
function ArrayMerge( $aArray1, $aArray2, $iMode = 0 )
{
    if ( !is_array( $aArray1 ) and !is_array( $aArray2 ) )
        return( array() );
    if ( is_array( $aArray1 ) and !is_array( $aArray2 ) )
        return( $aArray1 );
    if ( !is_array( $aArray1 ) and is_array( $aArray2 ) )
        return( $aArray2 );

    foreach( $aArray2 as $sKey => $sValue )
    {
        if ( $iMode == 0 )
            $aArray1[ $sKey ] = $sValue;
        if ( $iMode == 1 && !IsKey( $aArray1, $sKey ) )
            $aArray1[ $sKey ] = $sValue;
        if ( $iMode == 2 && IsKey( $aArray1, $sKey ) )
            $aArray1[ $sKey ] = $sValue;
        if ( $iMode == 3 && IsNull( $aArray1[ $sKey ] ) )
            $aArray1[ $sKey ] = $sValue;
    }

    return( $aArray1 );
}

// Aus einem 3-dim Array wird ein 2-dim Array einer bestimmten Spalte (Select-Array: Attribut)
// erzeugt.
// Vorausgesetzt, das Array ist wie folgt aufgebaut: array[Zeilen/Datenstze][Spalten/Attribute];
// param: 	3-dim Array, Index oder Assoziationsbez. der gewnschten Spalte,
//			boolean ... true, wenn Returnwert eindeutige Werte beinhalten soll
// return:	2-dim Array
// Beispiel:
//	$a2 = array( array() );
//	$a2 = $db->Read( "ipage_modul", "ipage_modul_id, name, link", "" , "ipage_modul_id" );
//  GetColumn( $a2, 1 ); // entspricht GetColumn( $a2, name ) und liefert alle name-Werte
function ArrayGetColumn( $aResult, $sColumn, $fDistinct = false )
{
    $aColumn = array();

    if ( !is_array( $aResult ) )
        return( $aColumn );

    foreach( $aResult as $sKey => $aRow )
		if ( !$fDistinct )
  			$aColumn[] = $aRow[ $sColumn ];
		else
			if ( !ArrayIsIn( $aColumn, $aRow[ $sColumn ] ) )
  			    $aColumn[] = $aRow[ $sColumn ];

	return( $aColumn );
}

function ArrayGetColumn2( $aResult, $sColumn )
{
    $aColumn = array();

    if ( !is_array( $aResult ) )
        return( $aColumn );

    foreach( $aResult as $iRow => $aRow )
        $aColumn[ $aRow[ $sColumn ] ] = $iRow;

    return( $aColumn );
}

// berprft ob ein Objekt Inhalt eines Arrays ist
// param: 	Array, Objekt
// return: 	true, wenn vorhanden, sonst false
function ArrayIsIn( $aArray, $sSearched, $fCaseSensitive = true )
{
   if ( !is_array( $aArray ) )
        return( false );

    if ( $fCaseSensitive )
        return( in_array( $sSearched, $aArray ) );

    foreach( $aArray as $sValue )
        if ( strcasecmp( $sSearched, $sValue ) == 0 )
            return( true );

	return( false );
}

// berprft ob ein Objekt Inhalt eines Arrays ist
// param: 	Array, Objekt
// return: 	key or null
function ArrayIsIn2( $aArray, $sSearched, $fCaseSensitive = true )
{
    if ( !is_array( $aArray ) )
        return( null );

    if ( $fCaseSensitive )
    {
        foreach( $aArray as $sKey => $sValue )
            if ( $sSearched == $sValue )
                return( $sKey );
    }
    else
    {
        foreach( $aArray as $sKey => $sValue )
            if ( strcasecmp( $sSearched, $sValue ) == 0 )
                return( $sKey );
    }

	return( null );
}

if ( !function_exists( 'array_key_exists' ) )
{
function array_key_exists( $key, $search )
{
    return( in_array( $key, array_keys( $search ) ) );
}
}

if ( !function_exists( 'array_intersect_key' ) )
{
// thx to Rod Byrnes (06-May-2007 05:10) (via PHP help)
function array_intersect_key($isec, $keys)
{
    $argc = func_num_args();
    if ( $argc > 2 )
    {
        for ( $i = 1; !empty( $isec ) && $i < $argc; $i++ )
        {
            $arr = func_get_arg( $i );
            foreach( array_keys( $isec ) as $key )
                if ( !isset( $arr[ $key ] ) )
                    unset( $isec[ $key ] );
        }
        return $isec;
    }
    else
    {
        $res = array();
        foreach( array_keys( $isec ) as $key )
            if ( isset( $keys[ $key ] ) )
                $res[ $key ] = $isec[ $key ];

        return $res;
    }
}
}

if ( !function_exists( 'array_combine' ) )
{
function array_combine( $aKeys, $aValues )
{
    $aCombined = array();
    foreach( $aKeys as $sKey => $sValue )
        $aCombined[ $sValue ] = $aValues[ $sKey ];
    return( $aCombined );
}
}

// Im Gegensatz zu implode besteht hier die Mglichkeit, da leere Felder nicht eingefgt werden.
/**
    @sLeft  is prepended to the value, default null
    @sRight is appended to the value, default null
*/
function ArrayImplode( $aArray, $sFiller, $fEmpty = null, $sLeft = null, $sRight = null )
{
    if ( $fEmpty === null )
        $fEmpty = true;

    if ( !is_array( $aArray ) )
        return( '' );

    $sBuffer = '';
	foreach ( $aArray as $sEntry )
    {
        if ( $fEmpty || ( $sEntry !== null && $sEntry !== '' ) )
        {
            if ( $sBuffer != '' )
                $sBuffer .= $sFiller;

            $sBuffer .= $sLeft . $sEntry . $sRight;
        }
    }

    return( $sBuffer );
}

/** berprft, ob der angegebene Key im Array vorhanden ist
    Wenn ein Eintrag im Array leer ist, dann wird Null zurckgegeben, obwohl ein Eintrag vorhanden ist.
    Mit IsKey kann berprft werden, ob ein Eintrag vorhanden ist.
    @param $aArray Array, da untersucht werden soll
    @param $sKey Schlssel, nach dem gesucht wird
    @return true/false
*/
function IsKey( $aArray, $sKey )
{
    if ( $aArray === null )
        return( false );
    if ( $sKey === null )
        return( false );

    if ( function_exists( 'array_key_exists' ) )
        return( array_key_exists( $sKey, $aArray ) );

    $aKeys = array_keys( $aArray );
    return( in_array( $sKey, $aKeys ) );
}

/**
    sId             Name des ID Feldes
    aMaster         3Dim Array
    aSlave          3Dim Array
    aInsert         3Dim Array, damit aus Slave ein Master wird
    aUpdate         3Dim Array, damit aus Slave ein Master wird
    aDelete         3Dim Array, damit aus Slave ein Master wird
    fInsert         Fehlende Eintrge sollen eingefgt werden
    fUpdate         Bestehende Eintrge sollen aktualisiert werden
    fDelete         Eintrge, die zuviel sind, sollen gelscht werden
    @param $iUpdateMode null: replace existing entry with new entry (default)
                        0 Array2 ergnzt/berschreibt Array1
                        1 Array2 ergnzt Array1
                        2 Array2 berschreibt Array1
                        3 Array2 ergnzt Array1, berschreibt Array1, wenn Value = Null;
    @Return void
*/
function ArraySync( $sId, $aMaster, $aSlave, &$aInsert, &$aUpdate, &$aDelete, $fInsert = true, $fUpdate = true, $fDelete = false, $iUpdateMode = null )
{
    // Jeden Datensatz im Master durchgehen und mit Slave vergleichen
    if ( $fInsert || $fUpdate )
		foreach( $aMaster as $sKey => $aRow )
		{
		    $sFound = ArrayFindRow( $aSlave, $sId, $aRow[ $sId ], false );
            if ( $sFound === null )
            {
				if ( $fInsert )
                    $aInsert[] = $aRow;
            }
            else
                if ( $fUpdate )
                    if ( $iUpdateMode === null )
                        $aUpdate[] = $aRow;
                    else
                        $aUpdate[] = ArrayMerge( $aRow, $aSlave[ $sFound ], $iUpdateMode );
        }

    // Jeden Datensatz im Slave durchgehen und mit Master vergleichen
    if ( $fDelete )
		foreach( $aSlave as $sKey => $aRow )
		{
		    $sFound = ArrayFindRow( $aMaster, $sId, $aRow[ $sId ], false );
            if ( $sFound === null )
                if ( $fDelete )
                    $aDelete[] = $aRow;
        }
}

/*
//  Type:               Function
//  Description:        Sucht in einem 3Dim Array nach einen sId Feld, da den Wert sValue hat.
//  Params:
//      aRows           3Dim Array
//      sId             Name des ID Feldes
//      sValue          Werd fr ID
//  Return:             Null oder sKey
*/
function ArrayFindRow( $aRows, $sId, $sValue, $fCasesensitive = true )
{
	if ( !is_array( $aRows ) )
		return( Null );

    if ( $fCasesensitive )
    {
        foreach( $aRows as $sKey => $aRow )
    		if ( $aRow[ $sId ] == $sValue )
                return( $sKey );
    }
    else
    {
        foreach( $aRows as $sKey => $aRow )
            if ( strcasecmp ( $aRow[ $sId ], $sValue ) == 0 )
                return( $sKey );
    }

	return( null );
}

// Gibt die Anzahl der Element eines Arrays zurck
// param: 	Array
// return: 	0, wenn das Array leer ist, oder das Array keine Elemente enthlt
// Beispiel:
function ArrayCount( $aArray )
{
    if ( !is_array( $aArray ) )
        return( 0 );

    return( count( $aArray ) );
}

// Funktioniert hnlich wie join(), aber
// - leere Array Elemente werden ignoiert
// - ist das Array leer, wir ein Leerstring zurckgegeben
// - als Abschlu kann ein optionaler und ein unbedingter Zusatzstring angehngt werden
// - Nach erfolgter Verarbeitung wird das Array mit unset() gelscht
// param: 	aArray          Array mit Strings
//          sFiller         String, der zwischen 2 Array Elementen eingefgt wird
//          sOptional       String, wird nur angehngt, wenn mindestens ein Eintrag im Array ist
//          sAlternativ     String, wird nur angehngt, wenn kein Eintrag im Array ist
//          sMust           String, der immer angehngt wird
// return: 	String
function ArrayJoin( $aArray, $sFiller = "", $sOptional = "", $sMust = "", $sAlternative = "" )
{
    if ( !is_array( $aArray ) )
        return( $sAlternative . $sMust );

    $sBuffer = "";

    foreach( $aArray as $sKey => $sValue )
        if ( strlen( $sValue ) > 0 )
        {
            if ( strlen( $sBuffer ) > 0 )
                $sBuffer .= $sFiller;
            $sBuffer .= $sValue;
        }

    if ( strlen( $sBuffer ) > 0 )
        $sBuffer .= $sOptional;
    else
        $sBuffer = $sAlternative;

    return( $sBuffer . $sMust );
}

function ArrayPrint( $aArray )
{
    DebugPrint( $aArray );
}

/** Reads a file and returns it as a string
    @param sFilename
    @param sBuffer
    @return true/false
*/
function FileRead( $sFilename, &$sBuffer )
{
    // use file_get_contents if available, should be faster (see PHP documentation)
    if ( function_exists( 'file_get_contents' ) )
        $sBuffer = file_get_contents( $sFilename );
    else
    {
        // read the whole file
    	if ( !( $pFile = fopen( $sFilename, 'r' ) ) )
    		return( false );

        $sBuffer = '';
    	while( !feof( $pFile ) )
    		$sBuffer .= fread( $pFile, 1024 );

    	fclose( $pFile );
    }

	return( true );
}

/** Writes the content into a file
    @param $sFilename name of the file
    @param $sBuffer content to be written
    @return true/false
*/
function FileWrite( $sFilename, $sBuffer )
{
    global $oApp;

    // use file_put_contents if available, should be faster (see PHP documentation)
    // 2009.07.29 DOH There seems to be a problem in IIS7 and file_put_contents. The normal write works.
    if ( function_exists( 'file_put_contents' ) && !$oApp->IsIis() )
        $iResult = file_put_contents( $sFilename, $sBuffer );
    else
    {
        // open the file
        $pFile = @fopen( $sFilename, 'w' );
    	if ( $pFile === false )
        	return( false );

        // write the content
    	$iResult = fwrite( $pFile, $sBuffer );
    	fclose( $pFile );
    }

	if ( $iResult === false )
	    return( false );

    return( true );
}

function FileCopy( $sSource, $sDestination )
{
    // 2010.02.23 DOH   this must be some relict from PHPv3 times...
    //if ( !FileRead( $sSource, $sBuffer ) )
    //    return( false );
    //if ( !FileWrite( $sDestination, $sBuffer ) )
    //    return( false );
    //return( true );

    return( copy( $sSource, $sDestination ) );
}

function FileDelete( $sFilename )
{
	return unlink( $sFilename );
}

/** Converts a text file to a charset
    @param $sFilename filename
    @param $sFrom source encoding: windows-1252, utf-8, iso-8859-15
    @param $sTo target encoding: windows-1252, utf-8, iso-8859-15
    @return boolean
*/
function FileConvert( $sFilename, $sFrom, $sTo )
{
    // Open source
    if ( !( $hFile = fopen( $sFilename, 'r' ) ) )
        return( false );

    // Open temp target
    $sTempname = tempnam( dirname( $sFilename ), basename( $sFilename ) );
    if ( !( $hTemp = fopen( $sTempname, 'w' ) ) )
        return( false );

    // Copy content line by line
    while( !feof( $hFile ) )
    {
        $sBuffer = fgets( $hFile );
        $sBuffer = StringConvert( $sBuffer, $sFrom, $sTo );
        fputs( $hTemp, $sBuffer );
    }

    // Close files
    fclose( $hTemp );
    fclose( $hFile );

    // Delete the original
    unlink( $sFilename );

    // Rename the temp to the original
    rename( $sTempname, $sFilename );

    return( true );
}

/** Verschiebt eine Datei nach dem Upload in ein anderes Verzeichnis
    @param $sPath Relativer Pfad fr das Images Verzeichnis
    @param $sFile Temporrer Dateiname des Bildes (Referenz!) --> returns new filename to caller (relativ to sPath)
    @param $sFileNew Original-Dateiname des Bildes
    @param $sFileOld Dateiname des derzeitigen Bildes
    @param $sFilePrefix Wird vor dem Dateinamen angehngt
    @param $sFilePostfix Wird zwischen Dateinamen und Extension eingefgt
    @param $iLevel = 0 Gibt an, auf wieviele Verzeichnisebenen die Bilder aufgeteilt werden sollen
    @return true/false
    $sFile enthlt nach dem Upload den neuen Dateinamen
    $sFileOld wird, falls vorhanden, gelscht.

    Es wird ein Dateiname wie folgender erzeugt:
    725d9847df2d4d572f5f5581c134d75a.gif

    Ist Level = 0, wird er direkt in das angegebene Verzeichnis gespeichert.
    Ist Level = 1, wird der erste Buchstabe als Verzeichnisname verwendet.
    Ist Level = 2, wird der erste Buchstabe fr die erste Verzeichnisebene, der zweite Buchstabe fr die 2 Ebene verwendet.
*/
function FileUpload( $sPath, &$sFile, $sFileNew, $sFileOld = '', $sFilePrefix = '', $sFilePostfix = '', $iLevel = 0 )
{
    global $oError;
    global $oResource;

    $fOk = true;

    // Create path
    DirectoryCreate( substr( $sPath, 0, -1 ), 0777 );

    // Falls vorhanden, alte Datei lschen
    if ( !IsNull( $sFileOld ) )
    {
        $sFileOld = $sPath . $sFileOld;
        if ( file_exists( $sFileOld ) )
            if ( unlink( $sFileOld ) === FALSE )
                if ( is_object( $oError ) && is_object( $oResource ) )
                    $oError->Add( $oResource->Error( 'file_delete', $sFileOld ) );
    }

    // Create new filename
    $sTo = FileTemp( $sPath, strtolower( Extension( $sFileNew ) ), $sFilePrefix, $sFilePostfix, $iLevel );

    // Datei kopieren
    if ( move_uploaded_file( $sFile, $sTo ) )
    {
        // Filesystem Rechte setzen
        chmod( $sTo, 0666 );

        // Neuen Dateinamen speichern
        $sFile = substr( $sTo, strlen( $sPath ) );
    }
    else
        if ( is_object( $oError ) && is_object( $oResource ) )
        {
            $oError->Add( $oResource->Error( 'file_copy', $sFile, $sTo ) );
            $fOk = false;
        }

    return( $fOk );
}

/** Kopiert eine Upload-Datei (die normalerweise bei einer Datensatz-Kopierung)
    @param $sPath Relativer Pfad fr das Images Verzeichnis
    @param $sFromPath Relativer Pfad fr das Source Verzeichnis
    @param $sFile Pfad und Dateiname des Bildes (ab Root Images) (Referenz!)
    @param $sFilePrefix Wird vor dem Dateinamen angehngt
    @param $sFilePostfix Wird zwischen Dateinamen und Extension eingefgt
    @param $iLevel = 0 Gibt an, auf wieviele Verzeichnisebenen die Bilder aufgeteilt werden sollen
    @return true/false
    $sFile enthlt nach dem Upload den neuen Pfad und Dateinamen (ab Images Verzeichnis)

    Es wird ein Dateiname wie folgender erzeugt:
    725d9847df2d4d572f5f5581c134d75a.gif

    Ist Level = 0, wird er direkt in das angegebene Verzeichnis gespeichert.
    Ist Level = 1, wird der erste Buchstabe als Verzeichnisname verwendet.
    Ist Level = 2, wird der erste Buchstabe fr die erste Verzeichnisebene, der zweite Buchstabe fr die 2 Ebene verwendet.
*/
function FileUploadCopy( $sPath, $sFromPath, &$sFile, $sFilePrefix = '', $sFilePostfix = '', $iLevel = 0 )
{
    global $oError;
    global $oResource;

    $fOk = true;

    // Wenn das Bild nicht vorhanden ist, dann einfach ignorieren
    if ( !file_exists( $sFromPath . $sFile ) )
        return( true );

    // Neuen Dateinamen erzeugen
    $sTo = FileTemp( $sPath, strtolower( Extension( $sFile ) ), $sFilePrefix, $sFilePostfix, $iLevel );

    // Datei kopieren
    $sFrom = $sFromPath . $sFile;
    if ( copy( $sFrom, $sTo ) )
    {
        // Filesystem Rechte setzen
        chmod( $sTo, 0666 );

        // Neuen Dateinamen speichern
        $sFile = substr( $sTo, strlen( $sPath ) );
    }
    else
        if ( is_object( $oError ) && is_object( $oResource ) )
        {
            $oError->Add( $oResource->Error( 'file_copy', $sFrom, $sTo ) );
            $fOk = false;
        }

    return( $fOk );
}

/** Lscht eine Upload-Datei
    @param $sPath Realtiver Pfad fr das Images Verzeichnis
    @param $sFile Dateiname des Bildes (Referenz!)
    @return true/false
    $sFile enthlt nach dem Upload den neuen Dateinamen
*/
function FileUploadDelete( $sPath, &$sFile )
{
    global $oError;
    global $oResource;

    $fOk = true;

    // Datei lschen
    $sFilename = $sPath . $sFile;
    if ( file_exists( $sFilename ) )
        if ( unlink( $sFilename ) )
            // Dateinamen lschen
            $sFile = '';
        else
            if ( is_object( $oError ) && is_object( $oResource ) )
            {
                $oError->Add( $oResource->Error( 'file_delete', $sFilename ) );
                $fOk = false;
            }

    return( $fOk );
}

// Client IP ermitteln
// param: keiner
// return: String
function ClientIP()
{
    $sClientIP = $_SERVER[ 'HTTP_X_FORWARDED_FOR' ];
    if ( isset( $sClientIP ) && $sClientIP != 'unknown' )
    {
        $sClientIP = explode( ',', $sClientIP );
        $sClientIP = $sClientIP[ 0 ];
        return( $sClientIP );
    }
    if ( isset( $_SERVER[ 'REMOTE_ADDR' ] ) )
        return( $_SERVER[ 'REMOTE_ADDR' ] );

    $sClientIP = getenv( 'HTTP_X_FORWARDED_FOR' );
    if ( isset( $sClientIP ) && $sClientIP != 'unknown' )
    {
        $sClientIP = explode( ',', $sClientIP );
        $sClientIP = $sClientIP[ 0 ];
        return( $sClientIP );
    }

    return( getenv( 'REMOTE_ADDR' ) );
}

/** Create all missing directories
    @param $sPath, eg. /dir/dir1/dir2 or ../dir/dir1/dir2
    @param $iMode, default 0700
    @return true/false
*/
function DirectoryCreate( $sPath, $iMode = null )
{
    if ( $iMode === null )
        $iMode = 0777;

    // avoid '..' problem.
    if ( strlen( $sPath ) < 3 )
        return( true );
    elseif ( is_dir( $sPath ) )
        return( true );
    elseif ( dirname( $sPath ) == $sPath )
        return( true );
    else
        DirectoryCreate( dirname( $sPath ), $iMode );

    if ( !mkdir( $sPath ) )
        return( false );
    if ( !chmod( $sPath, $iMode ) )
        return( false );

    return( true );
}

/** Delete directories recursivly
    @param $sPath, eg. /dir/dir1/dir2 or ../dir/dir1/dir2
    @return true/false
*/
function DirectoryDelete( $sPath )
{
    // Check directory
    if ( !is_dir( $sPath ) )
        return( false );

    // Open directory
    $hDir = opendir( $sPath );
    if ( !$hDir )
        return( false );

    // Process all entries
    while( ( $sFile = readdir( $hDir ) ) !== false )
    {
        if ( $sFile == '.' )
            continue;
        if ( $sFile == '..' )
            continue;

        if ( is_dir( $sPath . '/' . $sFile ) )
            // Recursively delete directory
            DirectoryDelete( $sPath . '/' . $sFile );
        else
            // Delete file
            unlink( $sPath . '/' . $sFile );
    }

    // Close directory
    closedir( $hDir );

    // Delete directory
    return( rmdir( $sPath ) );
}

/** Copy a directory recursive
    @param $sSource path to the source directory incl. trailing /
    @param $sDestination path to the destination directory incl. traisling /
    @param $fOverwrite overwrite existing files, default true
    @param $iDirectoryRights, default 0777
    @param $iFileRights, default 0666
    @return true/false
*/
function DirectoryCopy( $sSource, $sDestination, $fOverwrite = null, $iDirectoryRights = null, $iFileRights = null )
{
    if ( $fOverwrite === null )
        $fOverwrite = true;
    if ( $iDirectoryRights === null )
        $iDirectoryRights = 0777;
    if ( $iFileRights === null )
        $iFileRights = 0666;

    // Open source directory
    $hDirectory = opendir( $sSource );
    if ( !$hDirectory )
        return( false );

    // Create destination directory
    if ( !DirectoryCreate( $sDestination, $iDirectoryRights ) )
        return( false );

    // Copy all files recursive
    while( ( $sEntry = readdir( $hDirectory ) ) !== false )
    {
        // current directory
        if ( $sEntry == '.' )
            continue;
        // parent directory
        if ( $sEntry == '..' )
            continue;
        // empty directory marker (needed by mercurial)
        if ( $sEntry == '.emptydir' )
            continue;

        // hidden files
        if ( $sEntry[ 0 ] == '.' )
            continue;

        // ignore subdirectories
        if ( is_dir( $sSource . $sEntry ) )
        {
            if ( !DirectoryCopy( $sSource . $sEntry . '/', $sDestination . $sEntry . '/', $fOverwrite, $iDirectoryRights, $iFileRights ) )
                return( false );
        }
        elseif ( is_file( $sSource . $sEntry ) )
        {
            if ( $fOverwrite == true || !is_file( $sDestination . $sEntry ) )
            {
                if ( !copy( $sSource . $sEntry, $sDestination . $sEntry ) )
                    return( false );
                if ( !chmod( $sDestination . $sEntry, $iFileRights ) )
                    return( false );
            }
        }
    }
    closedir( $hDirectory );

    return( true );
}

// Filename
// Liefert den Dateinamen (ohne Extension)
function Filename( $sPath )
{
    $sFilename = basename( $sPath );

    $i = strpos( $sFilename, "." );
    if ( !is_string( $i ) || $i )
        $sFilename = substr( $sFilename, 0, $i );

    return( $sFilename );
}

// Extension
// Liefert die Extension (ohne Punkt)
function Extension( $sPath )
{
    $sExtension = basename( $sPath );

    $i = strrpos( $sExtension, '.' );
    if ( $i !== FALSE )
        $sExtension = substr( $sExtension, $i + 1 );
    else
        $sExtension = '';

    return( $sExtension );
}

// erstellt aus einen Array ein SQL-WHERE Statement
function Array2Statement( $aStatenents )
{
    $sStatements = '';

	foreach( $aStatenents as $sStatement )
		if ( $sStatement )
			$sStatements .= ( $sStatements ? " AND " : "" ) . $sStatement;

	return( $sStatements );
}

/** SystemSetTimeout
    @param $iTimeout Setzt den Execution Timeout von PHP. Angaben in Sekunden. -1 setzt das Timeout auf den Defaultwert zurck
    @return true/false
*/
function SystemSetTimeout( $iTimeout = null )
{
    // ignore user abort
    ignore_user_abort( true );

    // in safe mode, do not set the timeout limit.
    if ( ini_get( 'safe_mode' ) )
        return( false );

    // get default timeout value
    if ( $iTimeout === null || $iTimeout == -1 )
        $iTimeout = ini_get( 'max_execution_time' );

    // set timeout value
    set_time_limit( $iTimeout );

    return( true );
}

function PathLink( $sSource, $sDestination, $sDelimiter = "/" )
{
    while( true )
    {
        $i = strpos( $sSource, $sDelimiter ) + 1;
        $j = strpos( $sDestination, $sDelimiter ) + 1;

        if ( substr( $sSource, $i - 1, 1 ) <> $sDelimiter )
            break;
        if ( substr( $sDestination, $j - 1, 1 ) <> $sDelimiter )
            break;

        if ( substr( $sSource, 0, $i ) <> substr( $sDestination, 0, $j ) )
            break;

        $sSource = substr( $sSource, $i );
        $sDestination = substr( $sDestination, $j );
    }

    $sLink = "";

    while( true )
    {
        $i = strpos( $sSource, $sDelimiter );

        if ( !$i )
            break;

        $sLink = ".." . $sDelimiter . $sLink;
        $sSource = substr( $sSource, $i + 1 );
    }

    if ( $sLink == "." )
        $sLink = "." . $sDelimiter;

    return( $sLink . $sDestination );
}

/** berprft, ob eine Kreditkartennummer zu einer Kreditkartenfirma pat
    @param sType Name der Kreditkartenfirma: visa, mastercard, ...
    @param sNumber Nummer der Kreditkarte
    @return true (ok), false (ungltig)

    Card Type                   Prefix           Length     Check digit
     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     MasterCard                  51-55            16         mod 10
     Visa                        4                13, 16     mod 10
     AMEX                        34, 37           15         mod 10
     Dinners Club/Carte Blanche  300-305, 36, 38  14         mod 10
     Discover                    6011             16         mod 10
     enRoute                     2014, 2149       15         any
     JCB                         3                16         mod 10
     JCB                         2131, 1800       15         mod 10
     siehe auch http://www.beachnet.com/~hstiles/cardtype.hthml
*/
function CreditcardType( $sType, $sNumber )
{
    if ( preg_match( "/^5[1-5]\d{14}$/", $sNumber ) && $sType == 'mastercard' )
        return( true );

    else if ( preg_match( "/^4(\d{12}|\d{15})$/", $sNumber ) && $sType == 'visa' )
        return( true );

    else if ( preg_match( "/^3[47]\d{13}$/", $sNumber ) && $sType == 'amex' )
        return( true );

    else if ( ( preg_match( "/^[300-305]\d{11}$/", $sNumber ) || preg_match( "/^3[68]\d{12}$/", $sNumber ) ) && $sType == 'dinners' )
        return( true );

    else if ( preg_match( "/^6011\d{12}$/", $sNumber ) && $sType == 'discover' )
        return( true );

    else if ( preg_match( "/^2(014|149)\d{11}$/", $sNumber ) && $sType == 'enroute' )
        return( true );

    else if ( ( preg_match( "/^3\d{15}$/", $sNumber ) || preg_match( "/^(2131|1800)\d{11}$/", $sNumber ) ) && $sType == 'jcb' )
        return( true );

    return( false );
}

/** berprfe eine Kreditkartennummer auf Gltigkeit
    @param sNumber Kreditkartennummer
    @return true (ok), false (ungltige Nummer)
*/
function CreditcardNumber( $sNumber )
{
    for( $iSum = 0, $i = strlen( $sNumber ) - 1; $i >= 0; $i-- )
    {
        $iSum += $sNumber[ $i ];
        $sDigit = "" . ( 2 * $sNumber[ --$i ]);
        for( $j = strlen( $sDigit ) -1; $j >= 0; $j-- )
            $iSum += $sDigit[ $j ];
    }

    return( $iSum % 10 == 0 );
}

/** Supplies a file for downloading
    @param $sFilename Filename
    @param $sFilenameUser Filename for User, default null (uses basename of $sFilename then)
    @return void
*/
function FileDownload( $sFilename, $sFilenameUser = null, $sFilemode = null )
{
    global $oApp;

    if ( !file_exists( $sFilename ) )
        return( false );

    if ( $sFilenameUser === null || $sFilenameUser === '' )
    {
        $sFilenameUser = basename( $sFilename );

        if ( strpos( $sFilenameUser, '.' ) === false )
            $sFilenameUser .= '.' . Extension( $sFilename );
    }

    // Decode UTF-8 (IE6 needs that)
    if ( $oApp->GetCharset() == 'utf-8' )
        $sFilenameUser = utf8_decode( $sFilenameUser );

    if ( $sFilemode === null || $sFilemode === '' || ( $sFilemode != 'download' && $sFilemode != 'open' ) )
        $sFilemode = 'download';

    // Send headers
    // check PHPMagazin 2007.3, p. 76
    // Anzeige und Download einer PDF-Datei in einem Script
    header( 'Expires: Mon, 26 Jul 1997 05:00:00 GMT' );
    header( 'Last-Modified: ' . gmdate( 'D, d M Y H:i:s ') . ' GMT' );
    // Makes troubles with IE6:
    // header( 'Cache-Control: must-revalidate, post-check=0, pre-check=0', false );
    // header( 'Pragma: no-cache' );
    header( 'Cache-Control: maxage=3600' );
    header( 'Pragma: public' );

    if ( $sFilemode == 'download' )
    {
        header( 'Content-Description: File Transfer' );

        // Needed for IE6:
        if ( ( $oApp->GetBrowser() == 'IE' && $oApp->GetBrowserVersion() == '6.0' ) || $oApp->GetBrowser() == 'Opera' )
            header( 'Content-Type: application/octetstream' );
        else
            header( 'Content-Type: application/octet-stream' );

        header( 'Content-Disposition: filename="' . $sFilenameUser . '"' );
        header( 'Content-Disposition: attachment; filename="' . $sFilenameUser . '"' );
    }

    if ( $sFilemode == 'open' )
    {
        header( 'Content-Type: ' . MimeType( Extension( $sFilename ) ) );
        header( 'Content-Disposition: inline; filename="' . $sFilenameUser . '"' );
    }

    header( 'Content-Transfer-Encoding: binary' );
    header( 'Content-Length: ' . filesize( $sFilename ) );

    SystemSetTimeout( 0 );

    // Datei downloaden
    $oFile = fopen( $sFilename, 'rb' );
    fpassthru( $oFile );

    SystemSetTimeout();

    return( true );
}

/** Create a temp file
    @param $sPath Path, where the filename should go
    @param $sExtension Extension, the filename will have, default null
    @param $sPrefix Filename prefix, default null
    @param $sPostfix Filename postfix (before extension), default null
    @param $iLevel if level = 2 and filename = "1234", path will be extended into "path/1/2/", default 0
    @param $fPath Include sPath in returned value, default true
    @return Temporary filename inkluding path and extension
*/
function FileTemp( $sPath, $sExtension = Null, $sPrefix = Null, $sPostfix = Null, $iLevel = Null, $fPath = null )
{
    if ( $iLevel === null )
        $iLevel = 0;
    if ( $fPath === null )
        $fPath = true;

    srand( ( double ) microtime() * 1000000 );
    do
    {
        $sFilename = $sPrefix . md5( uniqid( rand() ) ) . $sPostfix . '.' . $sExtension;
        $sSubPath = '';
//        if ( !ini_get( 'safe_mode' ) )
            for ( $i = 1; $i <= $iLevel; $i++ )
            {
                $sSubPath .= substr( $sFilename, $i - 1, 1 );
                if ( !is_dir( $sPath . $sSubPath ) )
                    mkdir( $sPath . $sSubPath, 0777 );
                $sSubPath .= '/';
            }
        $sFilename = $sSubPath . $sFilename;
    }
    while( file_exists( $sPath . $sFilename ) );

    if ( $fPath )
        $sFilename = $sPath . $sFilename;

    return( $sFilename );
}

/** FileHtaccessDeny: creates a htaccess file to deny access
    @param $sFilename (absolut or relative)
*/
function FileHtaccessDeny( $sFilename )
{
    $sBuffer = '';
    $sBuffer .= '<Limit GET POST>' . "\n";
    $sBuffer .= '    order deny,allow' . "\n";
    $sBuffer .= '    deny from all' . "\n";
    $sBuffer .= '</Limit>' . "\n";

    return( FileWrite( $sFilename, $sBuffer ) );
}

/** FileIndexRedirect: creates a index.php file to redirect to the homepage
    @param $sFilename (absolut or relative)
*/
function FileIndexRedirect( $sFilename, $sRoot )
{
    $sBuffer = '';
    $sBuffer .= '<?php' . "\n";
    $sBuffer .= '' . "\n";
    $sBuffer .= 'include_once \'' . PathLink( $sFilename, $sRoot . 'include/opage.php' ) . '\';' . "\n";
    $sBuffer .= '' . "\n";
    $sBuffer .= 'header( \'HTTP/1.1 301 Moved Permanently\' );' . "\n";
    $sBuffer .= 'header( \'Location: \' . $oApp->GetHttp() . $oApp->GetRoot() );' . "\n";
    $sBuffer .= 'exit();' . "\n";
    $sBuffer .= '' . "\n";
    $sBuffer .= '?>' . "\n";

    return( FileWrite( $sFilename, $sBuffer ) );
}

/** MimeType
*/
function MimeType( $sExtension )
{
    switch( $sExtension )
    {
        case 'pdf':
            return( 'application/pdf' );
        break;

        case 'exe':
            return( 'application/octet-stream' );
        break;

        case 'zip':
            return( 'application/zip' );
        break;

        case 'doc':
            return( 'application/msword' );
        break;

        case 'xls':
            return( 'application/vnd.ms-excel' );
        break;

        case 'ppt':
            return( 'application/vnd.ms-powerpoint' );
        break;

        case 'gif':
            return( 'image/gif' );
        break;

        case 'png':
            return( 'image/png' );
        break;

        case 'jpeg':
        case 'jpg':
            return( 'image/jpg' );
        break;

        case 'mp3':
            return( 'audio/mpeg' );
        break;

        case 'wav':
            return( 'audio/x-wav' );
        break;

        case 'mpeg':
        case 'mpg':
        case 'mpe':
            return( 'video/mpeg' );
        break;

        case 'mov':
            return( 'video/quicktime' );
        break;

        case 'avi':
            return( 'video/x-msvideo' );
        break;
    }

    return( null );
}

function Something2Byte( $sSize = 0 )
{
    if ( !$sSize )
        return( 0 );

    $aSize[ 'MB' ] = 1048576;
    $aSize[ 'Mb' ] = 1048576;
    $aSize[ 'M' ] = 1048576;
    $aSize[ 'm' ] = 1048576;
    $aSize[ 'KB' ] = 1024;
    $aSize[ 'Kb' ] = 1024;
    $aSize[ 'K' ] = 1024;
    $aSize[ 'k' ] = 1024;

    $iLength = strlen( $sSize );
    foreach( $aSize as $sKey => $iBytes )
        if ( ( $iLength > strlen( $sKey ) ) && ( substr( $sSize, $iLength - strlen( $sKey ) ) == $sKey ) )
        {
            $sSize = substr( $sSize, 0, $iLength - strlen( $sKey ) ) * $iBytes;
            break;
        }

    return( $sSize );
}

if ( !function_exists( 'StringWindowsToUtf8' ) )
{
    /*
        This structure encodes the difference between ISO-8859-1 and Windows-1252,
        as a map from the UTF-8 encoding of some ISO-8859-1 control characters to
        the UTF-8 encoding of the non-control characters that Windows-1252 places
        at the equivalent code points.
        Aidan Kehoe <php-manual@parhasard.net>
    */
    global $aCp1252ToUtf8;
    $aCp1252ToUtf8 = array
    (
        "\xc2\x80" => "\xe2\x82\xac", /* EURO SIGN */
        "\xc2\x82" => "\xe2\x80\x9a", /* SINGLE LOW-9 QUOTATION MARK */
        "\xc2\x83" => "\xc6\x92",     /* LATIN SMALL LETTER F WITH HOOK */
        "\xc2\x84" => "\xe2\x80\x9e", /* DOUBLE LOW-9 QUOTATION MARK */
        "\xc2\x85" => "\xe2\x80\xa6", /* HORIZONTAL ELLIPSIS */
        "\xc2\x86" => "\xe2\x80\xa0", /* DAGGER */
        "\xc2\x87" => "\xe2\x80\xa1", /* DOUBLE DAGGER */
        "\xc2\x88" => "\xcb\x86",     /* MODIFIER LETTER CIRCUMFLEX ACCENT */
        "\xc2\x89" => "\xe2\x80\xb0", /* PER MILLE SIGN */
        "\xc2\x8a" => "\xc5\xa0",     /* LATIN CAPITAL LETTER S WITH CARON */
        "\xc2\x8b" => "\xe2\x80\xb9", /* SINGLE LEFT-POINTING ANGLE QUOTATION */
        "\xc2\x8c" => "\xc5\x92",     /* LATIN CAPITAL LIGATURE OE */
        "\xc2\x8e" => "\xc5\xbd",     /* LATIN CAPITAL LETTER Z WITH CARON */
        "\xc2\x91" => "\xe2\x80\x98", /* LEFT SINGLE QUOTATION MARK */
        "\xc2\x92" => "\xe2\x80\x99", /* RIGHT SINGLE QUOTATION MARK */
        "\xc2\x93" => "\xe2\x80\x9c", /* LEFT DOUBLE QUOTATION MARK */
        "\xc2\x94" => "\xe2\x80\x9d", /* RIGHT DOUBLE QUOTATION MARK */
        "\xc2\x95" => "\xe2\x80\xa2", /* BULLET */
        "\xc2\x96" => "\xe2\x80\x93", /* EN DASH */
        "\xc2\x97" => "\xe2\x80\x94", /* EM DASH */
        "\xc2\x98" => "\xcb\x9c",     /* SMALL TILDE */
        "\xc2\x99" => "\xe2\x84\xa2", /* TRADE MARK SIGN */
        "\xc2\x9a" => "\xc5\xa1",     /* LATIN SMALL LETTER S WITH CARON */
        "\xc2\x9b" => "\xe2\x80\xba", /* SINGLE RIGHT-POINTING ANGLE QUOTATION*/
        "\xc2\x9c" => "\xc5\x93",     /* LATIN SMALL LIGATURE OE */
        "\xc2\x9e" => "\xc5\xbe",     /* LATIN SMALL LETTER Z WITH CARON */
        "\xc2\x9f" => "\xc5\xb8"      /* LATIN CAPITAL LETTER Y WITH DIAERESIS*/
    );

    function StringWindowsToUtf8( $sBuffer )
    {
       global $aCp1252ToUtf8;
       return( strtr( utf8_encode( $sBuffer ), $aCp1252ToUtf8 ) );
    }
}
