<?php

defined( 'oPage' ) or die();

// Create content module
$oModule = $oFactory->Modul( 'CContact' );

// Create template
/* @var $oTemplate CTemplate */
$oTemplate = $this->Template( 'form.tpl', 'contact' );

// Form
$oForm = $oFactory->Control( 'CForm' );
$oForm->AddField( 'company' );
$oForm->AddField( 'intro', 'SELECT', true );
$oForm->AddField( 'title' );
$oForm->AddField( 'firstname', null, true );
$oForm->AddField( 'lastname', null, true );
$oForm->AddField( 'street' );
$oForm->AddField( 'zip' );
$oForm->AddField( 'city' );

if ( $oApp->GetoPage() != 'base' )
{
    $oCountry = $oFactory->Country();
    $oForm->SetDefault( 'country', 'AT' );
    $oForm->AddField( 'country', 'COUNTRY', true );
    $oForm->SetOptions( 'country', $oCountry->GetList() );
}

$oForm->AddField( 'telephone' );
$oForm->AddField( 'fax' );
$oForm->AddField( 'mobile' );
$oForm->AddField( 'email', 'EMAIL', true, true );
$oForm->AddField( 'text', 'TEXTBOX', true );
$oForm->AddField( 'captcha', 'CAPTCHA', true );
$oForm->AddField( 'submit', 'SUBMIT' );

if ( $oForm->IsSubmitted() && $oForm->Validate() )
{
    $fOk = true;

    // Prepare values
	$aValues = $oForm->GetValues();
	foreach( $aValues as $sKey => $sValue )
    {
	    $aValues[ $sKey ] = strip_tags( $sValue );
    }

    $oDate = $oFactory->Date();
    $aValues[ 'date' ] = $oDate->Format( 4 );

    // Insert data into database and send emails to user and admin
    if ( $oModule->AddActionWithValues( $aValues, 'plugin/contact/template/email.tpl', 'plugin/contact/template/email.tpl' ) )
    {
        $oTemplate->Parse( 'main.submitted' );
    }
    else
    {
        $oTemplate->Parse( 'main.error' );
    }
}
else
{
    $oForm->OutputTpl( $oTemplate );
}

// Parse
$oTemplate->Parse()->Output();

