<?php

defined( 'oPage' ) or die();

class CContact extends CModul
{
    function CContact( $sName = null )
    {
        // Create admin page
        $this->SetShowPageAdmin( true );

        // Set default name
        $this->SetDefault( 'contact' );

        // Initialize base class
        $this->CModul( $sName );

        // Set default sort orders
        $this->SetOrder( 'sort' );
        $this->SetOrder( 'date', 'desc' );

        $this->SetFieldUse( 'target', false );

        // Enabled default fields for listview in the administration interface
        $this->SetFieldUseAdminList( 'id' );
        $this->SetFieldUseAdminList( 'date' );
        $this->SetFieldUseAdminList( 'company' );
        $this->SetFieldUseAdminList( 'firstname' );
        $this->SetFieldUseAdminList( 'lastname' );
        $this->SetFieldUseAdminList( 'sort' );
        $this->SetFieldUseAdminList( 'display' );

        // get path to admin templates
        $this->SetAdminPath( 'plugin/contact/admin/contact/' );
    }

    function SetFields()
    {
        $this->SetField( 'id', 'ID' );
        $this->SetField( 'target' );
        $this->SetField( 'date', 'DATETIME' );
        $this->SetField( 'company' );
        $this->SetField( 'intro', 'SELECT' );
        $this->SetField( 'title' );
        $this->SetField( 'firstname' );
        $this->SetField( 'lastname' );
        $this->SetField( 'telephone' );
        $this->SetField( 'fax' );
        $this->SetField( 'mobile' );
        $this->SetField( 'email', 'EMAIL' );
        $this->SetField( 'street' );
        $this->SetField( 'zip' );
        $this->SetField( 'city' );
        $this->SetField( 'country', 'COUNTRY' );
        $this->SetField( 'text', 'TEXTBOX' );
        $this->SetField( 'sort', 'INTEGER' );
        $this->SetField( 'display', 'DISPLAY', true );

        parent::SetFields();
    }

    function AdminListProperties( &$oAdmin, $sName )
    {
        global $oApp;
        global $oFactory;

        parent::AdminListProperties( $oAdmin, $sName );

        switch( $sName )
        {
            case 'country':
                $oCountry = $oFactory->Country();
                $oAdmin->SetOptions( $sName, $oCountry->GetList() );
                $oAdmin->SetWidth( $sName, 25 );
                $oAdmin->SetMaxlength( $sName, 255 );
                $oAdmin->SetDefault( $sName, 'AT' );
            break;
        }
    }

    function AdminProperties( &$oAdmin, $sName )
    {
        global $oParameter;
        global $oApp;
        global $oFactory;

        parent::AdminProperties( $oAdmin, $sName );

        switch( $sName )
        {
            case 'country':
                $oCountry = $oFactory->Country();
                $oAdmin->SetOptions( $sName, $oCountry->GetList() );
                $oAdmin->SetWidth( $sName, 25 );
                $oAdmin->SetMaxlength( $sName, 255 );
                $oAdmin->SetDefault( $sName, 'AT' );
            break;
        }
    }

    function PrepareRow( &$aRow )
    {
        global $oApp;

        foreach( $this->GetFieldList() as $sName )
            switch( $sName )
            {
	            case 'date':
	                $this->PrepareDate( $aRow, $sName );
                break;

                case 'company':
                case 'title':
                case 'firstname':
                case 'lastname':
                case 'telephone':
                case 'fax':
                case 'mobile':
                case 'street':
                case 'zip':
                case 'city':
                case 'text':
                    $this->PrepareText( $aRow, $sName );
                break;
            }

        return( parent::PrepareRow( $aRow ) );
    }

    function GetEmailTarget()
    {
        $sTarget = '';

        // Get target parameter name
        if ( $this->GetFieldUse( 'target' ) )
        {
            // Get current row
            $iRow = $this->GetOutputRowFrom();

            // Get target value from current row
            $sTarget = $this->GetValue( $iRow, 'target' );

            if ( $sTarget != '' )
            {
                $sTarget = '#' . $sTarget;
            }
        }

        return( $sTarget );
    }

    function GetEmailAdmin()
    {
        return( $this->Parameter( 'email' . $this->GetEmailTarget(), parent::GetEmailAdmin() ) );
    }

    function GetEmailAdminName()
    {
        return( $this->Parameter( 'email_name' . $this->GetEmailTarget(), parent::GetEmailAdminName() ) );
    }

    function GetEmailFrom()
    {
        return( $this->Parameter( 'from_email' . $this->GetEmailTarget(), parent::GetEmailFrom() ) );
    }

    function GetEmailFromName()
    {
        return( $this->Parameter( 'from_email_name' . $this->GetEmailTarget(), parent::GetEmailFromName() ) );
    }
}

