<?php

defined( 'oPage' ) or die();

/** Plugin class
*/
class CContentPlugin extends CPlugin
{
    /** Setup plugins
        @var &$oSetup reference to the setup object
    */
    function Setup( &$oSetup )
    {
        $oSetup->AddModul( 'CContent' );

        // Add view to page
        $oSetup->AddPage( 'content', 'plugin_content', $this->GetPath() . 'view.php', null, 'Content', null, null, null, null, null, true );
    }

    /** Factory extension for the plugin
        @var $sClass name of the wanted class
    */
    function FactoryModul( $sClass, &$sCreate, &$sName, &$sInclude )
    {
        switch( $sClass )
        {
            case 'CContent':
                $sInclude = $this->sPath . 'modul/content.php';
            break;

            default:
                return( false );
            break;
        }

        return( true );
    }

    /** Factory extension for the plugin
        @param $oObject reference of the instanced
        @param $sClass name of the wanted class
    */
    function FactoryModulConfigure( &$oObject, $sClass )
    {
        /** @var CApp $oApp */
		global $oApp;
		/** @var CPlugins $oPlugins */
		global $oPlugins;

        switch( $sClass )
        {
            case 'CContent':
                // Use section_id only when section plugin is available
                if ( $oPlugins->Exists( 'section' ) )
                {
                    $oObject->SetFieldUseAdminList( 'section_id' );
                }

                $oObject->SetFieldUseAdminList( 'date' );
                $oObject->SetFieldUseAdminList( 'image_small' );
                $oObject->SetFieldUseAdminList( 'parent_id' );
                $oObject->SetFieldUseAdmin( 'image_text' );
                $oObject->SetFieldUseAdmin( 'filename_title' );
                $oObject->SetFieldUseAdmin( 'filename_name' );
                $oObject->SetFieldUseAdmin( 'filename_file' );
                $oObject->SetFieldUseAdmin( 'url_title' );
                $oObject->SetFieldUseAdmin( 'url' );
                $oObject->SetFieldUseAdmin( 'target' );
                // add a sub module named 'content'
                // this is important, since the submodule would have the same name as the main module otherwise
                // which does not work with the provided plugin templates
                $oObject->AddSub( $oObject->GetClass(), 'id', 'parent_id', 'content' );

				switch( $oApp->GetCharset() )
				{
					case 'utf-8':
						$aOptions[ StringWindowsToUtf8( '' ) ] = StringWindowsToUtf8( 'Standard' );
						$aOptions[ StringWindowsToUtf8( 'titleanddate' ) ] = StringWindowsToUtf8( 'Titel mit Datum' );
						$aOptions[ StringWindowsToUtf8( 'imageleft' ) ] = StringWindowsToUtf8( 'Bild links im Rand' );
						// $aOptions[ StringWindowsToUtf8( 'imageleft_hover' ) ] = StringWindowsToUtf8( 'Bild links (Hover)' );
						// $aOptions[ StringWindowsToUtf8( 'imageleft_zoom' ) ] = StringWindowsToUtf8( 'Bild links (Zoom)' );
						// $aOptions[ StringWindowsToUtf8( 'imageleft_zoomhover' ) ] = StringWindowsToUtf8( 'Bild links (Zoom & Hover)' );
						// $aOptions[ StringWindowsToUtf8( 'imageright' ) ] = StringWindowsToUtf8( 'Bild rechts' );
						// $aOptions[ StringWindowsToUtf8( 'imageright_hover' ) ] = StringWindowsToUtf8( 'Bild rechts (Hover)' );
						// $aOptions[ StringWindowsToUtf8( 'imageright_zoom' ) ] = StringWindowsToUtf8( 'Bild rechts (Zoom)' );
						// $aOptions[ StringWindowsToUtf8( 'imageright_zoomhover' ) ] = StringWindowsToUtf8( 'Bild rechts (Zoom & Hover)' );
						// $aOptions[ StringWindowsToUtf8( 'listimageleft' ) ] = StringWindowsToUtf8( 'Liste Bild links' );
						// $aOptions[ StringWindowsToUtf8( 'listimageright' ) ] = StringWindowsToUtf8( 'Liste Bild rechts' );
						// $aOptions[ StringWindowsToUtf8( 'listimageleftlinkurl' ) ] = StringWindowsToUtf8( 'Liste Bild links (verlinkt mit URL)' );
						// $aOptions[ StringWindowsToUtf8( 'listimagerightlinkurl' ) ] = StringWindowsToUtf8( 'Liste Bild rechts (verlinkt mit URL)' );
						$aOptions[ StringWindowsToUtf8( 'imagesleft' ) ] = StringWindowsToUtf8( 'Bild links im Text, Text daneben' );
						$aOptions[ StringWindowsToUtf8( 'imagesleft_block' ) ] = StringWindowsToUtf8( 'Bild links im Text, Text darunter' );
						// $aOptions[ StringWindowsToUtf8( 'imagesright' ) ] = StringWindowsToUtf8( 'Bilder rechts' );
						$aOptions[ StringWindowsToUtf8( 'imagesmall_left' ) ] = StringWindowsToUtf8( 'kleines Bild inline links' );
						$aOptions[ StringWindowsToUtf8( 'imagesmall_right' ) ] = StringWindowsToUtf8( 'kleines Bild inline rechts' );
						$aOptions[ StringWindowsToUtf8( 'imagesmall' ) ] = StringWindowsToUtf8( 'kleines Bild anzeigen' );
						$aOptions[ StringWindowsToUtf8( 'imagebig' ) ] = StringWindowsToUtf8( 'groes Bild anzeigen' );
						// $aOptions[ StringWindowsToUtf8( 'imageinline' ) ] = StringWindowsToUtf8( 'Bild im Text' );
					break;

					default:
						$aOptions[ '' ] = 'Standard';
						$aOptions[ 'titleanddate' ] = 'Titel mit Datum';
						$aOptions[ 'imageleft' ] = 'Bild links im Rand';
						// $aOptions[ 'imageleft_hover' ] = 'Bild links (Hover)';
						// $aOptions[ 'imageleft_zoom' ] = 'Bild links (Zoom)';
						// $aOptions[ 'imageleft_zoomhover' ] = 'Bild links (Zoom & Hover)';
						// $aOptions[ 'imageright' ] = 'Bild rechts';
						// $aOptions[ 'imageright_hover' ] = 'Bild rechts (Hover)';
						// $aOptions[ 'imageright_zoom' ] = 'Bild rechts (Zoom)';
						// $aOptions[ 'imageright_zoomhover' ] = 'Bild rechts (Zoom & Hover)';
						// $aOptions[ 'listimageleft' ] = 'Liste Bild links';
						// $aOptions[ 'listimageright' ] = 'Liste Bild rechts';
						// $aOptions[ 'listimageleftlinkurl' ] = 'Liste Bild links (verlinkt mit URL)';
						// $aOptions[ 'listimagerightlinkurl' ] = 'Liste Bild rechts (verlinkt mit URL)';
						$aOptions[ 'imagesleft' ] = 'Bild links im Text, Text daneben';
						$aOptions[ 'imagesleft_block' ] = 'Bild links im Text, Text darunter';
						// $aOptions[ 'imagesright' ] = 'Bilder rechts';
						$aOptions[ 'imagesmall_left' ] = 'kleines Bild inline links';
						$aOptions[ 'imagesmall_right' ] = 'kleines Bild inline rechts';
						$aOptions[ 'imagesmall' ] = 'kleines Bild anzeigen';
						$aOptions[ 'imagebig' ] = 'groes Bild anzeigen';
						// $aOptions[ 'imageinline' ] = 'Bild im Text';
					break;
				}
                $oObject->SetFieldAdminOptions( 'template', $aOptions );
            break;

            default:
                return( false );
            break;
        }

        return( true );
    }
}
