<?php

defined( 'oPage' ) or die();

$iContent = $oApp->GetParameter( 'content' );
$iParent = $oApp->GetParameter( 'parent' );

// Create content module
$oModule = $oFactory->Modul( 'CContent' );

// Create template
$oTemplate = $this->Template( 'content.tpl', $oModule->GetName() );

// Set filter for section
if ( $oModule->GetFieldUse( 'section_id' ) )
{
    /* @var CSectionController $oSectionController */
    $oSectionController = $oPlugins->Get( 'section' );
    $iSubSection = $oSectionController->GetSubSectionId();

    // Check for subsection parameter in $aParameter;
    if ( isset( $aParameter[ 'subsection' ] ) )
    {
        $aSubSection = $oSectionController->QuerySectionByName( $aParameter[ 'subsection' ] );
        if ( isset( $aSubSection ) )
        {
            $iSubSection = $aSubSection[ 'id' ];
            $oTemplate->Assign( 'subsection', $aSubSection );
        }
    }

    $oModule->SetFilter( 'section_id', $iSubSection );
}

// Is a content ID available?
if ( $iContent !== null && $iContent !== '' )
{
    $oModule->SetFilter( 'id', $iContent );
}
elseif ( $oModule->GetFieldUse( 'parent_id' ) )
{
    if ( $iParent !== null && $iParent !== '' )
    {
        $oModule->SetFilter( 'parent_id', $iParent );
    }
    else
    {
        // Only read root elements
        $oModule->SetFilter( 'parent_id', null );
    }
}

// Read
$oModule->QueryData();

// Output
$oModule->OutputTpl( $oTemplate );

// Parse
$oTemplate->Parse()->Output();

