<?php

defined( 'oPage' ) or die();

$iContent = $oApp->GetParameter( 'content' );
$iParent = $oApp->GetParameter( 'parent' );

// Create content module
$oModule = $oFactory->Modul( 'CContent' );

// Create template
$oTemplate = $this->Template( 'content.tpl', $oModule->GetName() );

// Create the pager control
$oPager = $oFactory->Control( 'CPager' );

// Set filter for section
if ( $oModule->GetFieldUse( 'section_id' ) )
{
    $oSectionController = $oPlugins->Get( 'section' );
    $oModule->SetFilter( 'section_id', $oSectionController->GetSubSectionId() );
    $oModule->SetRows( $oParameter->Get( 'content_rows:' . $oSectionController->GetSubSection(), $oParameter->Get( 'content_rows', $oParameter->Get( 'rows' ) ) ) );
}
else
{
    $oModule->SetRows( $oParameter->Get( 'content_rows', $oParameter->Get( 'rows' ) ) );
}

// Is a content ID available?
if ( $iContent !== null && $iContent !== '' )
{
    $oModule->SetFilter( 'id', $iContent );
}
elseif ( $oModule->GetFieldUse( 'parent_id' ) )
{
    if ( $iParent !== null && $iParent !== '' )
    {
        $oModule->SetFilter( 'parent_id', $iParent );
    }
    else
    {
        // Only read root elements
        $oModule->SetFilter( 'parent_id', null );
    }
}


$oModule->SetPage( $oPager->GetPage() );

// Read
$oModule->QueryData();

// Output
$oModule->OutputTpl( $oTemplate );

// Output the pager
$oPager->SetPages( $oModule->GetPages() );
if ( $oPager->GetPage() > 1 )
{
    $oPager->OutputTpl( $oTemplate, null, '1' );
}
$oPager->OutputTpl( $oTemplate, null, '2' );

// Parse
$oTemplate->Parse()->Output();

