<?php

defined( 'oPage' ) or die();

class CSection extends CModul
{
    function CSection( $sName = null )
    {
        // Create admin page
        $this->SetShowPageAdmin( true );
        // Set path to admin templates
        $this->SetAdminPath( 'plugin/section/admin/section/' );

        $this->SetDefault( 'section' );
        parent::CModul( $sName );

        // Filter setzen
        $this->SetFilter( 'display', 'y' );

        // Sortierung
        $this->SetOrder( 'parent_id' );
        $this->SetOrder( 'sort' );
        $this->SetOrder( 'title' );

        $this->SetFieldUse( 'parent_id', false );
        $this->SetFieldUse( 'name', false );
        $this->SetFieldUse( 'title_content', false );
        $this->SetFieldUse( 'text', false );
        $this->SetFieldUse( 'text_ishtml', false );
        $this->SetFieldUse( 'page_name', false );
        $this->SetFieldUse( 'paramter', false );
        $this->SetFieldUse( 'style', false );
        $this->SetFieldUse( 'banner', false );
        $this->SetFieldUse( 'use_page_title', false );
        $this->SetFieldUse( 'navigation_hide', false );
        $this->SetFieldUse( 'menu_hide', false );
        $this->SetFieldUse( 'select_hide', false );
        $this->SetFieldUse( 'admin_navigation_hide', false );
        $this->SetFieldUse( 'admin_menu_hide', false );
        $this->SetFieldUse( 'admin_select_hide', false );
        $this->SetFieldUse( 'preview', false );

        $this->SetFieldUseAdminList( 'sort', true );
        $this->SetFieldUseAdminList( 'title', true );
    }

    function SetFields()
    {
        $this->SetField( 'id', 'ID' );
        $this->SetField( 'parent_id', 'FOREIGNID' );
        $this->SetField( 'name', 'NAME' );
		$this->SetField( 'title', null, true );
		$this->SetField( 'title_menu', null, true );
		$this->SetField( 'title_navigation', null, true );
		$this->SetField( 'title_content', null, true );
        $this->SetField( 'text', 'TEXTBOX', true );
        $this->SetField( 'text_ishtml', 'YESNO', true );
        $this->SetField( 'page_name', 'FOREIGNNAME' );
        $this->SetField( 'parameter' );
        $this->SetField( 'use_page_title', 'YESNO', true );
        $this->SetField( 'style' );
        $this->SetField( 'banner', 'YESNO' );
        $this->SetField( 'navigation_hide', 'YESNO', true );
        $this->SetField( 'menu_hide', 'YESNO', true );
        $this->SetField( 'select_hide', 'YESNO', true );
        $this->SetField( 'admin_navigation_hide', 'YESNO', true );
        $this->SetField( 'admin_menu_hide', 'YESNO', true );
        $this->SetField( 'admin_select_hide', 'YESNO', true );
        $this->SetField( 'sort', 'INTEGER' );
        $this->SetField( 'display', 'DISPLAY', true );
        $this->SetField( 'preview', 'YESNO' );

        parent::SetFields();
    }

    function AdminList( &$oAdmin )
    {
        global $oApp;

        if ( $this->GetFieldUse( 'parent_id' ) )
        {
            $oAdmin->AddBlockRow( 'action_button#parent_id' );

            if ( !Isnull( $oApp->GetParameter( 'parent_id' ) ) )
            {
                $this->SetFilter( 'parent_id', $oApp->GetParameter( 'parent_id' ) );
                $this->SetFieldUseAdminList( 'parent_id', false );
            }
            else
                if ( !Isnull( $oApp->GetParameter( 'subsection' ) ) )
                {
                    $this->SetFilter( 'parent_id', $oApp->GetParameter( 'subsection' ) );
                    $this->SetFieldUseAdminList( 'parent_id', false );
                }
        }

        parent::AdminList( $oAdmin );
    }

    function AdminListProperties( &$oAdmin, $sName )
    {
        global $oFactory;

        parent::AdminListProperties( $oAdmin, $sName );

        switch( $sName )
        {
            case 'parent_id':
                $sField = 'title';
                if ( $this->GetFieldUse( 'title_navigation' ) )
                {
                    $sField = 'title_navigation';
                }
                $aSection = $this->GetList( array( $sField ), null, '', null, array( '0' => ' - ' ), null, null, true );
                $oAdmin->SetOptions( $sName, $aSection );
            break;

            case 'name':
                $oAdmin->SetWidth( $sName, 30 );
                $oAdmin->SetMaxlength( $sName, 255 );
            break;

            case 'title':
                $oAdmin->SetWidth( $sName, 30 );
                $oAdmin->SetMaxlength( $sName, 255 );
            break;
        }
    }

    function Admin( &$oAdmin )
    {
        global $oApp;

        // call parent
        parent::Admin( $oAdmin );

        if ( $this->GetFieldUse( 'parent_id' ) )
        {
            // Look for parameter parent_id
            $iParent = $oApp->GetParameter( 'parent_id' );

            // Look for parameter parent_id in form
            if ( $iParent == null )
            {
                // Initialise the admin form
                $oAdmin->InitForm();

                $iParent = $oAdmin->GetValue( 'parent_id' );
            }

            // Look for parameter subsection as parent_id
            if ( $iParent == null )
                $iParent = $oApp->GetParameter( 'subsection' );

            // No parent id? -> query the current record and use the parent_id of the first record
            if ( $iParent == null )
            {
                $this->QueryData();
                $iParent = $this->Get( 'parent_id' );
            }

            // Set default for parent_id
            $oAdmin->SetDefault( 'parent_id', $iParent );

            // query parent data and use as default
            if ( $iParent != null )
            {
                $aResult = $this->QueryRows( array( 'name' ), array( $this->GetField( 'id' ) => array( 'value' => $iParent, 'compare' => '=' ) ) );

                if ( $aResult[ 0 ][ 'name' ] != '' )
                    $oAdmin->SetDefault( 'name', $aResult[ 0 ][ 'name' ] . ' - ' );
            }
        }
    }

    function AdminProperties( &$oAdmin, $sName )
    {
        global $oFactory;
        global $sRoot;

        parent::AdminProperties( $oAdmin, $sName );

        switch( $sName )
        {
            case 'parent_id':
                $sField = 'title';
                if ( $this->GetFieldUse( 'title_navigation' ) )
                {
                    $sField = 'title_navigation';
                }
                $aSection = $this->GetList( array( $sField ), null, '', null, array( '0' => ' - ' ), null, null, true );
                $oAdmin->SetOptions( $sName, $aSection );
            break;

            case 'name':
                $oAdmin->SetWidth( $sName, 50 );
                $oAdmin->SetMaxlength( $sName, 255 );
            break;

            case 'title':
                $oAdmin->SetWidth( $sName, $this->GetFieldWidthAdmin( $sName, 140 ) );
                $oAdmin->SetMaxlength( $sName, 255 );
            break;

            case 'title_menu':
                $oAdmin->SetWidth( $sName, $this->GetFieldWidthAdmin( $sName, 50 ) );
                $oAdmin->SetMaxlength( $sName, 255 );
                $oAdmin->SetSyncMaster( $sName, str_replace( '_menu', '', $sName ) );
            break;

            case 'title_navigation':
                $oAdmin->SetWidth( $sName, $this->GetFieldWidthAdmin( $sName, 50 ) );
                $oAdmin->SetMaxlength( $sName, 255 );
                $oAdmin->SetSyncMaster( $sName, str_replace( '_navigation', '', $sName ) );
            break;

            case 'title_content':
                $oAdmin->SetWidth( $sName, $this->GetFieldWidthAdmin( $sName, 140 ) );
                $oAdmin->SetMaxlength( $sName, 255 );
                $oAdmin->SetSyncMaster( $sName, str_replace( '_content', '', $sName ) );
            break;

            case 'text':
                $oAdmin->SetWidth( $sName, 142 );
                $oAdmin->SetHeight( $sName, $this->GetFieldHeightAdmin( $sName, 6 ) );
            break;

            // name is used differently here as usually
            case 'page_name':
                $oPage = $oFactory->Modul( 'CPage' );

                $sFilter = null;
                if ( $oPage->GetFieldUse( 'page_content' ) )
                    $sFilter .= ( $sFilter ? ' and ' : '' ) . $this->GetField( 'page_content' ) . '=\'y\'';

                $oPage->ClearOrders();
                $oPage->SetOrder( 'title_display' );
                $oAdmin->SetOptions( $sName, $oPage->GetList( array( 'title_navigation', 'name' ), $sFilter, null, 'name', array( '0' => ' ', '2a' => '(', '2b' => ')' ) ) );
                $oAdmin->SetMaxlength( $sName, 255 );
                $oAdmin->SetDefault( $sName, 'home' );
            break;

            case 'style':
                $oAdmin->SetWidth( $sName, 50 );
                $oAdmin->SetMaxlength( $sName, 255 );
            break;
        }
    }

	function PrepareRowEdit( &$aValues, $sAction = 'changed', $fClear = false )
	{
        global $oApp;

		// Prepare field 'name':
		// Replace all ' ' with '_'
		// Repalce all '' with 'aeoeue'
		// Repalce all '' with 'AeOeUe'
		// Repalce all '' with 'ss'
		if ( $this->GetFieldUse( 'name' ) )
        {
            // Default chars
            $aReplace = array( ' ', '/', '.', '"', '\'', ':', '#', '?' );
            $aWith = array( '_', '-', '', '', '', '', '', '' );

            // Umlaute
            switch( $oApp->GetCharset() )
            {
                case 'utf-8':
                    $aReplace = array_merge( $aReplace, array( StringWindowsToUtf8( '' ), StringWindowsToUtf8( '' ), StringWindowsToUtf8( '' ), StringWindowsToUtf8( '' ), StringWindowsToUtf8( '' ), StringWindowsToUtf8( '' ), StringWindowsToUtf8( '' ) ) );
                break;

                default:
                    $aReplace = array_merge( $aWith, array( '', '', '', '', '', '', '' ) );
                break;
            }
            $aWith = array_merge( $aWith, array( 'ae', 'oe', 'ue', 'Ae', 'Oe', 'Ue', 'ss' ) );

            // Ampersent
            $aReplace[] = '&';
            if ( $oApp->GetLanguageShortText( true ) == 'de' )
            {
                $aWith[] = 'und';
            }
            else
            {
                $aWith[] = 'and';
            }

            // Replace "--" with "-"
            $aReplace[] = '--';
            $aWith[] = '-';

            $aValues[ 'name' ] = str_replace( $aReplace, $aWith, $aValues[ 'name' ] );
        }

        return( parent::PrepareRowEdit( $aValues, $sAction, $fClear ) );
	}

    function PrepareRow( &$aRow )
    {
        if ( $this->GetFieldUse( 'title_content' ) )
        {
            if ( $aRow[ 'title_content' ] == '' )
            {
                $aRow[ 'title_content' ] = $aRow[ 'title' ];
            }
        }

        $this->PrepareText( $aRow, 'title' );
        $this->PrepareText( $aRow, 'title_menu' );
        $this->PrepareText( $aRow, 'title_navigation' );
        $this->PrepareText( $aRow, 'title_content' );
        $this->PrepareText( $aRow, 'text', $aRow[ 'text_ishtml' ] == 'y' );

        return( parent::PrepareRow( $aRow ) );
    }

    /** Liefert alle Namen als eine Liste fr eine SelectBox
        @Param $sCategory Name der Kategorie, deren Unterpunkte ausgelesen werden sollen (zieht vor $sCategoryId)
        @Param $sCategoryId Id der Kategorie, deren Unterpunkte ausgelesen werden sollen
        @Param $iDepth Anzahl der Stufen, die ausgelesen werden sollen (0 nur die aktuelle), -1 fr alle Stufen
        @Param $sField Feldname, der verwendet werden soll
        @Param $fLeavesOnly Nur die unterste Ebene soll angezeigt werden.
        @param $sTitle Titel, der als Prefix vor die Eintrge gestellt werden soll, zb. Title - Kategorie Level 1 - Kategorie Level2
        @param $fTitleAppend sTitel vorne anhngen, default true
        @param $iOverrideLevel Ab diesem Level wird sOverrideValue verwendet, falls vorhanden. Default leer
            D.h. wenn $iValueLevel = 1, dann wird am dem Level 1 nicht der Inhalt von $sField verwendet, sondern der Inhalt der bergeordneten Kategorie
            Wird bei den Sections verwendet, damit beim Ersetzen immer die Hauptsection verwendet wird.
        @param $sOverrideValue Wert der verwendet wird (wenn leer, wird der Inhalt von $sField verwendet). Default leer.
        @param $sFieldId Name field used as array index
        @Return void
    */
    function GetListX
    (
        $sCategory = null,
        $iCategoryId = null,
        $iDepth = null,
        $sField = null,
        $fLeavesOnly = null,
        $sTitle = null,
        $fTitleAppend = null,
        $iOverrideLevel = null,
        $sOverrideValue = null,
        $sFieldId = null
    )
    {
        global $oDb;

        if ( $sCategory === null )
            $sCategory = '';
        if ( $iCategoryId === null )
            $iCategoryId = '';
        if ( $iDepth === null )
            $iDepth = 0;
        if ( $sField === null )
            $sField = 'title';
        if ( $fLeavesOnly === null )
            $fLeavesOnly = false;
        if ( $sTitle === null )
            $sTitle = '';
        if ( $fTitleAppend === null )
            $fTitleAppend = true;
        if ( $iOverrideLevel === null )
            $iOverrideLevel = '';
        if ( $sOverrideValue === null )
            $sOverrideValue = '';
        if ( $sFieldId === null )
            $sFieldId = 'id';

		$sTable = $this->GetTable();
        $sFields = $this->GetFields();
        $sOrder = $this->GetOrders();

        // Wenn wir einen Kategorienamen haben, die zugehrige Id lesen
        if ( $this->GetFieldUse( 'name' ) and !Isnull( $sCategory ) )
        {
      		$sFilter = $this->GetField( 'name' ) . "='$sCategory'";

        	$aResult = $oDb->Read( $sTable, $sFields, $sFilter, $sOrder );

        	if ( ArrayCount( $aResult ) == 0 )
        	    die( "CCategory: GetList: Ungltiger Name: $sCategory" );

        	$iCategoryId = $aResult[0][ 'id' ];
        }

        // Eigenen Filter definieren
        $sFilter = null;
        if ( $this->GetFieldUse( 'display' ) && $this->IsFilter( 'display' ) )
            $sFilter = $this->GetField( 'display' ) . '<>\'n\'';

        if ( !Isnull( $sFilter ) )
            $sFilter = "( $sFilter ) ";

        // Kategorien auslesen
        if ( $this->GetFieldUse( 'parent_id' ) )
        {
            if ( !Isnull( $sFilter ) )
                $sFilter .= 'and ';
            if ( !Isnull( $iCategoryId ) )
                // Die Untergeordneten Punkte auslesen
        		$sFilter = $sFilter . '( ' . $this->GetField( 'parent_id' ) . "=$iCategoryId AND " . $this->GetField( 'parent_id' ) . "<>" . $this->GetField( 'id' ) . ' )';
            else
                // Alle Top-Kategorien auslesen
        		$sFilter = $sFilter . '( ' . $this->GetField( 'parent_id' ) . " is null or " . $this->GetField( 'parent_id' ) . "=" . $this->GetField( 'id' ) . ' )';
        }

        if ( $this->GetDebug() )
        {
            echo "<hr>";
            echo $this->GetName() . ': QueryData()<br>';
            echo "Table: $sTable<br>";
            echo "Fields: $sFields<br>";
            echo "Filter: $sFilter<br>";
            echo "Order: $sOrder<br>";
        }

        // Daten lesen
    	$aResult = $oDb->Read( $sTable, $sFields, $sFilter, $sOrder );

        if ( $this->GetDebug() )
        {
            echo "<hr>";
            echo $this->GetName() . ': QueryData() Data<br>';
            ArrayPrint( $aResult );
        }

        // Array Initialisieren
        $aList = array();

        if ( !Isnull( $sTitle ) )
            $sTitle .= ' - ';

        // Override Level verringern
        if ( !Isnull( $iOverrideLevel ) )
            $iOverrideLevel--;

        // Alle gefundenen Datenstze verarbeiten
		foreach ( $aResult as $aRow )
		{
            // Wert aus der DB oder OverrideValue verwenden?
            if ( !Isnull( $sOverrideValue ) )
                $sValue = $sOverrideValue;
 		    else
 		        $sValue = $aRow[ $sField ];

            // Wert in die Liste einfgen
            if ( !$fLeavesOnly || $iDepth == 0 )
            {
                if ( $fTitleAppend )
        		    $aList[ $aRow[ $sFieldId ] ] = $sTitle . $sValue;
        		else
        		    $aList[ $aRow[ $sFieldId ] ] = $sValue;
            }

            // Rekursion
			if ( $iDepth != 0 )
			{
			    $sValue = '';
			    if ( !Isnull( $sOverrideValue ) )
			        $sValue = $sOverrideValue;
			    else
        		    if ( !Isnull( $iOverrideLevel ) )
        		        if ( $iOverrideLevel <= 0 )
            		        $sValue = $aRow[ $sField ];

			    if ( $fTitleAppend )
			        $sTitleAppend = $aRow[ $sField ];
			    else
			        $sTitleAppend = '';

			    $aListSub = $this->GetListX( '', $aRow[ 'id' ], $iDepth - 1, $sField, $fLeavesOnly, $aRow[ $sField ], $fTitleAppend, $iOverrideLevel, $sValue, $sFieldId );
                $aList = ArrayMerge( $aList, $aListSub );
            }
        }

        return( $aList );
	}
}

