<?php

defined( 'oPage' ) or die();

/** Plugin class
*/
class CSectionNavigationSubPlugin extends CPlugin
{
    var $fNavigation = true;
    var $oNavigation;

    function CSectionNavigationSubController()
    {
        parent::CPlugin();

        // Set output block
        $this->SetBlock( 'sectionnavigationsub' );
    }

    /** use CNavigation oder CMenu?
    */
    function SetNavigation( $fValue = null )
    {
        if ( $fValue === null )
        {
            $fValue = true;
        }

        $this->fNavigation = $fValue;
    }
    function GetNavigation()
    {
        return( $this->fNavigation );
    }

    /** use CNavigation oder CMenu?
    */
    function SetMenu( $fValue = null )
    {
        if ( $fValue === null )
        {
            $fValue = true;
        }

        $this->fNavigation = !$fValue;
    }
    function GetMenu()
    {
        return( !$this->fNavigation );
    }

    /** Hook entry point for WebpageX
        @param &$oWebpage reference to the page object
        @param $sPart ('constructor', 'begin_pre', 'begin', 'end')
    */
    function WebpageX( &$oWebpage, $sPart )
    {
        global $oFactory;
        global $oPlugins;

        parent::WebpageX( $oWebpage, $sPart );

        switch( $sPart )
        {
            case 'constructor':
            break;

            case 'begin':
                // Get section plugin Controller
                $oSectionController = $oPlugins->Get( 'section' );

                // create navigation object
                if ( $this->GetNavigation() )
                {
                    $this->oNavigation = $oFactory->Control( 'CNavigation' );
                }
                else
                {
                    $this->oNavigation = $oFactory->Control( 'CMenu', 'navigation' );
                }

                // get all top section below the current main section
                $oSectionController->FillNavigation( $this->oNavigation, $oSectionController->GetSectionId(), 'parent_id', null, true );
                // set active items:
                // section names are unique
                // subsections have the following format: section_-_subsection_-_subsubsection
                $aSections = explode( '_-_', $oSectionController->GetSubSection() );
                $sSubSection = '';
                foreach( $aSections as $sSection )
                {
                    if ( $sSubSection != '' )
                    {
                        $sSubSection .= '_-_';
                    }
                    $sSubSection .= $sSection;

                    $this->oNavigation->AddActive( $sSubSection );
                }
            break;

            case 'end':
                // @var $oTemplate CTemplate
                $oTemplate = $this->Template( 'content.tpl', 'sectionnavigationsub' );

                // output navigation
                $this->oNavigation->OutputTpl( $oTemplate );

                // Get the output
                $oTemplate->Parse();
                $oWebpage->Assign( $this->GetName(), $oTemplate->Text() );
                $oWebpage->Parse( 'main.' . $this->GetName() );
            break;
        }
    }
}
