<?php

defined( 'oPage' ) or die();

/** Plugin class
*/
class CSectionNavigationTopPlugin extends CPlugin
{
    /**
     * use CNavigation by default, use CMenu when false
     */
    var $fNavigation = true;

    var $oNavigation;

    function __construct()
    {
        parent::CPlugin();

        // Set output block
        $this->SetBlock( 'sectionnavigationtop' );
    }

    /** Hook entry point for WebpageX
        @param &$oWebpage reference to the page object
        @param $sPart ('constructor', 'begin_pre', 'begin', 'end')
    */
    function WebpageX( &$oWebpage, $sPart )
    {
        global $oFactory;
        global $oPlugins;

        parent::WebpageX( $oWebpage, $sPart );

        switch( $sPart )
        {
            case 'constructor':
            break;

            case 'begin':
                // Get section plugin Controller
                $oSectionPlugin = $oPlugins->Get( 'section' );

                // create navigation object
                if ( $this->fNavigation )
                {
                    $this->oNavigation = $oFactory->Control( 'CNavigation' );
                }
                else
                {
                    $this->oNavigation = $oFactory->Control( 'CMenu', 'navigation' );
                }

                // get all top section entries (where parent_id is null)
                $oSectionPlugin->FillNavigation( $this->oNavigation, null, 'parent_id' );
                $this->oNavigation->SetActive( $oSectionPlugin->GetSection() );
            break;

            case 'end':
                // Create template
                $oTemplate = $this->Template( 'content.tpl', 'sectionnavigationtop' );

                // output navigation
                $this->oNavigation->OutputTpl( $oTemplate );

                // Get the output
                $oTemplate->Parse();
                $oWebpage->Assign( $this->GetBlock(), $oTemplate->Text() );
                $oWebpage->Parse( 'main.' . $this->GetBlock() );
            break;
        }
    }

    /**
     * Set type to navigation
     */
    function SetNavigation( $fValue = null )
    {
        if ( $fValue === null )
            $fValue = true;

        $this->fNavigation = $fValue;
    }

    /**
     * Is current mode navigation mode?
     */
    function GetNavigation()
    {
        return( $this->fNavigation );
    }

    /**
     * Set type to menu
     */
    function SetMenu( $fValue = null )
    {
        if ( $fValue === null )
            $fValue = true;

        $this->fNavigation = !$fValue;
    }

    /**
     * Is current mode menu mode?
     */
    function GetMenu()
    {
       return( !$this->fNavigation );
    }
}
